package oracle.fsgbu.obscfcm.services.report;

import java.io.IOException;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;

import org.slf4j.MDC;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.servlet.FilterRegistrationBean;
import org.springframework.stereotype.Component;

import oracle.fsgbu.plato.core.persistence.provider.PlatoHolder;

public class AdditonalLogbackDiagnosticContext extends FilterRegistrationBean {
	public AdditonalLogbackDiagnosticContext() {
		super(new MDCContextFilter());
		addUrlPatterns("/*");
		setOrder(Integer.MAX_VALUE);
	}

	@Component
	public static class MDCContextFilter implements Filter {

		@Autowired
		private ApplicationLoggingProperties loggingProperties;

		/**
		 * {@inheritDoc}
		 */
		@Override
		public void init(FilterConfig filterConfig) throws ServletException {
			// NOOP
		}

		@Override
		public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain)
				throws IOException, ServletException {
			MDC.put("env", loggingProperties.getEnvironment());
			MDC.put("tenant", PlatoHolder.getCurrentTenant());
			MDC.put("user", ((HttpServletRequest) servletRequest).getHeader("userId"));
			MDC.put("branch", ((HttpServletRequest) servletRequest).getHeader("branchCode"));
			filterChain.doFilter(servletRequest, servletResponse);
		}

		/**
		 * {@inheritDoc}
		 */
		@Override
		public void destroy() {
			// NOOP
		}
	}
}
