/*******************************************************************************
 * This source is part of the Oracle Banking Credit Facility Process Management Software Product. 
 * Copyright (c) 2018 , 2018 , Oracle and/or its affiliates.  All rights reserved.
 * 
 * No part of this work may be reproduced, stored in a retrieval system, adopted or transmitted in any form or by any means,
 * electronic, mechanical, photographic, graphic, optic recording or otherwise, 
 * translated in any language or computer language, without the prior written permission of Oracle and/or its affiliates.
 * 
 * Oracle Financial Services Software Limited.
 * Oracle Park, Off Western Express Highway,
 * Goregaon (East), 
 * Mumbai - 400 063, India.
 ******************************************************************************/
package oracle.fsgbu.obscfcm.services.report;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.web.WebApplicationInitializer;
import oracle.fsgbu.plato.logger.PlatoLogger;

@SpringBootApplication
@EnableEurekaClient
@ComponentScan({"oracle.fsgbu.obscfcm.services.report", "oracle.fsgbu.plato.common", "oracle.fsgbu.gcs", "oracle.fsgbu.gus",
    "oracle.fsgbu.plato.core", "oracle.fsgbu.plato.flyway", "oracle.fsgbu.sms","oracle.fsgbu.plato.logger", "oracle.fsgbu.plato.subscriber", "oracle.fsgbu.plato.eventhub","oracle.fsgbu.obscfcm.alertsgenerator",
        "oracle.fsgbu.plato.cache","oracle.fsgbu.ob.adapter", "oracle.fsgbu.obscf.alertsplaceholder","oracle.fsgbu.obscfcm.alertsplaceholder","oracle.cashflow.scfcm.adapter","oracle.fsgbu.plato.coherence",
      "oracle.fsgbu.cmc","oracle.fsgbu.scfcm.utility","oracle.fsgbu.obscf.master.maintenance","oracle.fsgbu.obscfcm"})
//@EnableFeignClients({ "oracle.fsgbu.sms" })
public class Application extends SpringBootServletInitializer implements WebApplicationInitializer {

  private static final PlatoLogger LOG = new PlatoLogger(Application.class);

  public static void main(String[] args) {
    LOG.info("Starting up the demo application");
    SpringApplication.run(Application.class, args);
  }

  @Override
  protected SpringApplicationBuilder configure(SpringApplicationBuilder builder) {
    return builder.sources(Application.class);
  }
}
