package oracle.fsgbu.obscfcm.services.report.client;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import oracle.fsgbu.obscfcm.services.report.constants.ReportConstants;
import oracle.fsgbu.obscfcm.services.report.util.ReportingUtil;
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipMasterDTO;
import oracle.fsgbu.plato.logger.PlatoLogger;

@Service
public class RelationshipEventServiceClientImpl implements RelationshipEventServiceClient {

	private static final PlatoLogger LOGGER = new PlatoLogger(RelationshipEventServiceClientImpl.class);

	@Value("${obscfcm.report.service.appId}")
	private String appId;
	
	@Value("${eureka.protocol:http}")
	private String protocol;
	
	@Autowired
	private RestTemplate restTemplate;

	@Override
	public Boolean saveRelationshipData(ObcmTmRelationshipMasterDTO relationshipDto, String userId, String branchCode) {
		ResponseEntity<Boolean> response = null;

		try {
			String formUrl = protocol + ReportConstants.SAVE_RELATIONSHIP_SERVICE;
			HttpEntity<ObcmTmRelationshipMasterDTO> entity = new HttpEntity<>(relationshipDto, ReportingUtil.buildHeadersForEventService(appId, userId, branchCode));
			response = restTemplate.exchange(formUrl, HttpMethod.POST, entity, Boolean.class);
		} catch (Exception e) {
			LOGGER.error("Error in RelationshipData {}", e);
		}

		if (response != null) {
			return response.getBody();
		}

		return null;
	}

}