package oracle.fsgbu.obscfcm.services.report.config;

import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

import oracle.fsgbu.obscfcm.services.report.constants.ReportConstants;
import oracle.fsgbu.plato.logger.PlatoLogger;

@Service
public class ReportConfigDbUtil {
	private static final PlatoLogger LOGGER = new PlatoLogger(ReportConfigDbUtil.class);

	public static DatabaseConfiguration getDatabaseConfiguration(final ApplicationContext context) {
		DatabaseConfiguration dbConfig = null;
		if (ReportConstants.DEPLOY_ENVIORNMENT_CLOUD
				.equalsIgnoreCase(System.getProperty(ReportConstants.DEPLOY_ENVIORNMENT))) {
			dbConfig = context.getBean(MultiTenantDatabaseConfig.class);
		} else {
			dbConfig = context.getBean(ObscfcmReportDatabaseConfig.class);
			LOGGER.info("getDatabaseConfiguration::ObscfcmReportDatabaseConfig accessing.....");
		}
		return dbConfig;
	}
}
