package oracle.fsgbu.obscfcm.services.report.kafka;

import org.springframework.cloud.stream.schema.avro.AvroSchemaMessageConverter;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.util.MimeType;

@Configuration
public class AvroNoSchemaRegistryConfiguration {

	  public static final String BEAN_NAME_AVRO_INVOICE_MESSAGE_CONVERTER = "avroInvoiceMessageConverter";
	  public static final String BEAN_NAME_AVRO_RELATIONSHIP_MESSAGE_CONVERTER = "avroRelationshipMessageConverter";
	  public static final String BEAN_NAME_AVRO_EXP_DRCR_RECON_MESSAGE_CONVERTER = "avroExpDrCrReconMessageConverter";
	  public static final String BEAN_NAME_AVRO_INV_PMT_RECON_MESSAGE_CONVERTER = "avroInvPmtMessageConverter";
	  public static final String BEAN_NAME_AVRO_FIN_PMT_RECON_MESSAGE_CONVERTER = "avroFinPmtMessageConverter";
	  public static final String BEAN_NAME_AVRO_PMT_ALLOC_MESSAGE_CONVERTER = "avroPmtAllocMessageConverter";
	  public static final String BEAN_NAME_AVRO_PAYMENT_MESSAGE_CONVERTER = "avroPaymentMessageConverter";
	  public static final String BEAN_NAME_AVRO_INV_CN_RECON_MESSAGE_CONVERTER = "avroInvCnReconMessageConverter";
	  public static final String BEAN_NAME_AVRO_INVOICE_TW_MESSAGE_CONVERTER = "avroInvoiceTwMessageConverter";
	  public static final String BEAN_NAME_AVRO_FILEUPLOAD_MESSAGE_CONVERTER = "avroFileUploadMessageConverter";
	  public static final String BEAN_NAME_AVRO_CREDIT_NOTE_MESSAGE_CONVERTER = "avroCreditNoteMessageConverter";
	  public static final String BEAN_NAME_AVRO_ACCOUNT_ROLE_SCHEMA_MESSAGE_CONVERTER = "avroSchemaAccountRoleMessageConverter";
	  public static final String BEAN_NAME_AVRO_ACCOUNT_ROLE_TW_SCHEMA_MESSAGE_CONVERTER = "avroSchemaAccountRoleTWMessageConverter";
	  public static final String BEAN_NAME_AVRO_ACCOUNT_ENTRY_UPDATED_SCHEMA_MESSAGE_CONVERTER = "avroSchemaAccountEntryMessageConverter";
	  public static final String BEAN_NAME_AVRO_ACCOUNT_ENTRY_TW_UPDATED_SCHEMA_MESSAGE_CONVERTER = "avroSchemaAccountEntryTWMessageConverter";
	  public static final String BEAN_NAME_AVRO_ACCOUNT_ENTRY_CODE_UPDATED_SCHEMA_MESSAGE_CONVERTER = "avroSchemaAccountEntryCodeMessageConverter";
	  public static final String BEAN_NAME_AVRO_ACCOUNT_ENTRY_CODE_TW_UPDATED_SCHEMA_MESSAGE_CONVERTER = "avroSchemaAccountEntryCodeTWMessageConverter";
	  public static final String BEAN_NAME_AVRO_INTERNAL_ACCOUNT_MAP_UPDATED_MESSAGE_CONVERTER = "avroSchemaInternalAccountMapMessageConverter";
	  public static final String BEAN_NAME_AVRO_INTERNAL_ACCOUNT_MAP_TW_UPDATED_SCHEMA_MESSAGE_CONVERTER = "avroSchemaInternalAccountMapTWMessageConverter";
	  public static final String BEAN_NAME_AVRO_EXTERNAL_ACCOUNT_MAP_UPDATED_MESSAGE_CONVERTER = "avroSchemaExternalAccountMapMessageConverter";
	  public static final String BEAN_NAME_AVRO_EXTERNAL_ACCOUNT_MAP_TW_UPDATED_MESSAGE_CONVERTER = "avroSchemaExternalAccountMapTWMessageConverter";
	  public static final String BEAN_NAME_AVRO_OB_CHARGES_SCHEMA_MESSAGE_CONVERTER = "avroSchemaObChargesMessageConverter";
	  public static final String BEAN_NAME_AVRO_OB_FINANCE_SCHEMA_MESSAGE_CONVERTER = "avroSchemaObFinanceMessageConverter";
	  public static final String BEAN_NAME_AVRO_OB_INVOICE_SCHEMA_MESSAGE_CONVERTER = "avroSchemaObInvoiceDetailsMessageConverter";
	  public static final String BEAN_NAME_AVRO_CREATE_EXTERNAL_DELINQSTATUS_MESSAGE_CONVERTER = "avroCreateExternalDelinqStatusMessageConverter";
	  public static final String BEAN_NAME_AVRO_CREATE_CUSTOMER_DELINQSTATUS_MESSAGE_CONVERTER = "avroCreateCustomerDelinqStatusMessageConverter";
	  public static final String BEAN_NAME_AVRO_INVOICE_TM_MESSAGE_CONVERTER = "avroInvoiceTmMessageConverter";

      public static final String BEAN_NAME_AVRO_INVOICE_CASHFLOW_MESSAGE_CONVERTER = "avroInvoiceCashflowTmMessageConverter";
      
      public static final String BEAN_NAME_AVRO_CREATE_CASHFLOW_FROM_RECON_MESSAGE_CONVERTER = "avroCreateCashflowFromReconMessageConverter";
      
	  @Bean(name = BEAN_NAME_AVRO_INVOICE_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroInvoiceMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_RELATIONSHIP_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroRelationshipMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_EXP_DRCR_RECON_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroExpDrCrReconMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_INV_CN_RECON_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroInvCnReconMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_INV_PMT_RECON_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroInvPmtReconMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_FIN_PMT_RECON_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroFinPmtReconMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_PMT_ALLOC_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroPmtAllocMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_PAYMENT_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroPaymentMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }

	  @Bean(name = BEAN_NAME_AVRO_INVOICE_TW_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroInvoiceTwMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }
	  @Bean(name = BEAN_NAME_AVRO_FILEUPLOAD_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroFileUploadMessageConverter() {
	        AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	        return converter;
	  }
	  @Bean(name = BEAN_NAME_AVRO_CREDIT_NOTE_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroCreditNoteMessageConverter() {
	 	AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	 	return converter;
	  }
	
	  @Bean(name = BEAN_NAME_AVRO_ACCOUNT_ROLE_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaAccountRoleMessageConverter() {
		return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_ACCOUNT_ROLE_TW_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaAccountRoleTWMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_ACCOUNT_ENTRY_UPDATED_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaAccountEntryMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_ACCOUNT_ENTRY_TW_UPDATED_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaAccountEntryTWMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_ACCOUNT_ENTRY_CODE_UPDATED_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaAccountEntryCodeMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_ACCOUNT_ENTRY_CODE_TW_UPDATED_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaAccountEntryCodeTWMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_INTERNAL_ACCOUNT_MAP_UPDATED_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaInternalAccountMapMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_INTERNAL_ACCOUNT_MAP_TW_UPDATED_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaInternalAccountMapTWMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_EXTERNAL_ACCOUNT_MAP_UPDATED_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaExternalAccountMapMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_EXTERNAL_ACCOUNT_MAP_TW_UPDATED_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaExternalAccountMapTWMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_OB_CHARGES_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaOBChargesMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_OB_FINANCE_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaOBFinanceDetailsMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_OB_INVOICE_SCHEMA_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroSchemaOBInvoiceDetailsMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_CREATE_EXTERNAL_DELINQSTATUS_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroCreateExternalDelinqStatusMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_CREATE_CUSTOMER_DELINQSTATUS_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroCreateCustomerDelinqStatusMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	  }
	  
	  @Bean(name = BEAN_NAME_AVRO_INVOICE_TM_MESSAGE_CONVERTER)
	  public AvroSchemaMessageConverter avroInvoiceTmMessageConverter() {
		  AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		  return converter;
	  }

	@Bean(name = BEAN_NAME_AVRO_INVOICE_CASHFLOW_MESSAGE_CONVERTER)
	public AvroSchemaMessageConverter avroInvoiceCashflowTmMessageConverter() {
		AvroSchemaMessageConverter converter = new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
		return converter;
	}
	
	@Bean(name = BEAN_NAME_AVRO_CREATE_CASHFLOW_FROM_RECON_MESSAGE_CONVERTER)
	public AvroSchemaMessageConverter avroCreateCashflowFromReconMessageConverter() {
		  return new AvroSchemaMessageConverter(MimeType.valueOf("avro/bytes"));
	}
}
