package oracle.fsgbu.obscfcm.services.report.kafka;

import org.springframework.cloud.stream.annotation.Input;
import org.springframework.messaging.SubscribableChannel;

import oracle.fsgbu.obscfcm.services.report.constants.ReportConstants;

/**
 * Interface PlatoMessageChannels for Spring Cloud Stream.
 *
 */
public interface PlatoMessageChannels {

	@Input(ReportConstants.INVOICE_UPDATED)
	SubscribableChannel platoGetInvoicesUpdated();
	
	@Input(ReportConstants.RELATIONSHIP_MASTER_CHNL)
	SubscribableChannel platoGetRelationshipUpdated();
	
	@Input(ReportConstants.RELATIONSHIP_TW_MASTER_CHNL)
	SubscribableChannel platoGetRelationshipTwUpdated();
	
	@Input(ReportConstants.EXP_DRCR_PMT_RECON_UPDATED)
	SubscribableChannel platoGetExpDrCrPmtReconUpdated();
	
	@Input(ReportConstants.INV_PMT_RECON_UPDATED)
	SubscribableChannel platoGetInvPmtReconUpdated();
	
	@Input(ReportConstants.FIN_PMT_RECON_UPDATED)
	SubscribableChannel platoGetFinPmtReconUpdated();
	
	@Input(ReportConstants.PMT_ALLOC_UPDATED)
	SubscribableChannel platoGetPmtAllocTxnUpdated();
	
	@Input(ReportConstants.PAYMENT_UPDATED)
	SubscribableChannel platoGetPaymentUpdated();
	
	
	@Input(ReportConstants.PAYMENT_TW_UPDATED)
	SubscribableChannel platoGetPaymentTwUpdated();
	
	@Input (ReportConstants.INV_CN_RECON_UPDATED)
	SubscribableChannel platoGetInvCnReconUpdated();
	
	@Input (ReportConstants.INVOICE_TW_UPDATED_EVENT)
	SubscribableChannel platoGetInvoiceTwUpdated();
	
	@Input (ReportConstants.FILE_UPDATED)
	SubscribableChannel platoGetFileUpdated();

	@Input (ReportConstants.CREDIT_NOTES_UPDATED)
	SubscribableChannel platoGetCreditNoteUpdated();
	
	@Input (ReportConstants.RECON_TW_UPDATED)
	SubscribableChannel platoReconTwUpdated();
	
	@Input(ReportConstants.ACCOUNT_ROLE_UPDATED)
	SubscribableChannel platoPublishAccountRoleUpdated();
	
	@Input(ReportConstants.ACCOUNT_ROLE_TW_UPDATED)
	SubscribableChannel platoPublishAccountRoleTWUpdated();
	
	@Input(ReportConstants.ACCOUNT_ENTRY_UPDATED)
	SubscribableChannel platoPublishAccountEntryUpdated();
	
	@Input(ReportConstants.ACCOUNT_ENTRY_TW_UPDATED)
	SubscribableChannel platoPublishAccountEntryTWUpdated();
	
	@Input(ReportConstants.ACCOUNT_ENTRY_CODE_UPDATED)
	SubscribableChannel platoPublishAccountEntryCodeUpdated();
	
	@Input(ReportConstants.ACCOUNT_ENTRY_CODE_TW_UPDATED)
	SubscribableChannel platoPublishAccountEntryCodeTWUpdated();
	
	@Input(ReportConstants.INTERNAL_ACCOUNT_MAP_UPDATED)
	SubscribableChannel platoPublishInternalAccountMapUpdated();
	
	@Input(ReportConstants.INTERNAL_ACCOUNT_MAP_TW_UPDATED)
	SubscribableChannel platoPublishInternalAccountMapTWUpdated();
	
	@Input(ReportConstants.EXTERNAL_ACCOUNT_MAP_TW_UPDATED)
	SubscribableChannel platoPublishExternalAccountMapTWUpdated();
	
	@Input(ReportConstants.EXTERNAL_ACCOUNT_MAP_UPDATED)
	SubscribableChannel platoPublishExternalAccountMapUpdated();
	
	@Input(ReportConstants.AUTO_DEBIT_INSTRUMENT_UPDATED)
    SubscribableChannel  platoPublishAutoDebitInstrumentUpdated();
	
	
	@Input(ReportConstants.OB_CHARGES_UPDATED)
	SubscribableChannel platoPublishObChargesUpdated();
	
	@Input(ReportConstants.OB_FINANCE_UPDATED)
	SubscribableChannel platoPublishObFinanceTWUpdated();
	
	@Input(ReportConstants.OB_INVOICE_DETAILS_UPDATED)
	SubscribableChannel platoPublishObInvoiceDetailsUpdated();
	
	@Input(ReportConstants.CREATE_EXTERNAL_DELINQ_STATUS)
	SubscribableChannel platoPublishCreateExternalDelinqStatus();
	
	@Input(ReportConstants.CREATE_CUSTOMER_DELINQ_STATUS)
	SubscribableChannel platoPublishCreateCustomerDelinqStatus();
	
	@Input (ReportConstants.INVOICE_TM_UPDATED_EVENT)
	SubscribableChannel platoGetInvoiceTmUpdated();
	
	@Input(ReportConstants.CREATE_CASHFLOW_FROM_RECON)
	SubscribableChannel platoPublishCreateCashflowFromRecon();

	@Input(ReportConstants.INVOICE_CASHFLOW)
	SubscribableChannel platoInvoiceCashflow();

}
