package oracle.fsgbu.obscfcm.services.report.model;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.validation.annotation.Validated;
import javax.validation.Valid;

/**
 * CmcCurrency Utility Dto Wrapper
 */
@ApiModel(description = "CmcCurrency Utility Dto Wrapper")
@Validated

public class CurrencyRateCalculatorDtoWrapper   {
  @JsonProperty("messages")
  private oracle.fsgbu.gus.response.dto.ResponseDto messages = null;

  @JsonProperty("data")
  private CurrencyUtilityDto data = null;

  public CurrencyRateCalculatorDtoWrapper messages(oracle.fsgbu.gus.response.dto.ResponseDto messages) {
    this.messages = messages;
    return this;
  }

  /**
   * Get messages
   * @return messages
  **/
  @ApiModelProperty(value = "")

  @Valid

  public oracle.fsgbu.gus.response.dto.ResponseDto getMessages() {
    return messages;
  }

  public void setMessages(oracle.fsgbu.gus.response.dto.ResponseDto messages) {
    this.messages = messages;
  }

  public CurrencyRateCalculatorDtoWrapper data(CurrencyUtilityDto data) {
    this.data = data;
    return this;
  }

  /**
   * Get data
   * @return data
  **/
  @ApiModelProperty(value = "")

  @Valid

  public CurrencyUtilityDto getData() {
    return data;
  }

  public void setData(CurrencyUtilityDto data) {
    this.data = data;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CurrencyRateCalculatorDtoWrapper currencyRateCalculatorDtoWrapper = (CurrencyRateCalculatorDtoWrapper) o;
    return Objects.equals(this.messages, currencyRateCalculatorDtoWrapper.messages) &&
        Objects.equals(this.data, currencyRateCalculatorDtoWrapper.data);
  }

  @Override
  public int hashCode() {
    return Objects.hash(messages, data);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CurrencyRateCalculatorDtoWrapper {\n");
    
    sb.append("    messages: ").append(toIndentedString(messages)).append("\n");
    sb.append("    data: ").append(toIndentedString(data)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

