package oracle.fsgbu.obscfcm.services.report.service;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import javax.persistence.EntityManager;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import oracle.fsgbu.obscfcm.services.report.domain.entity.ScftmCustomerDelinqStatus;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScftmCustomerDelinqStatusHis;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScftmExtCustomerDelinqStatus;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScftmExtCustomerDelinqStatusHis;
import oracle.fsgbu.obscfcm.services.report.persistence.ScftmCustomerDelinqStatusHisRepository;
import oracle.fsgbu.obscfcm.services.report.persistence.ScftmCustomerDelinqStatusRepository;
import oracle.fsgbu.obscfcm.services.report.persistence.ScftmExtCustomerDelinqStatusHisRepository;
import oracle.fsgbu.obscfcm.services.report.persistence.ScftmExtCustomerDelinqStatusRepository;
import oracle.fsgbu.obscfcm.services.scfcm.dto.ScftmCustomerDelinqStatusDTO;
import oracle.fsgbu.obscfcm.services.scfcm.dto.ScftmExtCustomerDelinqStatusHisDTO;
import oracle.fsgbu.plato.common.util.generator.SnowflakeGenerator;
import oracle.fsgbu.plato.core.domain.PlatoEntityManagerType;
import oracle.fsgbu.plato.core.persistence.provider.PlatoEntityManagerConfig;
import oracle.fsgbu.plato.logger.PlatoLogger;

@Service
public class CustomerListenerServiceImpl implements CustomerListenerService {

	private static final PlatoLogger LOGGER = new PlatoLogger(CustomerListenerServiceImpl.class);
	private static final String SIMPLE_DATE_FORMAT = "yyyy-MM-dd";

	@Autowired
	private ScftmExtCustomerDelinqStatusRepository scftmExtCustomerDelinqStatusRepository;

	@Autowired
	private ScftmExtCustomerDelinqStatusHisRepository scftmExtCustomerDelinqStatusHisRepository;
	
	@Autowired
	private ScftmCustomerDelinqStatusRepository scftmCustomerDelinqStatusRepository;

	@Autowired
	private ScftmCustomerDelinqStatusHisRepository scftmCustomerDelinqStatusHisRepository;
	
	@Autowired
	@PlatoEntityManagerConfig(PlatoEntityManagerType.APPLICATION)
	private EntityManager entityManager;

	@Autowired
	public CustomerListenerServiceImpl() {
	}

	private Date dateConverter(String inputDate) throws ParseException {

		DateFormat dateFormat = new SimpleDateFormat(SIMPLE_DATE_FORMAT);
		if (inputDate == null) {
			return null;
		}
		return dateFormat.parse(inputDate);
	}

	@Override
	@Transactional("PLATO_TX_MANAGER")
	public Boolean saveExtCustomerDelinqStatusData(String extCustomerDelinqStatusId,
			ScftmExtCustomerDelinqStatusHisDTO scftmExtCustomerDelinqStatusHisDTO, String userId, String branchCode) {
		LOGGER.info("Inside saveExtCustomerDelinqStatusData method...");
		/*try {
			ScftmExtCustomerDelinqStatusHis scftmExtCustomerDelinqStatusHis= new ScftmExtCustomerDelinqStatusHis();
//			String[] queryParams = { "customerId" };
//			String[] queryValues = { scftmExtCustomerDelinqStatusHisDTO.getCustomerId() };
//			List<ScftmExtCustomerDelinqStatusHis> scftmExtCustomerDelinqStatusHisList =  scftmExtCustomerDelinqStatusHisRepository.executeNamedQueryByCondition(queryParams, queryValues, "ScftmExtCustomerDelinqStatusHis.findByPk");
//			if (CollectionUtils.isNotEmpty(scftmExtCustomerDelinqStatusHisList)) {
//				scftmExtCustomerDelinqStatusHis = scftmExtCustomerDelinqStatusHisList.get(0);
//			} else {
//				scftmExtCustomerDelinqStatusHis = new ScftmExtCustomerDelinqStatusHis();
//			}
			BeanUtils.copyProperties(scftmExtCustomerDelinqStatusHisDTO, scftmExtCustomerDelinqStatusHis);
			scftmExtCustomerDelinqStatusHis.setId(scftmExtCustomerDelinqStatusHisDTO.getId());
			scftmExtCustomerDelinqStatusHis.setInputDate(scftmExtCustomerDelinqStatusHisDTO.getInputDate());
	        scftmExtCustomerDelinqStatusHis.setStatusDate(scftmExtCustomerDelinqStatusHis.getStatusDate());
	        LOGGER.info("extCustomerDelinqStatusId : " +extCustomerDelinqStatusId);
			scftmExtCustomerDelinqStatusRepository.deleteByKey(extCustomerDelinqStatusId);
			entityManager.flush();
			scftmExtCustomerDelinqStatusHisRepository.save(scftmExtCustomerDelinqStatusHis);
			LOGGER.info("Exiting saveExtCustomerDelinqStatusData method...");
			return true;
		}
		 catch(Exception e) {
			LOGGER.error("Error while commiting saveExtCustomerDelinqStatusData Data:: {}", e.getMessage(), e);
			return false;
			}*/
		ScftmExtCustomerDelinqStatusHis scftmExtCustomerDelinqStatusHis=null;
		try {
			String[] queryParams = { "customerId" };
			String[] queryValues = { extCustomerDelinqStatusId };
			List<ScftmExtCustomerDelinqStatus> scftmExtCustomerDelinqStatusToHist =  scftmExtCustomerDelinqStatusRepository.executeNamedQueryByCondition(queryParams, queryValues, "ScftmExtCustomerDelinqStatus.findByPk");
			
			if(null!=scftmExtCustomerDelinqStatusToHist){
				
			for(ScftmExtCustomerDelinqStatus scftmExtCustomerDelinqStatus :scftmExtCustomerDelinqStatusToHist ){
				scftmExtCustomerDelinqStatusHis = new ScftmExtCustomerDelinqStatusHis();
			BeanUtils.copyProperties(scftmExtCustomerDelinqStatus, scftmExtCustomerDelinqStatusHis);
			scftmExtCustomerDelinqStatusHis.setId(Long.toString(SnowflakeGenerator.getInstance().nextId()));
			scftmExtCustomerDelinqStatusHis.setInputDate(scftmExtCustomerDelinqStatusHisDTO.getInputDate());
             scftmExtCustomerDelinqStatusHis.setStatusDate(scftmExtCustomerDelinqStatusHisDTO.getStatusDate());
			scftmExtCustomerDelinqStatusRepository.deleteByKey(scftmExtCustomerDelinqStatus.getId());
			entityManager.flush();
			scftmExtCustomerDelinqStatusHisRepository.save(scftmExtCustomerDelinqStatusHis);
			
			}
			}
			return true;			
		} catch (Exception e) {
			LOGGER.error("Error while commiting saveExtCustomerDelinqStatusData Data:: {}", e.getMessage(), e);
			return false;
		}
	}

	@Override
	@Transactional("PLATO_TX_MANAGER")
	public Boolean saveCustomerDelinqStatusData(ScftmCustomerDelinqStatusDTO scftmCustomerDelinqStatusDTO, String userId, String branchCode) {
		LOGGER.info("Inside saveCustomerDelinqStatusData method...");
		/*try {
			ScftmCustomerDelinqStatusHis scftmCustomerDelinqStatusHis= null;
			String[] queryParamsStatusHis = { "customerId" };
			String[] queryValuesStatusHis = { scftmCustomerDelinqStatusHisDTO.getCustomerId() };
			List<ScftmCustomerDelinqStatusHis> scftmCustomerDelinqStatusHisList =  scftmCustomerDelinqStatusHisRepository.executeNamedQueryByCondition(queryParamsStatusHis, queryValuesStatusHis, "ScftmExtCustomerDelinqStatusHis.findByPk");
			if (CollectionUtils.isNotEmpty(scftmCustomerDelinqStatusHisList)) {
				scftmCustomerDelinqStatusHis = scftmCustomerDelinqStatusHisList.get(0);
			} else {
				scftmCustomerDelinqStatusHis = new ScftmCustomerDelinqStatusHis();
			}
			BeanUtils.copyProperties(scftmCustomerDelinqStatusHisDTO, scftmCustomerDelinqStatusHis);
			scftmCustomerDelinqStatusHis.setId(scftmCustomerDelinqStatusHisDTO.getId());
			scftmCustomerDelinqStatusHis.setInputDate(scftmCustomerDelinqStatusHisDTO.getInputDate());
			scftmCustomerDelinqStatusHis.setStatusDate(scftmCustomerDelinqStatusHis.getStatusDate());
			LOGGER.info("scftmCustomerDelinqStatusDTO.getCustomerId() : " +scftmCustomerDelinqStatusDTO.getCustomerId());
			scftmCustomerDelinqStatusRepository.deleteByKey(scftmCustomerDelinqStatusDTO.getCustomerId());
			entityManager.flush();
			scftmCustomerDelinqStatusHisRepository.save(scftmCustomerDelinqStatusHis);
			
			ScftmCustomerDelinqStatus scftmCustomerDelinqStatus = new ScftmCustomerDelinqStatus();
//			String[] queryParamsStatus = { "customerId" };
//			String[] queryValuesStatus = { scftmCustomerDelinqStatusHisDTO.getCustomerId() };
//			List<ScftmCustomerDelinqStatus> scftmCustomerDelinqStatusList =  scftmCustomerDelinqStatusRepository.executeNamedQueryByCondition(queryParamsStatus, queryValuesStatus, "ScftmExtCustomerDelinqStatus.findByPk");
//			if (CollectionUtils.isNotEmpty(scftmCustomerDelinqStatusList)) {
//				scftmCustomerDelinqStatus = scftmCustomerDelinqStatusList.get(0);
//			} else {
//				scftmCustomerDelinqStatus = new ScftmCustomerDelinqStatus();
//			}
			BeanUtils.copyProperties(scftmCustomerDelinqStatusDTO, scftmCustomerDelinqStatus);
			scftmCustomerDelinqStatus.setStatusDate(scftmCustomerDelinqStatus.getStatusDate());
			scftmCustomerDelinqStatusRepository.save(scftmCustomerDelinqStatus);
			LOGGER.info("Exiting saveCustomerDelinqStatusData method...");
			return true;
		}
		 catch(Exception e) {
			LOGGER.error("Error while commiting saveCustomerDelinqStatusData Data:: {}", e.getMessage(), e);
			return false;
			}*/
		try {
		ScftmCustomerDelinqStatusHis scftmCustomerDelinqStatusHis = null;
		ScftmCustomerDelinqStatus scftmCustomerDelinqStatus = null;
		ScftmCustomerDelinqStatus scftmCustomerDelinqStatusToHist = scftmCustomerDelinqStatusRepository
				.find(scftmCustomerDelinqStatusDTO.getCustomerId());
		if(null!=scftmCustomerDelinqStatusToHist){
		scftmCustomerDelinqStatusHis = new ScftmCustomerDelinqStatusHis();
		
		BeanUtils.copyProperties(scftmCustomerDelinqStatusToHist, scftmCustomerDelinqStatusHis);
		Date currentDate = new Date();
		scftmCustomerDelinqStatusHis.setInputDate(currentDate);
		scftmCustomerDelinqStatusHis.setStatusDate(scftmCustomerDelinqStatusDTO.getStatusDate());
		scftmCustomerDelinqStatusRepository.deleteByKey(scftmCustomerDelinqStatusDTO.getCustomerId());
		entityManager.flush();
		scftmCustomerDelinqStatusHisRepository.save(scftmCustomerDelinqStatusHis);
		}
		scftmCustomerDelinqStatus = new ScftmCustomerDelinqStatus();
		BeanUtils.copyProperties(scftmCustomerDelinqStatusDTO, scftmCustomerDelinqStatus);
		scftmCustomerDelinqStatusRepository.save(scftmCustomerDelinqStatus);
		return true;
		}
		 catch(Exception e) {
			LOGGER.error("Error while commiting saveCustomerDelinqStatusData Data:: {}", e.getMessage(), e);
			return false;
			}
	}

}
