package oracle.fsgbu.obscfcm.services.report.util;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.BeanUtils;

import oracle.fsgbu.accountMaintenance.api.model.ScfTmAccEntryCodeDetailsDTO;
import oracle.fsgbu.accountMaintenance.api.model.ScfTmAccEntryCodeMasterDTO;
import oracle.fsgbu.accountMaintenance.api.model.ScfTmAccEntryDetailsDTO;
import oracle.fsgbu.accountMaintenance.api.model.ScfTmAccEntryMasterDTO;
import oracle.fsgbu.accountMaintenance.api.model.ScfTmIntAccMapDetailsDTO;
import oracle.fsgbu.accountMaintenance.api.model.ScfTmIntAccMapMasterDTO;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmAccEntryCodeDetails;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmAccEntryCodeDetailsWork;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmAccEntryCodeMaster;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmAccEntryCodeMasterWork;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmAccEntryDetails;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmAccEntryDetailsWork;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmAccEntryMaster;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmAccEntryMasterWork;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmIntAccMapDetails;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmIntAccMapDetailsWork;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmIntAccMapMaster;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTmIntAccMapMasterWork;


public class AccountingModelAssembler {
	private static final String MAKER_DT_STAMP = "makerDateStamp";
	private static final String CHECKER_DT_STAMP = "checkerDtStamp";
	private static final String SIMPLE_DATE_FORMAT = "yyyy-MM-dd";
	public static void convertAccEntryTMModelToEntity(ScfcmTmAccEntryMaster scfcmTmAccEntryMaster, ScfTmAccEntryMasterDTO scfTmAccEntryMasterDTO) {
		String[] ignoreFields = { MAKER_DT_STAMP, CHECKER_DT_STAMP };
		BeanUtils.copyProperties(scfTmAccEntryMasterDTO, scfcmTmAccEntryMaster, ignoreFields);
		if (scfTmAccEntryMasterDTO.getScfTmAccEntryDetailsDTO()!= null) {
			scfcmTmAccEntryMaster.setScfcmTmAccEntryDetailsList(
					convertAccEntryTMVOToEntityList(scfTmAccEntryMasterDTO.getScfTmAccEntryDetailsDTO()));
        }
		scfcmTmAccEntryMaster.setModNo(scfTmAccEntryMasterDTO.getModNo());
		scfcmTmAccEntryMaster.setId(scfTmAccEntryMasterDTO.getId());
		scfcmTmAccEntryMaster.setMakerDateStamp(ReportingUtil.convertStrToDate(scfTmAccEntryMasterDTO.getMakerDateStamp()));
		scfcmTmAccEntryMaster.setCheckerDateStamp(ReportingUtil.convertStrToDate(scfTmAccEntryMasterDTO.getCheckerDateStamp()));
	}

	private static List<ScfcmTmAccEntryDetails> convertAccEntryTMVOToEntityList(List<ScfTmAccEntryDetailsDTO> scfTmAccEntryDetailsDTO) {
		List<ScfcmTmAccEntryDetails> scfcmTmAccEntryDetailsList = new ArrayList<>();
		scfTmAccEntryDetailsDTO.forEach(limitNode -> scfcmTmAccEntryDetailsList.add(convertAccEntryDetailsTMVOToEntity(limitNode)));
        return scfcmTmAccEntryDetailsList;
    }
	
	private static ScfcmTmAccEntryDetails convertAccEntryDetailsTMVOToEntity(ScfTmAccEntryDetailsDTO scfTmAccEntryDetailsDTO) {
		ScfcmTmAccEntryDetails scfcmTmAccEntryDetails = new ScfcmTmAccEntryDetails();
        if (scfTmAccEntryDetailsDTO != null) {
            BeanUtils.copyProperties(scfTmAccEntryDetailsDTO, scfcmTmAccEntryDetails);
            scfcmTmAccEntryDetails.setId(scfTmAccEntryDetailsDTO.getId());
        }
        
        return scfcmTmAccEntryDetails;
    }
	
	
	public static void convertAccEntryTWModelToEntity(ScfcmTmAccEntryMasterWork scfcmTmAccEntryMasterWork, ScfTmAccEntryMasterDTO scfTmAccEntryMasterDTO) {
		String[] ignoreFields = { MAKER_DT_STAMP, CHECKER_DT_STAMP };
		BeanUtils.copyProperties(scfTmAccEntryMasterDTO, scfcmTmAccEntryMasterWork, ignoreFields);
		if (scfTmAccEntryMasterDTO.getScfTmAccEntryDetailsDTO()!= null) {
			scfcmTmAccEntryMasterWork.setScfcmTmAccEntryDetailsWorkList(
					convertAccEntryTWVOToEntityList(scfTmAccEntryMasterDTO.getScfTmAccEntryDetailsDTO(), scfTmAccEntryMasterDTO.getModNo()));
        }
		scfcmTmAccEntryMasterWork.setModNo(scfTmAccEntryMasterDTO.getModNo());
		scfcmTmAccEntryMasterWork.setId(scfTmAccEntryMasterDTO.getId());
		scfcmTmAccEntryMasterWork.setMakerDateStamp(ReportingUtil.convertStrToDate(scfTmAccEntryMasterDTO.getMakerDateStamp()));
		scfcmTmAccEntryMasterWork.setCheckerDateStamp(ReportingUtil.convertStrToDate(scfTmAccEntryMasterDTO.getCheckerDateStamp()));
	}

	private static List<ScfcmTmAccEntryDetailsWork> convertAccEntryTWVOToEntityList(List<ScfTmAccEntryDetailsDTO> scfTmAccEntryDetailsDTO, Integer modNo) {
		List<ScfcmTmAccEntryDetailsWork> scfcmTmAccEntryDetailsWorkList = new ArrayList<>();
		scfTmAccEntryDetailsDTO.forEach(accEntry -> scfcmTmAccEntryDetailsWorkList.add(convertAccEntryDetailsTWVOToEntity(accEntry, modNo)));
        return scfcmTmAccEntryDetailsWorkList;
    }
	
	private static ScfcmTmAccEntryDetailsWork convertAccEntryDetailsTWVOToEntity(ScfTmAccEntryDetailsDTO scfTmAccEntryDetailsDTO, Integer modNo) {
		ScfcmTmAccEntryDetailsWork scfcmTmAccEntryDetailsWork = new ScfcmTmAccEntryDetailsWork();
        if (scfTmAccEntryDetailsDTO != null) {
            BeanUtils.copyProperties(scfTmAccEntryDetailsDTO, scfcmTmAccEntryDetailsWork);
            scfcmTmAccEntryDetailsWork.setId(scfTmAccEntryDetailsDTO.getId());
            scfcmTmAccEntryDetailsWork.setModNo(modNo);
        }
        
        return scfcmTmAccEntryDetailsWork;
    }
	
	////////
	
	public static void convertAccEntryCodeTWModelToEntity(ScfcmTmAccEntryCodeMasterWork scfcmTmAccEntryCodeMasterWork, ScfTmAccEntryCodeMasterDTO scfTmAccEntryCodeMasterDTO) {
		String[] ignoreFields = { MAKER_DT_STAMP, CHECKER_DT_STAMP };
		BeanUtils.copyProperties(scfTmAccEntryCodeMasterDTO, scfcmTmAccEntryCodeMasterWork, ignoreFields);
		if (scfTmAccEntryCodeMasterDTO.getScfTmAccEntryCodeDetailsDTO()!= null) {
			scfcmTmAccEntryCodeMasterWork.setScfcmTmAccEntryCodeDetailsWorkList(
					convertAccEntryCodeTWVOToEntityList(scfTmAccEntryCodeMasterDTO.getScfTmAccEntryCodeDetailsDTO(), scfTmAccEntryCodeMasterDTO.getModNo()));
        }
		scfcmTmAccEntryCodeMasterWork.setModNo(scfTmAccEntryCodeMasterDTO.getModNo());
		scfcmTmAccEntryCodeMasterWork.setId(scfTmAccEntryCodeMasterDTO.getId());
		scfcmTmAccEntryCodeMasterWork.setMakerDateStamp(ReportingUtil.convertStrToDate(scfTmAccEntryCodeMasterDTO.getMakerDateStamp()));
		scfcmTmAccEntryCodeMasterWork.setCheckerDateStamp(ReportingUtil.convertStrToDate(scfTmAccEntryCodeMasterDTO.getCheckerDateStamp()));
	}

	private static List<ScfcmTmAccEntryCodeDetailsWork> convertAccEntryCodeTWVOToEntityList(List<ScfTmAccEntryCodeDetailsDTO> scfTmAccEntryCodeDetailsDTO, Integer modNo) {
		List<ScfcmTmAccEntryCodeDetailsWork> scfcmTmAccEntryCodeDetailsWorkList = new ArrayList<>();
		scfTmAccEntryCodeDetailsDTO.forEach(accEntry -> scfcmTmAccEntryCodeDetailsWorkList.add(convertAccEntryCodeDetailsTWVOToEntity(accEntry, modNo)));
        return scfcmTmAccEntryCodeDetailsWorkList;
    }
	
	private static ScfcmTmAccEntryCodeDetailsWork convertAccEntryCodeDetailsTWVOToEntity(ScfTmAccEntryCodeDetailsDTO scfTmAccEntryCodeDetailsDTO, Integer modNo) {
		ScfcmTmAccEntryCodeDetailsWork scfcmTmAccEntryCodeDetailsWork = new ScfcmTmAccEntryCodeDetailsWork();
        if (scfTmAccEntryCodeDetailsDTO != null) {
            BeanUtils.copyProperties(scfTmAccEntryCodeDetailsDTO, scfcmTmAccEntryCodeDetailsWork);
            scfcmTmAccEntryCodeDetailsWork.setId(scfTmAccEntryCodeDetailsDTO.getId());
            scfcmTmAccEntryCodeDetailsWork.setModNo(modNo);
        }
        
        return scfcmTmAccEntryCodeDetailsWork;
    }
	
	
	////////
	
	public static void convertAccEntryCodeTMModelToEntity(ScfcmTmAccEntryCodeMaster scfcmTmAccEntryCodeMaster, ScfTmAccEntryCodeMasterDTO scfTmAccEntryCodeMasterDTO) {
		String[] ignoreFields = { MAKER_DT_STAMP, CHECKER_DT_STAMP };
		BeanUtils.copyProperties(scfTmAccEntryCodeMasterDTO, scfcmTmAccEntryCodeMaster, ignoreFields);
		if (scfTmAccEntryCodeMasterDTO.getScfTmAccEntryCodeDetailsDTO()!= null) {
			scfcmTmAccEntryCodeMaster.setScfcmTmAccEntryCodeDetailsList(
					convertAccEntryCodeTMVOToEntityList(scfTmAccEntryCodeMasterDTO.getScfTmAccEntryCodeDetailsDTO()));
        }
		scfcmTmAccEntryCodeMaster.setModNo(scfTmAccEntryCodeMasterDTO.getModNo());
		scfcmTmAccEntryCodeMaster.setId(scfTmAccEntryCodeMasterDTO.getId());
		scfcmTmAccEntryCodeMaster.setMakerDateStamp(ReportingUtil.convertStrToDate(scfTmAccEntryCodeMasterDTO.getMakerDateStamp()));
		scfcmTmAccEntryCodeMaster.setCheckerDateStamp(ReportingUtil.convertStrToDate(scfTmAccEntryCodeMasterDTO.getCheckerDateStamp()));
	}

	private static List<ScfcmTmAccEntryCodeDetails> convertAccEntryCodeTMVOToEntityList(List<ScfTmAccEntryCodeDetailsDTO> scfTmAccEntryCodeDetailsDTO) {
		List<ScfcmTmAccEntryCodeDetails> scfcmTmAccEntryCodeDetailsList = new ArrayList<>();
		scfTmAccEntryCodeDetailsDTO.forEach(accEntryCode -> scfcmTmAccEntryCodeDetailsList.add(convertAccEntryCodeDetailsTMVOToEntity(accEntryCode)));
        return scfcmTmAccEntryCodeDetailsList;
    }
	
	private static ScfcmTmAccEntryCodeDetails convertAccEntryCodeDetailsTMVOToEntity(ScfTmAccEntryCodeDetailsDTO scfTmAccEntryCodeDetailsDTO) {
		ScfcmTmAccEntryCodeDetails scfcmTmAccEntryCodeDetails = new ScfcmTmAccEntryCodeDetails();
        if (scfTmAccEntryCodeDetailsDTO != null) {
            BeanUtils.copyProperties(scfTmAccEntryCodeDetailsDTO, scfcmTmAccEntryCodeDetails);
            scfcmTmAccEntryCodeDetails.setId(scfTmAccEntryCodeDetailsDTO.getId());
        }
        
        return scfcmTmAccEntryCodeDetails;
    }
	
	//////////
	
	public static void convertInternalAccountMapTMModelToEntity(ScfcmTmIntAccMapMaster scfcmTmIntAccMapMaster, ScfTmIntAccMapMasterDTO scfTmIntAccMapMasterDTO) {
		String[] ignoreFields = { MAKER_DT_STAMP, CHECKER_DT_STAMP };
		BeanUtils.copyProperties(scfTmIntAccMapMasterDTO, scfcmTmIntAccMapMaster, ignoreFields);
		if (scfTmIntAccMapMasterDTO.getScfTmIntAccMapDetailsDTO()!= null) {
			scfcmTmIntAccMapMaster.setScfcmTmIntAccMapDetailsList(
					convertInternalAccountMapTMVOToEntityList(scfTmIntAccMapMasterDTO.getScfTmIntAccMapDetailsDTO()));
        }
		scfcmTmIntAccMapMaster.setModNo(scfTmIntAccMapMasterDTO.getModNo());
		scfcmTmIntAccMapMaster.setId(scfTmIntAccMapMasterDTO.getId());
		scfcmTmIntAccMapMaster.setMakerDtStamp(ReportingUtil.convertStrToDate(scfTmIntAccMapMasterDTO.getMakerDateStamp()));
		scfcmTmIntAccMapMaster.setCheckerDtStamp(ReportingUtil.convertStrToDate(scfTmIntAccMapMasterDTO.getCheckerDateStamp()));
	}

	private static List<ScfcmTmIntAccMapDetails> convertInternalAccountMapTMVOToEntityList(List<ScfTmIntAccMapDetailsDTO> scfTmIntAccMapDetailsDTO) {
		List<ScfcmTmIntAccMapDetails> scfcmTmIntAccMapDetailsList = new ArrayList<>();
		scfTmIntAccMapDetailsDTO.forEach(internalAccMap -> scfcmTmIntAccMapDetailsList.add(convertInternalAccountMapDetailsTMVOToEntity(internalAccMap)));
        return scfcmTmIntAccMapDetailsList;
    }
	
	private static ScfcmTmIntAccMapDetails convertInternalAccountMapDetailsTMVOToEntity(ScfTmIntAccMapDetailsDTO scfTmIntAccMapDetailsDTO) {
		ScfcmTmIntAccMapDetails scfcmTmIntAccMapDetails = new ScfcmTmIntAccMapDetails();
        if (scfTmIntAccMapDetailsDTO != null) {
            BeanUtils.copyProperties(scfTmIntAccMapDetailsDTO, scfcmTmIntAccMapDetails);
            scfcmTmIntAccMapDetails.setId(scfTmIntAccMapDetailsDTO.getId());
        }
        
        return scfcmTmIntAccMapDetails;
    }
	
	
	/////
	
	public static void convertInternalAccountMapTWModelToEntity(ScfcmTmIntAccMapMasterWork scfcmTmIntAccMapMasterWork, ScfTmIntAccMapMasterDTO scfTmIntAccMapMasterDTO) {
		String[] ignoreFields = { MAKER_DT_STAMP, CHECKER_DT_STAMP };
		BeanUtils.copyProperties(scfTmIntAccMapMasterDTO, scfcmTmIntAccMapMasterWork, ignoreFields);
		if (scfTmIntAccMapMasterDTO.getScfTmIntAccMapDetailsDTO()!= null) {
			scfcmTmIntAccMapMasterWork.setScfcmTmIntAccMapDetailsWorkList(
					convertInternalAccountMapTWVOToEntityList(scfTmIntAccMapMasterDTO.getScfTmIntAccMapDetailsDTO()));
        }
		scfcmTmIntAccMapMasterWork.setModNo(scfTmIntAccMapMasterDTO.getModNo());
		scfcmTmIntAccMapMasterWork.setId(scfTmIntAccMapMasterDTO.getId());
		scfcmTmIntAccMapMasterWork.setMakerDateStamp(ReportingUtil.convertStrToDate(scfTmIntAccMapMasterDTO.getMakerDateStamp()));
		scfcmTmIntAccMapMasterWork.setCheckerDateStamp(ReportingUtil.convertStrToDate(scfTmIntAccMapMasterDTO.getCheckerDateStamp()));
	}

	private static List<ScfcmTmIntAccMapDetailsWork> convertInternalAccountMapTWVOToEntityList(List<ScfTmIntAccMapDetailsDTO> scfTmIntAccMapDetailsDTO) {
		List<ScfcmTmIntAccMapDetailsWork> scfcmTmIntAccMapDetailsWorkList = new ArrayList<>();
		scfTmIntAccMapDetailsDTO.forEach(internalAccMap -> scfcmTmIntAccMapDetailsWorkList.add(convertInternalAccountMapDetailsTWVOToEntity(internalAccMap)));
        return scfcmTmIntAccMapDetailsWorkList;
    }
	
	private static ScfcmTmIntAccMapDetailsWork convertInternalAccountMapDetailsTWVOToEntity(ScfTmIntAccMapDetailsDTO scfTmIntAccMapDetailsDTO) {
		ScfcmTmIntAccMapDetailsWork scfcmTmIntAccMapDetailsWork = new ScfcmTmIntAccMapDetailsWork();
        if (scfTmIntAccMapDetailsDTO != null) {
            BeanUtils.copyProperties(scfTmIntAccMapDetailsDTO, scfcmTmIntAccMapDetailsWork);
            scfcmTmIntAccMapDetailsWork.setId(scfTmIntAccMapDetailsDTO.getId());
        }
        
        return scfcmTmIntAccMapDetailsWork;
    }
}
