package oracle.fsgbu.obscfcm.services.report.util;

import org.apache.commons.lang.StringUtils;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;

import oracle.fsgbu.gus.persistence.provider.GlobalHolder;
import oracle.fsgbu.obscfcm.alertsgenerator.constant.AlertConstants;
import oracle.fsgbu.obscfcm.services.report.constants.ReportConstants;

public class AlertServiceUtility {

	private AlertServiceUtility() {
		throw new IllegalStateException("Cannot make object of Utility class");
	}

	/**
	 * @param appId
	 * @param extraHeaders
	 * extraHeaders[0] : User Id
	 * extraHeaders[1] : Branch Code
	 * @return
	 */
	public static HttpHeaders buildHeaders(String appId, String... extraHeaders) {
		HttpHeaders httpHeaders = new HttpHeaders();
		if (GlobalHolder.getRequestContext() != null) {
			httpHeaders.setContentType(MediaType.APPLICATION_JSON);
			httpHeaders.add(ReportConstants.APPID, appId);
			httpHeaders.add(AlertConstants.BRANCH_CODE, StringUtils.isNotBlank(GlobalHolder.getRequestContext().getCurrBranch())? GlobalHolder.getRequestContext().getCurrBranch():extraHeaders[1]);
			httpHeaders.add(AlertConstants.USERID, StringUtils.isNotBlank(GlobalHolder.getRequestContext().getUserId())? GlobalHolder.getRequestContext().getUserId():extraHeaders[0]);
		}
		return httpHeaders;
	}
}
