package oracle.fsgbu.obscfcm.services.report.util;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.ReportingPolicy;
import org.mapstruct.control.DeepClone;
import org.mapstruct.factory.Mappers;

import oracle.fsgbu.eventService.api.model.InvoiceLinkedPoModel;
import oracle.fsgbu.eventService.api.model.PaymentDto;
import oracle.fsgbu.eventService.api.model.PoCommodityListDTO;
import oracle.fsgbu.eventService.api.model.PurchaseOrderDTO;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTmRelationshipMaster;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTwRelationshipDetails;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTwRelationshipDetailsExternalCode;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTwRelationshipMaster;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfTmInvoicePo;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfTwInvoicePo;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmPayment;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmTwPayment;
import oracle.fsgbu.obscfcm.services.report.domain.entity.po.TmCommodityList;
import oracle.fsgbu.obscfcm.services.report.domain.entity.po.TmPOShipParameters;
import oracle.fsgbu.obscfcm.services.report.domain.entity.po.TmPurchaseOrder;
import oracle.fsgbu.obscfcm.services.report.domain.entity.po.TwCommodityList;
import oracle.fsgbu.obscfcm.services.report.domain.entity.po.TwPOShipParameters;
import oracle.fsgbu.obscfcm.services.report.domain.entity.po.TwPurchaseOrder;
import oracle.fsgbu.obscfcm.services.report.model.CurrencyUtilityDto;
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipDetailsDTO;
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipDetailsExternalCodeDTO;
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipMasterDTO;


@Mapper(mappingControl = DeepClone.class, unmappedTargetPolicy = ReportingPolicy.IGNORE)
public interface MapperUtil {
	MapperUtil INSTANCE = Mappers.getMapper(MapperUtil.class);
	CurrencyUtilityDto clone(CurrencyUtilityDto currencyUtilityDto);

	@Mapping(target = "checkerDtStamp", expression = "java(ReportingUtil.setEntityDateFormat(obcmTmRelationshipMasterDTO.getCheckerDateStamp()))")
	@Mapping(target = "makerDtStamp", expression = "java(ReportingUtil.setEntityDateFormat(obcmTmRelationshipMasterDTO.getMakerDateStamp()))")
	@Mapping(target = "effFromDate", expression = "java(ReportingUtil.setEntityDateFormat(obcmTmRelationshipMasterDTO.getEffFromDate()))")
	@Mapping(target = "expiresOn", expression = "java(ReportingUtil.setEntityDateFormat(obcmTmRelationshipMasterDTO.getExpiresOn()))")
	@Mapping(target = "modNo", expression = "java(obcmTmRelationshipMasterDTO.getModNo()!=null ?new Integer(obcmTmRelationshipMasterDTO.getModNo().toString()) : null )")
	@Mapping(target = "authStat", expression = "java(obcmTmRelationshipMasterDTO.getAuthStatus())")
	@Mapping(target = "recordStat", expression = "java(obcmTmRelationshipMasterDTO.getRecordStatus())")
	ObcmTmRelationshipMaster  toEntity(ObcmTmRelationshipMasterDTO obcmTmRelationshipMasterDTO);
	
	@Mapping(target = "id", expression = "java(new oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTwRelationshipMasterPK(obcmTwRelationshipMasterDTO.getId()!=null ?obcmTwRelationshipMasterDTO.getId() : null,obcmTwRelationshipMasterDTO.getModNo()!=null ?new Integer(obcmTwRelationshipMasterDTO.getModNo().toString()) : null ))")
	@Mapping(target = "checkerDtStamp", expression = "java(ReportingUtil.setEntityDateFormat(obcmTwRelationshipMasterDTO.getCheckerDateStamp()))")
	@Mapping(target = "makerDtStamp", expression = "java(ReportingUtil.setEntityDateFormat(obcmTwRelationshipMasterDTO.getMakerDateStamp()))")
	@Mapping(target = "effFromDate", expression = "java(ReportingUtil.setEntityDateFormat(obcmTwRelationshipMasterDTO.getEffFromDate()))")
	@Mapping(target = "expiresOn", expression = "java(ReportingUtil.setEntityDateFormat(obcmTwRelationshipMasterDTO.getExpiresOn()))")
	@Mapping(target = "checkerRemarks", expression = "java(obcmTwRelationshipMasterDTO.getApproverRemarks())")
	@Mapping(target = "makerRemarks", expression = "java(obcmTwRelationshipMasterDTO.getDoerRemarks())")
	@Mapping(target = "authStat", expression = "java(obcmTwRelationshipMasterDTO.getAuthStatus())")
	ObcmTwRelationshipMaster  toTwEntity(ObcmTmRelationshipMasterDTO obcmTwRelationshipMasterDTO);

	@Mapping(target = "instrumentDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getInstrumentDate()))")
	@Mapping(target = "paymentBusinessDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getPaymentBusinessDate()))")
	@Mapping(target = "paymentDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getPaymentDate()))")
	@Mapping(target = "procBranchDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getProcBranchDate()))")
	@Mapping(target = "id", ignore= true)
	ScfcmTwPayment copyPropertiestoEntity(PaymentDto paymentDto);

	@Mapping(target = "instrumentDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getInstrumentDate()))")
	@Mapping(target = "paymentBusinessDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getPaymentBusinessDate()))")
	@Mapping(target = "paymentDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getPaymentDate()))")
	@Mapping(target = "procBranchDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getProcBranchDate()))")
	ScfcmTwPayment copyPropertiesTWtoEntity(PaymentDto paymentDto);

	@Mapping(target = "instrumentDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getInstrumentDate()))")
	@Mapping(target = "paymentBusinessDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getPaymentBusinessDate()))")
	@Mapping(target = "paymentDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getPaymentDate()))")
	@Mapping(target = "procBranchDate", expression = "java(ReportingUtil.setEntityDateFormat(paymentDto.getProcBranchDate()))")
	ScfcmPayment copyPropertiesTMtoEntity(PaymentDto paymentDto);
	
	
	@Mapping(target = "id", expression = "java(new oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTwRelationshipDetailsPK((obcmTmRelationshipDetailsDTO.getId()!=null ?obcmTmRelationshipDetailsDTO.getId() : null),(obcmTmRelationshipDetailsDTO.getModNo()!=null ?new Integer(obcmTmRelationshipDetailsDTO.getModNo().toString()) : null )))")
	@Mapping(target = "expiresOn", expression = "java(ReportingUtil.setEntityDateFormat(obcmTmRelationshipDetailsDTO.getExpiresOn()))")
	@Mapping(target = "relationshipMasterId", expression = "java(obcmTmRelationshipDetailsDTO.getRelationsMasterId())")
	ObcmTwRelationshipDetails  toTwEntity(ObcmTmRelationshipDetailsDTO obcmTmRelationshipDetailsDTO);
	
	@Mapping(target = "id", expression = "java(new oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTwRelationshipDetailsExternalCodePK(obcmTmRelationshipDetailsExternalCodeDTO.getId()!=null ?obcmTmRelationshipDetailsExternalCodeDTO.getId() : null,obcmTmRelationshipDetailsExternalCodeDTO.getModNo()!=null ?new Integer(obcmTmRelationshipDetailsExternalCodeDTO.getModNo().toString()) : null ))")
	ObcmTwRelationshipDetailsExternalCode   toTwEntity( ObcmTmRelationshipDetailsExternalCodeDTO obcmTmRelationshipDetailsExternalCodeDTO);

    @Mapping(target = "poDate",expression = "java(ReportingUtil.setEntityDateFormat(invoiceLinkedPoModel.getPoDate()))")
    ScfTmInvoicePo toScfTmInvoicePo(InvoiceLinkedPoModel invoiceLinkedPoModel);

    @Mapping(target = "poDate",expression = "java(ReportingUtil.setEntityDateFormat(invoiceLinkedPoModel.getPoDate()))")
    ScfTwInvoicePo toScfTwInvoicePo(InvoiceLinkedPoModel invoiceLinkedPoModel);
    
    @Mapping(target = "id", expression = "java(new oracle.fsgbu.obscfcm.services.report.domain.entity.po.TwPurchaseOrderPk((purchaseOrderDTO.getPoInternalNumber()!=null ?purchaseOrderDTO.getPoInternalNumber() : null),(purchaseOrderDTO.getSeqNo()!=null ?purchaseOrderDTO.getSeqNo(): null )))")
    @Mapping(target = "poDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getPoDate()))")
    @Mapping(target = "acceptanceDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getAcceptanceDate()))")
    @Mapping(target = "fundingReqDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getFundReqDate()))")
    @Mapping(target = "fundReqAmount", expression = "java(purchaseOrderDTO.getFundReqAmount()!=null ? new java.math.BigDecimal(purchaseOrderDTO.getFundReqAmount()):null )")
    @Mapping(target = "makerDtStamp",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getMakerDate()))")
    @Mapping(target = "version", ignore = true)
    TwPurchaseOrder toTwPurchaseOrder(PurchaseOrderDTO purchaseOrderDTO);

    @Mapping(target = "id", expression = "java(new oracle.fsgbu.obscfcm.services.report.domain.entity.po.TwPOShipParametersPK((purchaseOrderDTO.getPoInternalNumber()!=null ?purchaseOrderDTO.getPoInternalNumber() : null),(purchaseOrderDTO.getSeqNo()!=null ?purchaseOrderDTO.getSeqNo(): null )))")
    @Mapping(target = "reqShipmentDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getReqShipmentDate()))")
    @Mapping(target = "promisedShipmentDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getPromisedShipmentDate()))")
    @Mapping(target = "oldPromisedShipmentDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getOldPromisedShipmentDate()))")
    TwPOShipParameters toTwPOShipParameters(PurchaseOrderDTO purchaseOrderDTO);

    @Mapping(target = "id", ignore = true)
    TwCommodityList toTwCommodityList(PoCommodityListDTO poCommodityListDTO);
    
    @Mapping(target = "poDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getPoDate()))")
    @Mapping(target = "acceptanceDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getAcceptanceDate()))")
    @Mapping(target = "fundingReqDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getFundReqDate()))")
    @Mapping(target = "fundReqAmount", expression = "java(purchaseOrderDTO.getFundReqAmount()!=null ? new java.math.BigDecimal(purchaseOrderDTO.getFundReqAmount()):null )")
    @Mapping(target = "makerDtStamp",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getMakerDate()))")
    @Mapping(target = "version", ignore = true)
    TmPurchaseOrder toTmPurchaseOrder(PurchaseOrderDTO purchaseOrderDTO);
    
    @Mapping(target = "reqShipmentDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getReqShipmentDate()))")
    @Mapping(target = "promisedShipmentDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getPromisedShipmentDate()))")
    @Mapping(target = "oldPromisedShipmentDate",expression = "java(ReportingUtil.setEntityDateFormat(purchaseOrderDTO.getOldPromisedShipmentDate()))")
    TmPOShipParameters toTmPOShipParameters(PurchaseOrderDTO purchaseOrderDTO);
    TmCommodityList toTmCommodityList(PoCommodityListDTO poCommodityListDTO);
    
}
