package oracle.fsgbu.obscfcm.services.report.web;

import javax.validation.Valid;

import oracle.fsgbu.eventService.api.model.CreditNoteModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RestController;

import io.swagger.annotations.ApiParam;
import oracle.fsgbu.eventService.api.model.FileUploadDto;
import oracle.fsgbu.eventService.api.model.InvoiceModel;
import oracle.fsgbu.eventService.api.model.InvoiceTmDto;
import oracle.fsgbu.eventService.api.model.PaymentDto;
import oracle.fsgbu.eventService.web.api.EventServiceApi;
import oracle.fsgbu.obscfcm.services.report.service.EventListenerService;

@RestController
public class EventListenerServiceController implements EventServiceApi {

	@Autowired
	private EventListenerService eventListenerService;
	
	@Autowired
	public EventListenerServiceController(EventListenerService eventListenerService) {
		this.eventListenerService = eventListenerService;
	}
	
	@Override
	public ResponseEntity<Boolean> saveInvoiceData(
			@ApiParam(value = "Application id" ,required=true) @RequestHeader(value="appId", required=true) String appId,
			@ApiParam(value = "user id" ,required=true) @RequestHeader(value="userId", required=true) String userId,
			@ApiParam(value = "Branch Code" ,required=true) @RequestHeader(value="branchCode", required=true) String branchCode,
			@ApiParam(value = "" ,required=true )  @Valid @RequestBody InvoiceTmDto invoiceTmDto) {
		
		return ResponseEntity.ok(eventListenerService.fetchInvoiceData(invoiceTmDto.getTransactionReferenceNo(), userId, branchCode));
	}
	
	@Override
	public ResponseEntity<Boolean> savePaymentData(
			@ApiParam(value = "Application id" ,required=true) @RequestHeader(value="appId", required=true) String appId,
			@ApiParam(value = "user id" ,required=true) @RequestHeader(value="userId", required=true) String userId,
			@ApiParam(value = "Branch Code" ,required=true) @RequestHeader(value="branchCode", required=true) String branchCode,
			@ApiParam(value = "" ,required=true )  @Valid @RequestBody PaymentDto paymentDto) {
		
		return ResponseEntity.ok(eventListenerService.savePaymentData(paymentDto, userId, branchCode));
	}

	@Override
	public ResponseEntity<Boolean> saveUploadedFileData(
			@ApiParam(value = "Application id" ,required=true) @RequestHeader(value="appId", required=true) String appId,
			@ApiParam(value = "user id" ,required=true) @RequestHeader(value="userId", required=true) String userId,
			@ApiParam(value = "Branch Code" ,required=true) @RequestHeader(value="branchCode", required=true) String branchCode,
			@ApiParam(value = "" ,required=true )  @Valid @RequestBody FileUploadDto fileUploadDto) {

		return ResponseEntity.ok(eventListenerService.saveUploadedFileData(fileUploadDto, userId, branchCode));
	}

	@Override
	public ResponseEntity<Boolean> saveCreditNote(
			@ApiParam(value = "Application id" ,required=true) @RequestHeader(value="appId", required=true) String appId,
			@ApiParam(value = "user id" ,required=true) @RequestHeader(value="userId", required=true) String userId,
			@ApiParam(value = "Branch Code" ,required=true) @RequestHeader(value="branchCode", required=true) String branchCode,
			@Valid @RequestBody CreditNoteModel creditNoteModel) {

		return ResponseEntity.ok(eventListenerService.saveCreditNote(creditNoteModel, userId, branchCode));
	}
}