package oracle.fsgbu.obscfcm.services.report.web;

import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RestController;

import io.swagger.annotations.ApiParam;
import oracle.fsgbu.obscfcm.services.report.service.ReconEventListenerService;
import oracle.fsgbu.reconService.api.model.ExpDrCrPmtReconDTO;
import oracle.fsgbu.reconService.api.model.FinPmtReconDTO;
import oracle.fsgbu.reconService.api.model.InvCnReconDTO;
import oracle.fsgbu.reconService.api.model.InvPmtReconDTO;
import oracle.fsgbu.reconService.api.model.PmtAllocDTO;
import oracle.fsgbu.reconService.web.api.ReconServiceApi;

@RestController
public class ReconEventListenerServiceController implements ReconServiceApi {

	@Autowired
	private ReconEventListenerService reconEventListenerService;
	
	@Autowired
	public ReconEventListenerServiceController(ReconEventListenerService reconEventListenerService) {
		this.reconEventListenerService = reconEventListenerService;
	}
	

	@Override
	public ResponseEntity<Boolean> saveExpDrCrRecon(@ApiParam(value = "Application id" ,required=true) @RequestHeader(value="appId", required=true) String appId,
			@ApiParam(value = "user id" ,required=true) @RequestHeader(value="userId", required=true) String userId,
			@ApiParam(value = "Branch Code" ,required=true) @RequestHeader(value="branchCode", required=true) String branchCode,
			@ApiParam(value = "" ,required=true )  @Valid @RequestBody ExpDrCrPmtReconDTO expDrCrPmtReconDTO) {
		return ResponseEntity.ok(reconEventListenerService.saveExpDrCrReconData(expDrCrPmtReconDTO, userId, branchCode));
	}

	@Override
	public ResponseEntity<Boolean> saveInvPmtRecon(@ApiParam(value = "Application id" ,required=true) @RequestHeader(value="appId", required=true) String appId,
			@ApiParam(value = "user id" ,required=true) @RequestHeader(value="userId", required=true) String userId,
			@ApiParam(value = "Branch Code" ,required=true) @RequestHeader(value="branchCode", required=true) String branchCode,
			@ApiParam(value = "" ,required=true )  @Valid @RequestBody InvPmtReconDTO invPmtReconDTO) {
		return ResponseEntity.ok(reconEventListenerService.saveInvPmtReconData(invPmtReconDTO, userId, branchCode));
	}

	@Override
	public ResponseEntity<Boolean> saveFinPmtRecon(@ApiParam(value = "Application id" ,required=true) @RequestHeader(value="appId", required=true) String appId,
			@ApiParam(value = "user id" ,required=true) @RequestHeader(value="userId", required=true) String userId,
			@ApiParam(value = "Branch Code" ,required=true) @RequestHeader(value="branchCode", required=true) String branchCode,
			@ApiParam(value = "" ,required=true )  @Valid @RequestBody FinPmtReconDTO finPmtReconDTO) {
		return ResponseEntity.ok(reconEventListenerService.saveFinPmtReconData(finPmtReconDTO, userId, branchCode));
	}


	@Override
	public ResponseEntity<Boolean> savePmtAllocationData(
			@ApiParam(value = "Application id", required = true) @RequestHeader(value = "appId", required = true) String appId,
			@ApiParam(value = "user id", required = true) @RequestHeader(value = "userId", required = true) String userId,
			@ApiParam(value = "Branch Code", required = true) @RequestHeader(value = "branchCode", required = true) String branchCode,
			@ApiParam(value = "", required = true) @Valid @RequestBody PmtAllocDTO pmtAllocDTO) {
		return ResponseEntity.ok(reconEventListenerService.savePmtAllocData(pmtAllocDTO, userId, branchCode));
	}


	@Override
	public ResponseEntity<Boolean> saveInvCnRecon(
			@ApiParam(value = "Application id", required = true) @RequestHeader(value = "appId", required = true) String appId, 
			@ApiParam(value = "user id", required = true) @RequestHeader(value = "userId", required = true) String userId, 
			@ApiParam(value = "Branch Code", required = true) @RequestHeader(value = "branchCode", required = true) String branchCode,
			@ApiParam(value = "", required = true) @Valid @RequestBody InvCnReconDTO invCnReconDTO) {
		return ResponseEntity.ok(reconEventListenerService.saveInvCnReconData(invCnReconDTO, userId, branchCode));
	}
}