package oracle.fsgbu.obscfcm.services.report.web;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

import oracle.fsgbu.obscfcm.services.report.exception.InvalidDateRangeException;
import oracle.fsgbu.obscfcm.services.report.exception.InvalidTrendLineDateException;

@ControllerAdvice
public class ReconExceptionController {
   @ExceptionHandler(value = InvalidDateRangeException.class)
   public ResponseEntity<Object> exception(InvalidDateRangeException exception) {
      return new ResponseEntity<>("Date range seleted is more than 6 months", HttpStatus.BAD_REQUEST);
   }
   
   @ExceptionHandler(value = InvalidTrendLineDateException.class)
   public ResponseEntity<Object> exception(InvalidTrendLineDateException exception) {
      return new ResponseEntity<>("Trendline Date is either invalid or not falling between date range", HttpStatus.BAD_REQUEST);
   }
}
