package oracle.fsgbu.obscfcm.services.report.web;

import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RestController;

import io.swagger.annotations.ApiParam;
import oracle.fsgbu.obscfcm.services.report.service.RelationshipEventListenerService;
import oracle.fsgbu.obscfcm.services.scfcm.api.RelationshipmasterApi;
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipMasterDTO;

@RestController
public class RelationshipEventListenerServiceController implements RelationshipmasterApi {

	@Autowired
	private RelationshipEventListenerService relationshipEventListenerService;

	@Override
	public ResponseEntity<Boolean> saveRelationshipData(
			@ApiParam(value = "Application id", required = true) @RequestHeader(value = "appId", required = true) String appId,
			@ApiParam(value = "userId", required = true) @RequestHeader(value = "userId", required = true) String userId,
			@ApiParam(value = "branchCode", required = true) @RequestHeader(value = "branchCode", required = true) String branchCode,
			@ApiParam(value = "Request Body that contains data required for creating a new relationshipmaster", required = true) @Valid @RequestBody ObcmTmRelationshipMasterDTO relationshipmaster) {

		return ResponseEntity.ok(relationshipEventListenerService.saveRelationshipData(relationshipmaster));
	}
}