package oracle.fsgbu.obscfcm.services.report.web;

import javax.validation.Valid;

import oracle.fsgbu.reportsService.web.api.ReportTransactionServiceApi;
import org.springframework.beans.factory.annotation.Autowired;
import oracle.fsgbu.reportsService.api.model.InvoicesLinkedToPOCollection;

import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import io.swagger.annotations.ApiParam;
import oracle.fsgbu.obscfcm.services.report.service.ReportTransactionService;
import oracle.fsgbu.obscfcm.services.report.service.ReportTransactionServiceImpl;
import oracle.fsgbu.plato.logger.PlatoLogger;

import java.util.List;

@RestController
public class ReportTransactionServiceController implements ReportTransactionServiceApi {
	
	private static final PlatoLogger LOGGER = new PlatoLogger(ReportTransactionServiceController.class);
	
	@Autowired
	private ReportTransactionService reportTransactionService;
	
	@Autowired
	public ReportTransactionServiceController(ReportTransactionService reportTransactionService) {
		this.reportTransactionService = reportTransactionService;
	}
	
	
	@Override
	public ResponseEntity<InvoicesLinkedToPOCollection> getInvoicesLinkedToPO(
			@ApiParam(value = "Application id" ,required=true) @RequestHeader(value="appId", required=true) String appId,
			@ApiParam(value = "user id" ,required=true) @RequestHeader(value="userId", required=true) String userId,
			@ApiParam(value = "Branch Code" ,required=true) @RequestHeader(value="branchCode", required=true) String branchCode,
			@ApiParam(value = "Reference no List") @Valid @RequestParam(value = "poInternalNoList", required = false) List<String> poInternalNoList) {
		LOGGER.info("Request received for getInvoicesLinkedToPO");
		InvoicesLinkedToPOCollection response = reportTransactionService.getInvoicesLinkedToPO( appId,  userId,  branchCode,  poInternalNoList);
		if (response != null) {
			LOGGER.info("Response : " + response.toString());
		}
		LOGGER.info("Exiting getInvoicesLinkedToPO");
		return ResponseEntity.ok(response);
	}
}