declare table_exists number;
begin
select count(1) into table_exists from USER_TABLES where table_name = 'SCFCM_FILE';

if (table_exists = 0) then
execute immediate 'CREATE TABLE "SCFCM_FILE" 
   (	"INVOICE_FILE_ID" NUMBER NOT NULL, 
	"CHANNEL" VARCHAR2(10 BYTE), 
	"FILE_TYPE" VARCHAR2(8 BYTE), 
	"FILE_NAME" VARCHAR2(70 BYTE), 
	"STATUS" VARCHAR2(20 BYTE), 
	"FILE_REF" VARCHAR2(40 BYTE), 
	"UPLOAD_DATE" DATE, 
	"TOTAL_RECORDS" NUMBER, 
	"TOTAL_SUCCESS_RECORDS" NUMBER, 
	"TOTAL_FAILED_RECORDS" NUMBER(10,0), 
	"REASON_CODE" VARCHAR2(100 BYTE)
   )';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'INVOICE_FILE_PK';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX "INVOICE_FILE_PK" ON "SCFCM_FILE" ("INVOICE_FILE_ID")';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'INVOICE_FILE_UK1';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX "INVOICE_FILE_UK1" ON "SCFCM_FILE" ("FILE_REF")';
end if;
end;
/
declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'SCFCM_FILE' and constraint_name = 'SCFCM_FILE_PK';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE "SCFCM_FILE" ADD CONSTRAINT "SCFCM_FILE_PK" PRIMARY KEY ("INVOICE_FILE_ID")';
end if;
end;
/
declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'SCFCM_FILE' and constraint_name = 'SCF_FILE_UK1';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE "SCFCM_FILE" ADD CONSTRAINT "SCF_FILE_UK1" UNIQUE ("FILE_REF")';
end if;
end;