declare table_exists number;
begin
select count(1) into table_exists from USER_TABLES where table_name = 'SCFCM_INVOICE';

if (table_exists = 0) then
execute immediate 'CREATE TABLE "SCFCM_INVOICE" 
   (	"INVOICE_ID" NUMBER NOT NULL, 
	"INDICATOR" VARCHAR2(1 BYTE), 
	"INVOICE_NUMBER" VARCHAR2(25 BYTE) NOT NULL, 
	"INVOICE_DUE_DATE" DATE, 
	"CURRENCY" VARCHAR2(3 BYTE) NOT NULL, 
	"AMOUNT" NUMBER(28,4) NOT NULL, 
	"BUYER_ID" VARCHAR2(20 BYTE), 
	"SUPPLIER_ID" VARCHAR2(20 BYTE), 
	"BUYER_NAME" VARCHAR2(50 BYTE), 
	"SUPPLIER_NAME" VARCHAR2(50 BYTE), 
	"PROGRAM_CODE" VARCHAR2(20 BYTE), 
	"TAX_AMOUNT" NUMBER(28,4), 
	"TOTAL_INVOICE_AMOUNT" NUMBER(28,4), 
	"PO_NUMBER" VARCHAR2(25 BYTE), 
	"INVOICE_REF_NO" VARCHAR2(40 BYTE), 
	"PAYMENT_STATUS" VARCHAR2(20 BYTE), 
	"REASON_CODE" VARCHAR2(70 BYTE), 
	"ACCEPTANCE_AMOUNT" NUMBER(28,4), 
	"INV_ACCEPTANCE_DATE" DATE, 
	"INVOICE_STATUS" VARCHAR2(20 BYTE), 
	"PAID_AMOUNT" NUMBER(28,4), 
	"REMARKS" VARCHAR2(40 BYTE), 
	"INVOICE_PROCESS_STATUS" VARCHAR2(10 BYTE), 
	"FILLER_1" DATE, 
	"FILLER_2" VARCHAR2(25 BYTE), 
	"FILLER_3" VARCHAR2(25 BYTE), 
	"FILLER_4" VARCHAR2(25 BYTE), 
	"FILE_REF" VARCHAR2(25 BYTE), 
	"INVOICE_DATE" DATE, 
	"PRE_ACCEPTED" VARCHAR2(10 BYTE), 
	"PAYMENT_TERMS" VARCHAR2(150 BYTE), 
	"SHIPMENT_DATE" DATE, 
	"OUTSTANDING_AMOUNT" NUMBER, 
	"PURCHASE_ORDER_DATE" DATE, 
	"STALE_STATUS" VARCHAR2(20 BYTE), 
	"DISCOUNT_ALLOWED" VARCHAR2(1 BYTE), 
	"DISCOUNT_PERCENTAGE" NUMBER, 
	"DISCOUNT_AMOUNT" NUMBER, 
	"TAX_PERCENTAGE" NUMBER, 
	"PROGRAM_NAME" VARCHAR2(40 BYTE), 
	"HIERARCHY_CODE" VARCHAR2(20 BYTE), 
	"SHIPMENT_ADDRESS" VARCHAR2(150 BYTE), 
	"SHIPMENT_NO" VARCHAR2(20 BYTE), 
	"SHIPMENT_COUNTRY" VARCHAR2(3 BYTE), 
	"REASON_FOR_EXPORT" VARCHAR2(50 BYTE), 
	"TERMS_OF_SALE" VARCHAR2(3 BYTE), 
	"COUNTRY_OF_ORIGIN" VARCHAR2(3 BYTE), 
	"MISC_CHARGE_1_DESC" VARCHAR2(100 BYTE), 
	"MISC_CHARGE_1_AMOUNT" NUMBER(28,4), 
	"MISC_CHARGE_2_DESC" VARCHAR2(100 BYTE), 
	"MISC_CHARGE_2_AMOUNT" NUMBER(28,4), 
	"MISC_CHARGE_1" NUMBER(28,4), 
	"MISC_CHARGE_2" NUMBER(28,4), 
	"NET_INVOICE_AMOUNT" NUMBER(28,4), 
	"FINANCE_AMOUNT" NUMBER(28,4), 
	"FINANCE_PERCENTAGE" NUMBER(28,4), 
	"BUYER_DIV_CODE" VARCHAR2(20 BYTE), 
	"SUPPLIER_DIV_CODE" VARCHAR2(20 BYTE), 
	"BUYER_DIV_NAME" VARCHAR2(105 BYTE), 
	"SUPPLIER_DIV_NAME" VARCHAR2(105 BYTE), 
	"DIVISION_CODE" VARCHAR2(20 BYTE), 
	"IS_DISPUTED" VARCHAR2(1 BYTE), 
	"DISCREPANCY_CODE" VARCHAR2(25 BYTE), 
	"DISPUTE_RESOLVE_REMARKS" VARCHAR2(250 BYTE)
   )';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'INVOICE_PK';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX "INVOICE_PK" ON "SCFCM_INVOICE" ("INVOICE_ID")';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'SCF_INVOICE_UK2';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX "SCF_INVOICE_UK2" ON "SCFCM_INVOICE" ("INVOICE_REF_NO")';
end if;
end;
/
declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'SCFCM_INVOICE' and constraint_name = 'SCF_INVOICE_PK';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE "SCFCM_INVOICE" ADD CONSTRAINT "SCF_INVOICE_PK" PRIMARY KEY ("INVOICE_ID")';
end if;
end;
/
declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'SCFCM_INVOICE' and constraint_name = 'SCF_INVOICE_UK2';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE "SCFCM_INVOICE" ADD CONSTRAINT "SCF_INVOICE_UK2" UNIQUE ("INVOICE_REF_NO")';
end if;
end;
/
declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'SCFCM_INVOICE' and constraint_name = 'SCF_INVOICE_FK1';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE "SCFCM_INVOICE" ADD CONSTRAINT "SCF_INVOICE_FK1" FOREIGN KEY ("FILE_REF") REFERENCES "SCFCM_FILE" ("FILE_REF") ENABLE';
end if;
end;