declare table_exists number;
begin
select count(1) into table_exists from USER_TABLES where table_name = 'SCFCM_PAYMENT';

if (table_exists = 0) then
execute immediate 'CREATE TABLE "SCFCM_PAYMENT" 
   (	"ID" NUMBER, 
	"PAYMENT_REF_NO" VARCHAR2(50 BYTE) NOT NULL, 
	"INDICATOR" VARCHAR2(1 BYTE) NOT NULL, 
	"PAYMENT_NUMBER" VARCHAR2(50 BYTE) NOT NULL, 
	"PAYMENT_CURRENCY" VARCHAR2(3 BYTE) NOT NULL, 
	"PAYMENT_AMOUNT" NUMBER(28,4) NOT NULL, 
	"PAYMENT_MODE" VARCHAR2(10 BYTE) NOT NULL, 
	"PAYMENT_DATE" DATE NOT NULL, 
	"BENEFICIARY_CODE" VARCHAR2(30 BYTE), 
	"CREDIT_ACC_NO" VARCHAR2(35 BYTE), 
	"FLAG" VARCHAR2(1 BYTE), 
	"ENTITY_REF_NO" VARCHAR2(50 BYTE), 
	"REMARKS" VARCHAR2(150 BYTE), 
	"PAYMENT_PARTY_ID" VARCHAR2(20 BYTE), 
	"BENEFICIARY_ID" VARCHAR2(20 BYTE), 
	"PROGRAM_CODE" VARCHAR2(20 BYTE), 
	"REMITTER_ACC_NO" VARCHAR2(35 BYTE), 
	"BANK_CODE" VARCHAR2(11 BYTE), 
	"EFT_REF_NO" VARCHAR2(35 BYTE), 
	"INSTRUMENT_DATE" DATE, 
	"INSTRUMENT_BANK" VARCHAR2(50 BYTE), 
	"INSTRUMENT_BRANCH" VARCHAR2(50 BYTE), 
	"MANDATE_REF_NO" VARCHAR2(35 BYTE), 
	"CREDIT_NOTE_REF_NO" VARCHAR2(35 BYTE), 
	"FILLER1" VARCHAR2(25 BYTE), 
	"FILLER2" VARCHAR2(25 BYTE), 
	"FILLER3" VARCHAR2(25 BYTE), 
	"FILLER4" VARCHAR2(25 BYTE), 
	"PAYMENT_PROCESS_STATUS" VARCHAR2(10 BYTE), 
	"PAYMENT_STATUS" VARCHAR2(15 BYTE), 
	"FILE_REF" VARCHAR2(25 BYTE), 
	"REASON_CODE" VARCHAR2(70 BYTE), 
	"MATCHED_AMOUNT" NUMBER(28,4), 
	"UNMATCHED_AMOUNT" NUMBER(28,4)
   )';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'SCF_PAYMENT_PK';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX "SCF_PAYMENT_PK" ON "SCFCM_PAYMENT" ("ID")';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'SCF_PAYMENT_UK1';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX "SCF_PAYMENT_UK1" ON "SCFCM_PAYMENT" ("PAYMENT_REF_NO")';
end if;
end;
/
declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'SCFCM_PAYMENT' and constraint_name = 'SCF_PAYMENT_PK';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE "SCFCM_PAYMENT" ADD CONSTRAINT "SCF_PAYMENT_PK" PRIMARY KEY ("ID")';
end if;
end;
/
declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'SCFCM_PAYMENT' and constraint_name = 'SCF_PAYMENT_UK1';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE "SCFCM_PAYMENT" ADD CONSTRAINT "SCF_PAYMENT_UK1" UNIQUE ("PAYMENT_REF_NO")';
end if;
end;