declare table_exists number;
begin
select count(1) into table_exists from USER_TABLES where table_name = 'SCFCM_PAYMENT';

if (table_exists = 1) then
execute immediate 'drop table SCFCM_PAYMENT';
end if;
end;
/
declare table_exists number;
begin
select count(1) into table_exists from USER_TABLES where table_name = 'SCFCM_PAYMENT';

if (table_exists = 0) then
execute immediate 'CREATE TABLE "SCFCM_PAYMENT" 
   (	 
	"PAYMENT_REF_NO" VARCHAR2(50 BYTE) NOT NULL ENABLE, 
	"INDICATOR" VARCHAR2(6 BYTE), 
	"PAYMENT_NUMBER" VARCHAR2(50 BYTE) NOT NULL ENABLE, 
	"PAYMENT_CURRENCY" VARCHAR2(3 BYTE) NOT NULL ENABLE, 
	"PAYMENT_AMOUNT" NUMBER(28,4) NOT NULL ENABLE, 
	"PAYMENT_MODE" VARCHAR2(10 BYTE) NOT NULL ENABLE, 
	"PAYMENT_DATE" DATE NOT NULL ENABLE, 
	"BENEFICIARY_CODE" VARCHAR2(30 BYTE), 
	"CREDIT_ACC_NO" VARCHAR2(35 BYTE), 
	"FLAG" VARCHAR2(1 BYTE), 
	"ENTITY_REF_NO" VARCHAR2(50 BYTE), 
	"REMARKS" VARCHAR2(150 BYTE), 
	"PAYMENT_PARTY_ID" VARCHAR2(20 BYTE), 
	"BENEFICIARY_ID" VARCHAR2(20 BYTE), 
	"PROGRAM_CODE" VARCHAR2(20 BYTE), 
	"REMITTER_ACC_NO" VARCHAR2(35 BYTE), 
	"BANK_CODE" VARCHAR2(30 BYTE), 
	"EFT_REF_NO" VARCHAR2(35 BYTE), 
	"INSTRUMENT_DATE" DATE, 
	"INSTRUMENT_BANK" VARCHAR2(50 BYTE), 
	"INSTRUMENT_BRANCH" VARCHAR2(50 BYTE), 
	"MANDATE_REF_NO" VARCHAR2(35 BYTE), 
	"CREDIT_NOTE_REF_NO" VARCHAR2(35 BYTE), 
	"FILLER1" VARCHAR2(25 BYTE), 
	"FILLER2" VARCHAR2(25 BYTE), 
	"FILLER3" VARCHAR2(25 BYTE), 
	"FILLER4" VARCHAR2(25 BYTE), 
	"PAYMENT_PROCESS_STATUS" VARCHAR2(10 BYTE), 
	"PAYMENT_STATUS" VARCHAR2(15 BYTE), 
	"FILE_REF" VARCHAR2(70 BYTE), 
	"REASON_CODE" VARCHAR2(70 BYTE), 
	"MATCHED_AMOUNT" NUMBER(28,4), 
	"UNMATCHED_AMOUNT" NUMBER(28,4), 
	"REC_TXN_STATUS" VARCHAR2(1 BYTE), 
	"VIRTUAL_AC_FLAG" VARCHAR2(1 BYTE), 
	"FILLER5" VARCHAR2(25 BYTE), 
	"FILLER6" VARCHAR2(25 BYTE), 
	"FILLER7" VARCHAR2(25 BYTE), 
	"FILLER8" VARCHAR2(25 BYTE), 
	"FILLER9" VARCHAR2(25 BYTE), 
	"FILLER10" VARCHAR2(25 BYTE), 
	"DEBIT_CREDIT_INDICATOR" VARCHAR2(1 BYTE), 
	"GENERIC_APPROPRIATION" VARCHAR2(3 BYTE), 
	"SPECIFIC_APPROPRIATION" VARCHAR2(50 BYTE), 
	"PARTY_PAYMENT_CODE" VARCHAR2(30 BYTE), 
	"COUNTERPARTY_CODE" VARCHAR2(30 BYTE), 
	"AUTORECONCILE" VARCHAR2(1 BYTE), 
	"COUNTERPARTY_ID" VARCHAR2(20 BYTE), 
	"PAYMENT_BUSINESS_DATE" DATE, 
	"TRANSACTION_REF_NO" VARCHAR2(100 BYTE), 
	"SEQ_NO" NUMBER(4,0), 
	"BENEFICIARY_ROLE" VARCHAR2(5 BYTE), 
	"COUNTER_PARTY_ROLE" VARCHAR2(5 BYTE), 
	"PAYMENT_PARTY_ROLE" VARCHAR2(5 BYTE), 
	"RELATIONSHIP_CODE" VARCHAR2(20 BYTE), 
	"ERROR_DESC" VARCHAR2(100 BYTE), 
	"PAYMENT_PARTY_CATEGORY" VARCHAR2(20 BYTE), 
	"DERIVED_FLAG" VARCHAR2(20 BYTE), 
	"ALLOCATION_REQUIRED" VARCHAR2(1 BYTE), 
	"ALLOCATION_STATUS" VARCHAR2(50 BYTE), 
	"ALLOCATED_PMT_AMT" NUMBER(28,4), 
	"UNALLOCATED_PMT_AMT" NUMBER(28,4), 
	"ACCOUNT_OWNER" VARCHAR2(20 BYTE), 
	"PROC_BRANCH_CODE" VARCHAR2(30 BYTE), 
	"PROC_BRANCH_DATE" DATE, 
	"PAYMENT_PARTY_NAME" VARCHAR2(50 BYTE), 
	"COUNTERPARTY_NAME" VARCHAR2(50 BYTE), 
	"BENEFICIARY_NAME" VARCHAR2(50 BYTE)
  )';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'SCFCM_PAYMENT_PK';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX "SCFCM_PAYMENT_PK" ON "SCFCM_PAYMENT" ("PAYMENT_REF_NO")';
end if;
end;
/
declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'SCFCM_PAYMENT' and constraint_name = 'SCFCM_PAYMENT_PK';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE "SCFCM_PAYMENT" ADD CONSTRAINT "SCFCM_PAYMENT_PK" PRIMARY KEY ("PAYMENT_REF_NO")';
end if;
end;