declare table_exists number;
begin
select count(1) into table_exists from USER_TABLES where table_name = 'OB_INVOICE_TW';

if (table_exists = 0) then
execute immediate 'CREATE TABLE "OB_INVOICE_TW" 
   (	"INVOICE_ID" NUMBER NOT NULL ENABLE, 
	"INDICATOR" VARCHAR2(1 BYTE), 
	"INVOICE_NUMBER" VARCHAR2(25 BYTE) NOT NULL ENABLE, 
	"INVOICE_DUE_DATE" DATE, 
	"CURRENCY" VARCHAR2(3 BYTE) NOT NULL ENABLE, 
	"AMOUNT" NUMBER(28,4) NOT NULL ENABLE, 
	"BUYER_ID" VARCHAR2(20 BYTE), 
	"SUPPLIER_ID" VARCHAR2(20 BYTE), 
	"BUYER_NAME" VARCHAR2(50 BYTE), 
	"SUPPLIER_NAME" VARCHAR2(50 BYTE), 
	"TAX_AMOUNT" NUMBER(28,4), 
	"TOTAL_INVOICE_AMOUNT" NUMBER(28,4), 
	"PO_NUMBER" VARCHAR2(25 BYTE), 
	"INVOICE_REF_NO" VARCHAR2(40 BYTE), 
	"REASON_CODE" VARCHAR2(70 BYTE), 
	"ACCEPTANCE_AMOUNT" NUMBER(28,4), 
	"INV_ACCEPTANCE_DATE" DATE, 
	"INVOICE_STATUS" VARCHAR2(20 BYTE), 
	"REMARKS" VARCHAR2(200 BYTE), 
	"INVOICE_PROCESS_STATUS" VARCHAR2(10 BYTE), 
	"FILLER_1" DATE, 
	"FILLER_2" VARCHAR2(25 BYTE), 
	"FILLER_3" VARCHAR2(25 BYTE), 
	"FILLER_4" VARCHAR2(25 BYTE), 
	"FILE_REF" VARCHAR2(100 BYTE), 
	"INVOICE_DATE" DATE, 
	"PRE_ACCEPTED" VARCHAR2(10 BYTE), 
	"PAYMENT_TERMS" VARCHAR2(150 BYTE), 
	"OUTSTANDING_AMOUNT" NUMBER, 
	"PURCHASE_ORDER_DATE" DATE, 
	"STALE_STATUS" VARCHAR2(20 BYTE), 
	"DISCOUNT_ALLOWED" VARCHAR2(1 BYTE), 
	"DISCOUNT_PERCENTAGE" NUMBER, 
	"DISCOUNT_AMOUNT" NUMBER, 
	"TAX_PERCENTAGE" NUMBER, 
	"REASON_FOR_EXPORT" VARCHAR2(50 BYTE), 
	"TERMS_OF_SALE" VARCHAR2(3 BYTE), 
	"COUNTRY_OF_ORIGIN" VARCHAR2(3 BYTE), 
	"MISC_CHARGE_1_DESC" VARCHAR2(100 BYTE), 
	"MISC_CHARGE_1_AMOUNT" NUMBER(28,4), 
	"MISC_CHARGE_2_DESC" VARCHAR2(100 BYTE), 
	"MISC_CHARGE_2_AMOUNT" NUMBER(28,4), 
	"MISC_CHARGE_1" NUMBER(28,4), 
	"MISC_CHARGE_2" NUMBER(28,4), 
	"NET_INVOICE_AMOUNT" NUMBER(28,4), 
	"BUYER_DIV_CODE" VARCHAR2(20 BYTE), 
	"SUPPLIER_DIV_CODE" VARCHAR2(20 BYTE), 
	"BUYER_DIV_NAME" VARCHAR2(105 BYTE), 
	"SUPPLIER_DIV_NAME" VARCHAR2(105 BYTE), 
	"DIVISION_CODE" VARCHAR2(20 BYTE), 
	"IS_DISPUTED" VARCHAR2(1 BYTE), 
	"DISCREPANCY_CODE" VARCHAR2(25 BYTE), 
	"DISPUTE_RESOLVE_REMARKS" VARCHAR2(250 BYTE), 
	"TRANSACTION_REF_NO" VARCHAR2(100 BYTE), 
	"RELATION_CODE" VARCHAR2(100 BYTE), 
	"ID" VARCHAR2(50 BYTE) NOT NULL ENABLE, 
	"SEQ_NO" NUMBER(4,0) NOT NULL ENABLE, 
	"BUYER_CODE" VARCHAR2(100 BYTE), 
	"SUPPLIER_CODE" VARCHAR2(100 BYTE), 
	"REPAYMENT_ACC_NO" VARCHAR2(50 BYTE), 
	"VIRTUAL_AC_FLAG" VARCHAR2(1 BYTE), 
	"BANK" VARCHAR2(200 BYTE), 
	"BRANCH" VARCHAR2(3 BYTE), 
	"ROUTING_CODE" NUMBER(9,0), 
	"STAGE_ID" VARCHAR2(200 BYTE), 
	"REASON_FOR_SHIPMENT" VARCHAR2(50 BYTE), 
	"CHECKER_DT_STAMP" DATE, 
	"CHECKER_ID" VARCHAR2(192 BYTE), 
	"MAKER_DT_STAMP" DATE, 
	"MAKER_ID" VARCHAR2(192 BYTE), 
	"CHG_CALC" VARCHAR2(1 BYTE), 
	"TCM_ID" VARCHAR2(50 BYTE), 
	"PROC_BRANCH_CODE" VARCHAR2(3 BYTE), 
	"ACTION" VARCHAR2(20 BYTE), 
	"PROC_DATE" DATE, 
	"FILE_NAME" VARCHAR2(70 BYTE), 
	"DISPUTED_AMOUNT" NUMBER(28,4), 
	"LINKED_DOCS" VARCHAR2(50 BYTE), 
	"IS_ACCEPTED" VARCHAR2(1 BYTE), 
	"IS_DISPUTE_RESOLVED_WRITEOFF" VARCHAR2(1 BYTE), 
	"IS_OVERDUE" VARCHAR2(1 BYTE), 
	"OLD_ACCEPTANCE_AMT" NUMBER(28,4), 
	"OLD_EXPIRY_DATE" DATE, 
	"CHANNEL" VARCHAR2(10 BYTE), 
	"SOURCE_TXN_ID" VARCHAR2(40 BYTE), 
	"PAYMENT_DUE_DATE" DATE, 
	"FILLER_5" VARCHAR2(25 BYTE), 
	"FILLER_6" VARCHAR2(25 BYTE), 
	"FILLER_7" VARCHAR2(25 BYTE), 
	"FILLER_8" VARCHAR2(25 BYTE), 
	"FILLER_9" VARCHAR2(25 BYTE), 
	"FILLER_10" VARCHAR2(25 BYTE), 
	"VARIANCE_AMOUNT" NUMBER(28,4), 
	"ADJUSTMENT_REASON" VARCHAR2(2 BYTE)
   )';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'IDX_OB_INVOICE_TW_INV_NUM';

if (index_exists = 0) then
execute immediate 'CREATE INDEX "IDX_OB_INVOICE_TW_INV_NUM" ON "OB_INVOICE_TW" ("INVOICE_NUMBER")';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'IDX_OB_INVOICE_TW_PROC_STAT';

if (index_exists = 0) then
execute immediate 'CREATE INDEX "IDX_OB_INVOICE_TW_PROC_STAT" ON "OB_INVOICE_TW" ("INVOICE_PROCESS_STATUS")';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'IDX_OB_INVOICE_TW_TRANS_REF';

if (index_exists = 0) then
execute immediate 'CREATE INDEX "IDX_OB_INVOICE_TW_TRANS_REF" ON "OB_INVOICE_TW" ("TRANSACTION_REF_NO", "SEQ_NO")';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'OB_INVOICE_TW_PK';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX "OB_INVOICE_TW_PK" ON "OB_INVOICE_TW" ("ID", "SEQ_NO") ';
end if;
end;
