DECLARE
  table_exists NUMBER;
BEGIN
  SELECT COUNT(1)
  INTO table_exists
  FROM USER_TABLES
  WHERE table_name = 'OB_CHARGES_TXN';
  IF (table_exists = 0) THEN
    EXECUTE immediate 'CREATE TABLE OB_CHARGES_TXN
  (
    "ID" VARCHAR2(256 BYTE) NOT NULL ENABLE, 
	"TXN_REF_NO" VARCHAR2(50 BYTE) NOT NULL ENABLE, 
	"BRANCH_CODE" VARCHAR2(20 BYTE) NOT NULL ENABLE, 
	"CHG_CALC_DATE" DATE, 
	"APPLICATION_CODE" VARCHAR2(400 BYTE), 
	"CHARGE_CODE" VARCHAR2(3 BYTE), 
	"CHARGE_CODE_DESC" VARCHAR2(50 BYTE), 
	"CHARGE_AMOUNT" NUMBER(28,4), 
	"CHG_CCY" VARCHAR2(3 BYTE), 
	"CALC_ERROR_CODE" VARCHAR2(10 BYTE), 
	"POSTING_ERROR_CODE" VARCHAR2(10 BYTE), 
	"PARTY_ID" VARCHAR2(20 BYTE), 
	"CHG_CRITERIA_AMT_VALUE" NUMBER(28,4), 
	"CHG_CRITERIA_CCY" VARCHAR2(3 BYTE), 
	"CHG_CRITERIA_COUNT" VARCHAR2(10 BYTE), 
	"REFERENCE_START_DATE" DATE, 
	"REFERENCE_END_DATE" DATE, 
	"POSTING_DATE" DATE, 
	"CHARGE_GROUP" VARCHAR2(25 BYTE), 
	"CHARGE_CATEGORY" VARCHAR2(25 BYTE), 
	"CHARGE_TYPE" VARCHAR2(2 BYTE), 
	"CHG_SHARING" VARCHAR2(1 BYTE), 
	"PARTY_TO_CHG" VARCHAR2(6 BYTE) NOT NULL ENABLE, 
	"CHG_CRITERIA" VARCHAR2(25 BYTE) NOT NULL ENABLE, 
	"PARENT_CHG_CODE" VARCHAR2(3 BYTE), 
	"REF_TENOR_START_DT" VARCHAR2(25 BYTE) NOT NULL ENABLE, 
	"REF_TENOR_END_DT" VARCHAR2(25 BYTE) NOT NULL ENABLE, 
	"ALLOW_WAIVE" VARCHAR2(1 BYTE), 
	"AUTO_WAIVE" VARCHAR2(1 BYTE), 
	"ALLOW_OVERRIDE" VARCHAR2(1 BYTE), 
	"COLLECTION_TYPE" VARCHAR2(1 BYTE) NOT NULL ENABLE, 
	"COLL_FREQ" VARCHAR2(2 BYTE), 
	"COLL_REF_PERIOD" VARCHAR2(5 BYTE), 
	"COLL_UNITS" NUMBER(3,0), 
	"CALC_TYPE" VARCHAR2(1 BYTE) NOT NULL ENABLE, 
	"CALC_FREQ" VARCHAR2(2 BYTE), 
	"CALC_REF_PERIOD" VARCHAR2(5 BYTE), 
	"CALC_UNITS" NUMBER(3,0), 
	"CHG_PRC_TEMPLATE_ID" VARCHAR2(25 BYTE), 
	"CHG_PRC_DESC" VARCHAR2(50 BYTE), 
	"ALLOW_PRC_MODIFY" VARCHAR2(1 BYTE), 
	"EVENT_CODE" VARCHAR2(20 BYTE), 
	"PARTY_NAME" VARCHAR2(50 BYTE), 
	"EXCHANGE_RATE" NUMBER(28,4), 
	"INSTRUMENT_TYPE" VARCHAR2(50 BYTE), 
	"DEBIT_ACC_NO" VARCHAR2(25 BYTE), 
	"CREDIT_ACC_NO" VARCHAR2(25 BYTE), 
	"FIRST_CALC_DATE" DATE, 
	"NEXT_CALC_DATE" DATE, 
	"FIRST_COLL_DATE" DATE, 
	"NEXT_COLL_DATE" DATE, 
	"CHG_SHARING_PCT" NUMBER, 
	"NEXT_START_DATE" DATE, 
	"NEXT_END_DATE" DATE
  )';
  END IF;
END;