

declare table_exists number;
begin
select count(1) into table_exists from USER_TABLES where table_name = 'OBCM_TW_RELATIONSHIP_DETAILS';
if (table_exists = 0) then
execute immediate 'CREATE TABLE "OBCM_TW_RELATIONSHIP_DETAILS" 
   (	
   "MOD_NO" VARCHAR2(5 BYTE) NOT NULL ENABLE, 
	"AUTO_ACCEPTANCE" VARCHAR2(1 BYTE), 
	"COUNTERPARTYID" VARCHAR2(20 BYTE), 
	"ID" VARCHAR2(36 BYTE) NOT NULL ENABLE, 
	"PARTY_TYPE" VARCHAR2(5 BYTE), 
	"RELATIONSHIP_MASTER_ID" VARCHAR2(50 BYTE), 
	"EXPIRES_ON" DATE, 
	"NO_OF_DAYS" NUMBER, 
	"STATUS" VARCHAR2(2 BYTE), 
	"COUNTERPARTYNAME" VARCHAR2(50 BYTE), 
	"HOLIDAY_TREATMENT" CHAR(3 BYTE), 
	"AUTO_DEBIT_APPLICABLE" VARCHAR2(1 BYTE) , 
	"ALLOW_OVERDUE_RCV" VARCHAR2(1 BYTE), 
	"MAX_DAYS_OVERDUE" NUMBER(3,0), 
	"EXCESS_HANDLING" VARCHAR2(50 BYTE), 
	"EXCESS_REFUND_PARTY" VARCHAR2(20 BYTE), 
	"EXCESS_REFUND_PAYMENT_MODE" VARCHAR2(20 BYTE), 
	"EXCESS_REFUND_HANDLING" VARCHAR2(70 BYTE), 
	"EXCESS_PAYMENT_MODE" VARCHAR2(20 BYTE)
   )';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'PK_OBCM_TW_RELATIONSHIP_DETAILS';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX "PK_OBCM_TW_RELATIONSHIP_DETAILS" ON "OBCM_TW_RELATIONSHIP_DETAILS" ("ID", "MOD_NO")';
end if;
end;
/

declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'OBCM_TW_RELATIONSHIP_MASTER' and constraint_name = 'PK_OBCM_TW_RELATIONSHIP_MASTER';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE "OBCM_TW_RELATIONSHIP_DETAILS" ADD CONSTRAINT "PK_OBCM_TW_RELATIONSHIP_DETAILS" PRIMARY KEY ("ID", "MOD_NO")';
end if;
end;
/