declare table_exists number;
begin
select count(1) into table_exists from USER_TABLES where table_name = 'OBCM_TW_RELATIONSHIP_MASTER';
if (table_exists = 0) then
execute immediate 'CREATE TABLE "OBCM_TW_RELATIONSHIP_MASTER" 
   (	
    "ACTION" VARCHAR2(50 BYTE), 
	"KEY_ID" VARCHAR2(50 BYTE), 
	"CHECKER_REMARKS" VARCHAR2(200 BYTE), 
	"MAKER_REMARKS" VARCHAR2(200 BYTE), 
	"AUTH_STAT" VARCHAR2(1 BYTE), 
	"AUTO_ACCEPTANCE" VARCHAR2(1 BYTE), 
	"CHECKER_DT_STAMP" DATE, 
	"CHECKER_ID" VARCHAR2(12 BYTE), 
	"CORPORATE_ID" VARCHAR2(20 BYTE), 
	"EFF_FROM_DATE" DATE, 
	"ID" VARCHAR2(36 BYTE) NOT NULL ENABLE, 
	"MAKER_DT_STAMP" DATE, 
	"MAKER_ID" VARCHAR2(12 BYTE), 
	"MOD_NO" NUMBER(4,0) NOT NULL ENABLE, 
	"ONCE_AUTH" VARCHAR2(1 BYTE), 
	"RECORD_STAT" VARCHAR2(1 BYTE), 
	"RELATIONSHIP_CODE" VARCHAR2(20 BYTE), 
	"RELATIONSHIP_NAME" VARCHAR2(200 BYTE), 
	"EXPIRES_ON" DATE, 
	"PRODUCT" VARCHAR2(1 BYTE), 
	"NO_OF_DAYS" NUMBER, 
	"CORPORATE_NAME" VARCHAR2(50 BYTE), 
	"HOLIDAY_TREATMENT" CHAR(3 BYTE), 
	"AUTO_DEBIT_APPLICABLE" VARCHAR2(1 BYTE) , 
	"AUTO_PROCESSING" VARCHAR2(1 BYTE), 
	"AUTH_REQUIRED" VARCHAR2(1 BYTE), 
	"ALLOW_OVERDUE_RCV" VARCHAR2(1 BYTE) , 
	"MAX_DAYS_OVERDUE" NUMBER(3,0), 
	"EXCESS_HANDLING" VARCHAR2(50 BYTE), 
	"EXCESS_REFUND_PARTY" VARCHAR2(20 BYTE), 
	"EXCESS_REFUND_PAYMENT_MODE" VARCHAR2(20 BYTE), 
	"EXCESS_REFUND_HANDLING" VARCHAR2(70 BYTE), 
	"EXCESS_PAYMENT_MODE" VARCHAR2(20 BYTE)
   )';
end if;
end;
/
declare
index_exists number;
begin
select count(1) into index_exists from USER_INDEXES where index_name = 'PK_OBCM_TW_RELATIONSHIP_MASTER';

if (index_exists = 0) then
execute immediate 'CREATE UNIQUE INDEX PK_OBCM_TW_RELATIONSHIP_MASTER ON OBCM_TW_RELATIONSHIP_MASTER ("ID", "MOD_NO") ';
end if;
end;
/

declare
constraint_exists number;
begin
select count(1) into constraint_exists from USER_CONSTRAINTS where table_name = 'OBCM_TW_RELATIONSHIP_MASTER' and constraint_name = 'PK_OBCM_TW_RELATIONSHIP_MASTER';

if (constraint_exists = 0) then
execute immediate 'ALTER TABLE OBCM_TW_RELATIONSHIP_MASTER ADD CONSTRAINT PK_OBCM_TW_RELATIONSHIP_MASTER PRIMARY KEY ("ID", "MOD_NO")';
end if;
end;
/