declare table_exists number;
begin
select count(1) into table_exists from USER_TABLES where table_name = 'OB_PURCHASE_ORDER_TW';

if (table_exists = 0) then
execute immediate
  'CREATE TABLE "OB_PURCHASE_ORDER_TW"
   (    "PO_EXTERNAL_NUMBER" VARCHAR2(25 BYTE) NOT NULL ENABLE,
	"PO_INTERNAL_NUMBER" VARCHAR2(36 BYTE) NOT NULL ENABLE,
	"PO_DATE" DATE,
	"RELATIONSHIP_CODE" VARCHAR2(20 BYTE),
	"RELATIONSHIP_NAME" VARCHAR2(200 BYTE),
	"CURRENCY" VARCHAR2(10 BYTE),
	"BUYER_ID" VARCHAR2(20 BYTE),
	"BUYER_NAME" VARCHAR2(200 BYTE),
	"PROGRAM_ID" VARCHAR2(20 BYTE),
	"PROGRAM_NAME" VARCHAR2(200 BYTE),
	"SUPPLIER_ID" VARCHAR2(20 BYTE),
	"SUPPLIER_NAME" VARCHAR2(200 BYTE),
	"SUPPLIER_DIV_CODE" VARCHAR2(20 BYTE),
	"SUPPLIER_DIV_NAME" VARCHAR2(200 BYTE),
	"BUYER_DIV_CODE" VARCHAR2(20 BYTE),
	"BUYER_DIV_NAME" VARCHAR2(200 BYTE),
	"REMARKS" VARCHAR2(40 BYTE),
	"FILE_REF_NAME" VARCHAR2(70 BYTE),
	"PO_STATUS" VARCHAR2(20 BYTE),
	"PROCESS_STATUS" VARCHAR2(20 BYTE),
	"REASON_CODE" VARCHAR2(200 BYTE),
	"MAKER_ID" VARCHAR2(12 BYTE),
	"MAKER_DT_STAMP" DATE,
	"MAKER_REMARKS" VARCHAR2(200 BYTE),
	"CHECKER_ID" VARCHAR2(12 BYTE),
	"CHECKER_DT_STAMP" DATE,
	"CHECKER_REMARKS" VARCHAR2(200 BYTE),
	"RECORD_STAT" VARCHAR2(1 BYTE),
	"PO_TRANSACTION_REF_NO" VARCHAR2(36 BYTE),
	"TERMS_OF_SALE" VARCHAR2(5 BYTE),
	"PAYMENT_TERMS" VARCHAR2(50 BYTE),
	"COUNTRY_OF_ORIGIN" VARCHAR2(20 BYTE),
	"MISC_CHRG_1_DESC" VARCHAR2(20 BYTE),
	"MISC_CHRG_1_AMT" NUMBER(28,4),
	"MISC_CHRG_2_DESC" VARCHAR2(20 BYTE),
	"MISC_CHRG_2_AMT" NUMBER(28,4),
	"BASE_PO_AMOUNT" NUMBER(28,4),
	"DISCOUNT_AMOUNT" NUMBER(28,4),
	"DISCOUNT_PERCENT" NUMBER(28,4),
	"TAX_AMOUNT" NUMBER(28,4),
	"TAX_PERCENT" NUMBER(28,4),
	"TOTAL_PO_AMOUNT" NUMBER(28,4),
	"NET_PO_AMOUNT" NUMBER(28,4),
	"PRE_ACCEPTED" VARCHAR2(1 BYTE),
	"FILLER1" VARCHAR2(25 BYTE),
	"FILLER2" VARCHAR2(25 BYTE),
	"FILLER3" VARCHAR2(25 BYTE),
	"FILLER4" VARCHAR2(25 BYTE),
	"VERSION" NUMBER,
	"ACCEPTANCE_AMOUNT" NUMBER(28,4),
	"FUNDING_REQUEST_AMOUNT" NUMBER(28,4),
	"ACCEPTANCE_DATE" DATE,
	"STALE_STATUS" VARCHAR2(1 BYTE),
	"FILLER5" VARCHAR2(25 BYTE),
	"FILLER6" VARCHAR2(25 BYTE),
	"SEQ_NO" NUMBER,
	"IS_CHAGE_CALC" VARCHAR2(1 BYTE),
	"REASON_FOR_EXPORT" VARCHAR2(50 BYTE),
	"OLD_ACCEPTANCE_AMOUNT" NUMBER(28,4),
	"CHANNEL" VARCHAR2(50 BYTE),
	"SOURCE_TXN_ID" VARCHAR2(40 BYTE),
	"PO_AVAILABLE_AMT" NUMBER(28,4),
	"SHIPMENT_COUNTRY" VARCHAR2(3 BYTE),
	"FUNDING_REQ_DATE" DATE,
	"NEW_FUNDING_REQ_DATE" DATE,
	"EDIT_INFO" CLOB,
	"PO_ID" VARCHAR2(40 BYTE)
	 )';
  execute immediate
    'ALTER TABLE OB_PURCHASE_ORDER_TW ADD CONSTRAINT "PK_OB_PURCHASE_ORDER_TW" PRIMARY KEY ("PO_INTERNAL_NUMBER", "SEQ_NO")';
 end if;
end;