package oracle.fsgbu.customer.test.assembler

import org.mockito.Mockito

import lombok.Data
import oracle.fsgbu.eventService.api.model.CNLinkedInvoiceModel
import oracle.fsgbu.eventService.api.model.CnCommodityGridModel
import oracle.fsgbu.eventService.api.model.InvoiceCommodityGridModel
import oracle.fsgbu.eventService.api.model.LinkedInvoiceModel
import oracle.fsgbu.eventService.api.model.TmDrCrNoteLinkInvoiceModel
import oracle.fsgbu.eventService.api.model.InvoiceDto
import oracle.fsgbu.eventService.api.model.InvoiceModel
import oracle.fsgbu.eventService.api.model.InvoiceOfferDTO
import avro.oracle.fsgbu.obscf.invoicing.dto.UpdateInvoiceCommodityGridDto
import avro.oracle.fsgbu.obscf.invoicing.dto.UpdateDrCrNoteLinkInvoiceDto
import oracle.fsgbu.obscfcm.services.report.assembler.ScfInvoiceAssembler
import oracle.fsgbu.obscfcm.services.report.assembler.ScfTmCreditNoteAssembler
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmInvoice
import oracle.fsgbu.obscfcm.services.report.domain.entity.TmCnCommodityGrid
import oracle.fsgbu.obscfcm.services.report.domain.entity.TmInvoiceOfferParameters
import spock.lang.Shared
import spock.lang.Specification;
import spock.lang.Unroll;

@Data
class ScfTmCreditNoteAssemblerSpec extends Specification{
	
  @Shared mockDate = new String("2019-08-12");
  @Shared mockAmount = new BigDecimal("123456");
  @Shared mockString = new String("Test Data");
  @Shared discountPercentage = new BigDecimal("88");
	
	

  @Unroll("test convertInvocieCommGridEntityListToVOList method")
  def"test convertInvocieCommGridEntityListToVOList method"(){
		
	  given:
	  CnCommodityGridModel vo = new CnCommodityGridModel()
	 def list = new ArrayList()
	 list.add(vo)
		
	  ScfTmCreditNoteAssembler assembler = new ScfTmCreditNoteAssembler()
	  when:
	  def resp =assembler.convertInvocieCommGridEntityListToVOList(list)
	 then:
	 resp == resp
  }
  
  @Unroll("test convertInvocieCommGridEntityListToVOList method")
  def"test convertInvocieCommGridEntityListToVOList method1"(){
		
	  given:
	  CnCommodityGridModel vo = new CnCommodityGridModel()
	  vo.setDiscountPercentage(BigDecimal.ZERO)
	  vo.setNetCost(BigDecimal.ZERO)
	  vo.setQuantity(BigDecimal.ZERO)
	  vo.setTaxAmount(BigDecimal.ZERO)
	  vo.setTaxPercentage(BigDecimal.ZERO)
	  vo.setCostPerUnit(BigDecimal.ZERO)
	  vo.setTotalCost(BigDecimal.ZERO)
	  vo.setTotalWeight(BigDecimal.ZERO)
	  vo.setUnitWeight(BigDecimal.ZERO)
	 def list = new ArrayList()
	 list.add(vo)
		
	  ScfTmCreditNoteAssembler assembler = new ScfTmCreditNoteAssembler()
	  when:
	   def resp = assembler.convertInvocieCommGridEntityListToVOList(list)
	   then:
	   resp == resp
	
  }
  
  def"test convertLinkedInvoiceVOToEntity method"(){
	  
	given:
	CNLinkedInvoiceModel vo = new CNLinkedInvoiceModel()
   def list = new ArrayList()
   list.add(vo)
	  
	ScfTmCreditNoteAssembler assembler = new ScfTmCreditNoteAssembler()
	when:
	def resp =assembler.convertLinkedInvoiceVOListToEntityList(list)
   then:
   resp == resp
}
   
}