package oracle.fsgbu.customer.test.client

import oracle.fsgbu.accountMaintenance.api.model.*
import oracle.fsgbu.obscfcm.services.report.client.AccountMaintenanceServiceClientImpl
import oracle.fsgbu.obscfcm.services.report.constants.ReportConstants
import org.springframework.http.ResponseEntity
import org.springframework.web.client.RestTemplate
import spock.lang.Specification
import spock.lang.Unroll

class AccountMaintenanceServiceClientImplSpec extends Specification {
    RestTemplate restTemplate = Mock()
    AccountMaintenanceServiceClientImpl instance = new AccountMaintenanceServiceClientImpl(restTemplate)

    private void setupResponse(ResponseEntity<RoleWebModel> response, Object model) {
        restTemplate.exchange(_, _, _, _, _) >> response
        response.getBody() >> model
    }
	
	
	private void setupResponse() {
		restTemplate.exchange(_, _, _, _, _) >> {throw  Exception}; 
		
	}


    @Unroll("test getAccountRoleTWData method")
    def "test getAccountRoleTWData method"() {
        given:
        ResponseEntity<RoleWebModel> response = Mock()
        RoleWebModel model = new RoleWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getAccountRoleTWData("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getAccountRoleTWData method negative case")
    def "test getAccountRoleTWData method negative case"() {
        given:
        ResponseEntity<RoleWebModel> response = Mock()
        RoleWebModel model = new RoleWebModel()
        when:
        def res = instance.getAccountRoleTWData("refNo", "userId", "branchCode")
        then:
        res == null
    }

    @Unroll("test getAccountRoleTMData method")
    def "test getAccountRoleTMData method"() {
        given:
        ResponseEntity<RoleWebModel> response = Mock()
        RoleWebModel model = new RoleWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getAccountRoleTMData("refNo", "userId", "branchCode")
        then:
        res != null
    }
	
	@Unroll("test getAccountRoleTWData method exception")
	def "test getAccountRoleTWData method exception"() {
		given:
		ResponseEntity<RoleWebModel> response = Mock()
		setupResponse()
		when:

		def res = instance.getAccountRoleTWData("refNo", "userId", "branchCode")
		then:
		res == null
	}

	@Unroll("test getAccountRoleTMData method")
	def "test getAccountRoleTMData method"() {
		given:
		ResponseEntity<RoleWebModel> response = Mock()
		RoleWebModel model = new RoleWebModel()
		setupResponse(response, model)
		when:
		def res = instance.getAccountRoleTMData("refNo", "userId", "branchCode")
		then:
		res != null
	}

    @Unroll("test getAccountRoleTMData method negative")
    def "test getAccountRoleTMData method negative"() {
        given:
        ResponseEntity<RoleWebModel> response = Mock()
        RoleWebModel model = new RoleWebModel()
        when:
        def res = instance.getAccountRoleTMData("refNo", "userId", "branchCode")
        then:
        res == null
    }
	
	@Unroll("test getAccountRoleTMData method exception")
	def "test getAccountRoleTMData method exception"() {
		given:
		ResponseEntity<RoleWebModel> response = Mock()
		setupResponse()
		when:
		def res = instance.getAccountRoleTMData("refNo", "userId", "branchCode")
		then:
		res == null
	}

    @Unroll("test getAccountEntryTWData method")
    def "test getAccountEntryTWData method"() {
        given:
        ResponseEntity<AccentryWebModel> response = Mock()
        AccentryWebModel model = new AccentryWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getAccountEntryTWData("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getAccountEntryTWData method negative")
    def "test getAccountEntryTWData method negative"() {
        given:
        ResponseEntity<AccentryWebModel> response = Mock()
        AccentryWebModel model = new AccentryWebModel()
        when:
        def res = instance.getAccountEntryTWData("refNo", "userId", "branchCode")
        then:
        res == null
    }
	@Unroll("test getAccountEntryTWData method exception")
	def "test getAccountEntryTWData method exception"() {
		given:
		ResponseEntity<AccentryWebModel> response = Mock()
		setupResponse()
		when:
		def res = instance.getAccountEntryTWData("refNo", "userId", "branchCode")
		then:
		res == null
	}

    @Unroll("test getAccountEntryTMData method")
    def "test getAccountEntryTMData method"() {
        given:
        ResponseEntity<AccentryWebModel> response = Mock()
        AccentryWebModel model = new AccentryWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getAccountEntryTMData("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getAccountEntryTMData method negative")
    def "test getAccountEntryTMData method negative"() {
        given:
        ResponseEntity<AccentryWebModel> response = Mock()
        AccentryWebModel model = new AccentryWebModel()
        when:
        def res = instance.getAccountEntryTMData("refNo", "userId", "branchCode")
        then:
        res == null
    }
	
	@Unroll("test getAccountEntryTMData method exception")
	def "test getAccountEntryTMData method exception"() {
		given:
		ResponseEntity<AccentryWebModel> response = Mock()
        setupResponse()
		when:
		def res = instance.getAccountEntryTMData("refNo", "userId", "branchCode")
		then:
		res == null
	}

    @Unroll("test getAccountEntryCodeTWData method")
    def "test getAccountEntryCodeTWData method"() {
        given:
        ResponseEntity<AccentrycodeWebModel> response = Mock()
        AccentrycodeWebModel model = new AccentrycodeWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getAccountEntryCodeTWData("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getAccountEntryCodeTWData method negative")
    def "test getAccountEntryCodeTWData method negative"() {
        given:
        ResponseEntity<AccentrycodeWebModel> response = Mock()
        AccentrycodeWebModel model = new AccentrycodeWebModel()
        when:
        def res = instance.getAccountEntryCodeTWData("refNo", "userId", "branchCode")
        then:
        res == null
    }

	@Unroll("test getAccountEntryCodeTWData exception")
	def "test getAccountEntryCodeTWData exception"() {
		given:
		ResponseEntity<AccentrycodeWebModel> response = Mock()
		setupResponse()
		when:
		def res = instance.getAccountEntryCodeTWData("refNo", "userId", "branchCode")
		then:
		res == null
	}

	
    @Unroll("test getAccountEntryCodeTMData method")
    def "test getAccountEntryCodeTMData method"() {
        given:
        ResponseEntity<AccentrycodeWebModel> response = Mock()
        AccentrycodeWebModel model = new AccentrycodeWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getAccountEntryCodeTMData("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getAccountEntryCodeTMData method negative")
    def "test getAccountEntryCodeTMData method negative"() {
        given:
        ResponseEntity<AccentrycodeWebModel> response = Mock()
        AccentrycodeWebModel model = new AccentrycodeWebModel()
        when:
        def res = instance.getAccountEntryCodeTMData("refNo", "userId", "branchCode")
        then:
        res == null
    }

	
	@Unroll("test getAccountEntryCodeTMData exception")
	def "test getAccountEntryCodeTMData exception"() {
		given:
		ResponseEntity<AccentrycodeWebModel> response = Mock()
		setupResponse()
		when:
		def res = instance.getAccountEntryCodeTMData("refNo", "userId", "branchCode")
		then:
		res == null
	}

	
    @Unroll("test getInternalAccountMapTWData method")
    def "test getInternalAccountMapTWData method"() {
        given:
        ResponseEntity<IntaccmapWebModel> response = Mock()
        IntaccmapWebModel model = new IntaccmapWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getInternalAccountMapTWData("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getInternalAccountMapTWData method negative")
    def "test getInternalAccountMapTWData method negative"() {
        given:
        ResponseEntity<IntaccmapWebModel> response = Mock()
        IntaccmapWebModel model = new IntaccmapWebModel()
        when:
        def res = instance.getInternalAccountMapTWData("refNo", "userId", "branchCode")
        then:
        res == null
    }
	
	@Unroll("test getInternalAccountMapTWData method exception")
	def "test getInternalAccountMapTWData method exception"() {
		given:
		ResponseEntity<IntaccmapWebModel> response = Mock()
		setupResponse()
		when:
		def res = instance.getInternalAccountMapTWData("refNo", "userId", "branchCode")
		then:
		res == null
	}

    @Unroll("test getInternalAccountMapTMData method")
    def "test getInternalAccountMapTMData method"() {
        given:
        ResponseEntity<IntaccmapWebModel> response = Mock()
        IntaccmapWebModel model = new IntaccmapWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getInternalAccountMapTMData("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getInternalAccountMapTMData method negative")
    def "test getInternalAccountMapTMData method negative"() {
        given:
        ResponseEntity<IntaccmapWebModel> response = Mock()
        IntaccmapWebModel model = new IntaccmapWebModel()
        when:
        def res = instance.getInternalAccountMapTMData("refNo", "userId", "branchCode")
        then:
        res == null
    }
	
	@Unroll("test getInternalAccountMapTMData method exceptoon")
	def "test getInternalAccountMapTMData method exceptoon"() {
		given:
		ResponseEntity<IntaccmapWebModel> response = Mock()
setupResponse()
		when:
		def res = instance.getInternalAccountMapTMData("refNo", "userId", "branchCode")
		then:
		res == null
	}

    @Unroll("test getExternalAccountMapTWData method")
    def "test getExternalAccountMapTWData method"() {
        given:
        ResponseEntity<ExternalWebModel> response = Mock()
        ExternalWebModel model = new ExternalWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getExternalAccountMapTWData("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getExternalAccountMapTWData method negative")
    def "test getExternalAccountMapTWData method negative"() {
        given:
        ResponseEntity<ExternalWebModel> response = Mock()
        ExternalWebModel model = new ExternalWebModel()
        when:
        def res = instance.getExternalAccountMapTWData("refNo", "userId", "branchCode")
        then:
        res == null
    }
	
	@Unroll("test getExternalAccountMapTWData method exception")
	def "test getExternalAccountMapTWData method exception"() {
		given:
		ResponseEntity<ExternalWebModel> response = Mock()
setupResponse()
		when:
		def res = instance.getExternalAccountMapTWData("refNo", "userId", "branchCode")
		then:
		res == null
	}

    @Unroll("test getExternalAccountMapTMData method")
    def "test getExternalAccountMapTMData method"() {
        given:
        ResponseEntity<ExternalWebModel> response = Mock()
        ExternalWebModel model = new ExternalWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getExternalAccountMapTMData("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getExternalAccountMapTMData method negative")
    def "test getExternalAccountMapTMData method negative"() {
        given:
        ResponseEntity<ExternalWebModel> response = Mock()
        ExternalWebModel model = new ExternalWebModel()
        when:
        def res = instance.getExternalAccountMapTMData("refNo", "userId", "branchCode")
        then:
        res == null
    }
	
	@Unroll("test getExternalAccountMapTMData method exception")
	def "test getExternalAccountMapTMData method exception"() {
		given:
		ResponseEntity<ExternalWebModel> response = Mock()
setupResponse()
		when:
		def res = instance.getExternalAccountMapTMData("refNo", "userId", "branchCode")
		then:
		res == null
	}

    @Unroll("test getAccountingDataByFinRefNo method")
    def "test getAccountingDataByFinRefNo method"() {
        given:
        ResponseEntity<AccountingTransactionCollection> response = Mock()
        AccountingTransactionCollection model = new AccountingTransactionCollection()
        setupResponse(response, model)
        when:
        def res1 = instance.getAccountingDataByFinRefNo("userId", "branchCode", "refNo", ReportConstants.AUTHORIZED)
        def res2 = instance.getAccountingDataByFinRefNo("userId", "branchCode", "refNo", ReportConstants.UNAUTHORIZED)
        then:
        res1 != null && res2 != null
    }

    @Unroll("test getAccountingDataByFinRefNo method negative")
    def "test getAccountingDataByFinRefNo method negative"() {
        given:
        ResponseEntity<AccountingTransactionCollection> response = Mock()
        AccountingTransactionCollection model = new AccountingTransactionCollection()
        when:
        def res1 = instance.getAccountingDataByFinRefNo("userId", "branchCode", "refNo", ReportConstants.AUTHORIZED)
        def res2 = instance.getAccountingDataByFinRefNo("userId", "branchCode", "refNo", ReportConstants.UNAUTHORIZED)
        then:
        res1 == null && res2 == null
    }
	
	@Unroll("test getAccountingDataByFinRefNo method exception")
	def "test getAccountingDataByFinRefNo method exception"() {
		given:
		ResponseEntity<AccountingTransactionCollection> response = Mock()
		setupResponse()
		when:
		def res1 = instance.getAccountingDataByFinRefNo("userId", "branchCode", "refNo", ReportConstants.AUTHORIZED)
		then:
		res1 ==null
	}
}
