package oracle.fsgbu.customer.test.client

import org.springframework.http.ResponseEntity
import org.springframework.web.client.RestTemplate

import oracle.fsgbu.eventService.api.model.FileUploadDto
import oracle.fsgbu.eventService.api.model.InvoiceDto;
import oracle.fsgbu.eventService.api.model.PaymentDto;
import oracle.fsgbu.eventService.api.model.CreditNoteModel;
import oracle.fsgbu.obscfcm.services.report.client.EventServiceClientImpl
import spock.lang.Specification
import spock.lang.Unroll

class EventServiceClientImplSpec extends Specification{

	def restTemplate = Mock(RestTemplate)

	@Unroll("test saveInvoiceData method")
	def"test saveProductsData"(){
		given:
		InvoiceDto invoiceDto = new InvoiceDto()
		def restTemplate = Mock(RestTemplate);
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true);
		restTemplate.exchange(_,_,_,_)>>responseEntity;
		EventServiceClientImpl client = new EventServiceClientImpl(restTemplate)

		when:
		def response = client.saveInvoiceData(invoiceDto,"DEV", "004")
		then:
		response != null;
	}

	@Unroll("test saveInvoiceDataWithException method")
	def"test saveProductsDataWithException"(){
		given:
		InvoiceDto invoiceDto = new InvoiceDto()
		def restTemplate = Mock(RestTemplate);
		restTemplate.exchange(_,_,_,_)>>new Exception();
		EventServiceClientImpl client = new EventServiceClientImpl(restTemplate)

		when:
		def response = client.saveInvoiceData(invoiceDto,"DEV", "004")
		then:
		response == response;
	}
	
	@Unroll("test saveUploadedFileData method")
	def"test saveUploadedFileData"(){
		given:
		FileUploadDto fileDto = new FileUploadDto()
		def restTemplate = Mock(RestTemplate);
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true);
		restTemplate.exchange(_,_,_,_)>>responseEntity;
		EventServiceClientImpl client = new EventServiceClientImpl(restTemplate)

		when:
		def response = client.saveUploadedFileData(fileDto,"DEV", "004")
		then:
		response != null;
	}
	
	@Unroll("test saveUploadedFileDataWithException method")
	def"test saveUploadedFileDataWithException"(){
		given:
		FileUploadDto fileDto = new FileUploadDto()
		def restTemplate = Mock(RestTemplate);
		restTemplate.exchange(_,_,_,_)>>new Exception();
		EventServiceClientImpl client = new EventServiceClientImpl(restTemplate)

		when:
		def response = client.saveUploadedFileData(fileDto,"DEV", "004")
		then:
		response == response;
	}

	@Unroll("test savePaymentData method")
	def"test savePaymentData"(){
		given:
		PaymentDto paymentDto = new PaymentDto()
		def restTemplate = Mock(RestTemplate);
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true);
		restTemplate.exchange(_,_,_,_)>>responseEntity;
		EventServiceClientImpl client = new EventServiceClientImpl(restTemplate)

		when:
		def response = client.savePaymentData(paymentDto,"DEV", "004")
		then:
		response != null;
	}

	@Unroll("test savePaymentDataWithException method")
	def"test savePaymentDataWithException"(){
		given:
		PaymentDto paymentDto = new PaymentDto()
		def restTemplate = Mock(RestTemplate);
		restTemplate.exchange(_,_,_,_)>>new Exception();
		EventServiceClientImpl client = new EventServiceClientImpl(restTemplate)

		when:
		def response = client.savePaymentData(paymentDto,"DEV", "004")
		then:
		response == response;
	}
	
	@Unroll("test saveCreditNote method")
	def"test saveCreditNote"(){
		given:
		CreditNoteModel creditNoteModel = new CreditNoteModel()
		def restTemplate = Mock(RestTemplate);
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true);
		restTemplate.exchange(_,_,_,_)>>responseEntity;
		EventServiceClientImpl client = new EventServiceClientImpl(restTemplate)

		when:
		def response = client.saveCreditNote(creditNoteModel,"DEV", "004")
		then:
		response != null;
	}

	@Unroll("test saveCreditNoteWithException method")
	def"test saveCreditNoteWithException"(){
		given:
		CreditNoteModel creditNoteModel = new CreditNoteModel()
		def restTemplate = Mock(RestTemplate);
		restTemplate.exchange(_,_,_,_)>>new Exception();
		EventServiceClientImpl client = new EventServiceClientImpl(restTemplate)

		when:
		def response = client.saveCreditNote(creditNoteModel,"DEV", "004")
		then:
		response == response;
	}

}