package oracle.fsgbu.customer.test.client

import org.springframework.http.ResponseEntity
import org.springframework.web.client.RestTemplate

import oracle.fsgbu.obscfcm.services.report.client.InstrumentReceivablesServiceClientImpl
import spock.lang.Specification
import spock.lang.Unroll
import oracle.fsgbu.eventService.api.model.AutoDebitTxnCollection;
import oracle.fsgbu.eventService.api.model.InvoiceCollectionDto;
import oracle.fsgbu.eventService.api.model.PaymentCollectionDto;import static org.springframework.http.ResponseEntity.ok;



class InstrumentReceivablesServiceClientImplSpec extends Specification{

	def restTemplate = Mock(RestTemplate)

	@Unroll("test getInvoiceByTxnRefNo method")
	def "test getInvoiceByTxnRefNo method"() {
		given:
		def restTemplate = Mock(RestTemplate)
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		when:
		def response = service.getInvoiceByTxnRefNo("transactionRefNo","user","004")
		then:
		response == null
	}

	
	@Unroll("test getInvoiceByTxnRefNo method1")
	def "test getInvoiceByTxnRefNo method1"() {
		given:
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		
		def icd = new InvoiceCollectionDto();
		ResponseEntity<InvoiceCollectionDto> responseEntity = ok(icd);
		def restTemplate = Mock(RestTemplate)
		restTemplate.exchange(_,_,_,_,_)>> responseEntity;
		service.restTemplate = restTemplate
		
		when:
		def response = service.getInvoiceByTxnRefNo("transactionRefNo","user","004")
		then:
		response != null
	}

	@Unroll("test getInvoiceByTxnRefNo method2")
	def "test getInvoiceByTxnRefNo method2"() {
		given:
		def restTemplate = Mock(RestTemplate)
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		restTemplate.exchange(_,_,_,_,_)>>  {throw  Exception};
		when:
		def response = service.getInvoiceByTxnRefNo("transactionRefNo","user","004")
		then:
		response == null
	}


	@Unroll("test getAutoDebitTxns method")
	def "test getAutoDebitTxns method"() {
		given:
		def restTemplate = Mock(RestTemplate)
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		restTemplate.exchange(_,_,_,_,_)>> ok(null);
		
		service.restTemplate = restTemplate
		
		when:
		def response = service.getAutoDebitTxns("user","004","123")
		then:
		response == null
	}


	@Unroll("test getAutoDebitTxns method")
	def "test getAutoDebitTxns method1"() {
		given:
		def icd = new AutoDebitTxnCollection();
		ResponseEntity<AutoDebitTxnCollection> responseEntity = ok(icd);
		def restTemplate = Mock(RestTemplate)
		restTemplate.exchange(_,_,_,_,_)>> responseEntity;
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		
		service.restTemplate = restTemplate
		
		when:
		def response = service.getAutoDebitTxns("user","004","123")
		then:
		response != null
	}
	
	@Unroll("test getAutoDebitTxns method")
	def "test getAutoDebitTxns method2"() {
		given:
		def restTemplate = Mock(RestTemplate)
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		restTemplate.exchange(_,_,_,_,_)>>  {throw  Exception};
		service.restTemplate = restTemplate
		
				when:
		def response = service.getAutoDebitTxns("user","004","123")
		then:
		response == null
	}
	

	@Unroll("test getInvoiceMaintByTxnRefNo method")
	def "test getInvoiceMaintByTxnRefNo method3"() {
		given:
			def restTemplate = Mock(RestTemplate)
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		restTemplate.exchange(_,_,_,_,_)>>  {throw  Exception};
		service.restTemplate = restTemplate
		
		when:
		def response = service.getInvoiceMaintByTxnRefNo("123","user","004")
		then:
		response == null
	}

	
		
	@Unroll("test getInvoiceMaintByTxnRefNo method")
	def "test getInvoiceMaintByTxnRefNo method"() {
		given:
		def restTemplate = Mock(RestTemplate)
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		restTemplate.exchange(_,_,_,_,_)>> ok(null)
		service.restTemplate = restTemplate
		
		when:
		def response = service.getInvoiceMaintByTxnRefNo("123","user","004")
		then:
		response == null
	}

	
	@Unroll("test getInvoiceMaintByTxnRefNo method1")
	def "test getInvoiceMaintByTxnRefNo method1"() {
		
		given:
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		
		def icd = new InvoiceCollectionDto();
		ResponseEntity<InvoiceCollectionDto> responseEntity = ok(icd);
		def restTemplate = Mock(RestTemplate)
		restTemplate.exchange(_,_,_,_,_)>> responseEntity;
		service.restTemplate = restTemplate

		when:
		def response = service.getInvoiceMaintByTxnRefNo("123","user","004")
		then:
		response != null
	}

	@Unroll("test getPaymentByPayRefNo method")
	def "test getPaymentByPayRefNo method"() {
		given:
		def restTemplate = Mock(RestTemplate)
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		service.restTemplate = restTemplate
		when:
		def response = service.getPaymentByPayRefNo("123","user","004")
		then:
		response == null
	}
	
	@Unroll("test getPaymentByPayRefNo method")
	def "test getPaymentByPayRefNo method1"() {
		given:
		def restTemplate = Mock(RestTemplate)
		def icd = new PaymentCollectionDto();
		ResponseEntity<PaymentCollectionDto> responseEntity = ok(icd);
		restTemplate.exchange(_,_,_,_,_)>> responseEntity;
		
		
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		service.restTemplate = restTemplate
		
		when:
		def response = service.getPaymentByPayRefNo("123","user","004")
		then:
		response != null
	}
	
	
	@Unroll("test getPaymentByPayRefNo method")
	def "test getPaymentByPayRefNo method2"() {
			given:
		def restTemplate = Mock(RestTemplate)
	//	def icd = new PaymentCollectionDto();
		ResponseEntity<PaymentCollectionDto> responseEntity = ok(null);
		
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		service.restTemplate = restTemplate
		
		when:
		def response = service.getPaymentByPayRefNo("123","user","004")
		then:
		response == null
	}

	@Unroll("test getPaymentTwByPayRefNo method")
	def "test getPaymentTwByPayRefNo method"() {
		given:
		def restTemplate = Mock(RestTemplate)
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		service.restTemplate = restTemplate
		
		when:
		def response = service.getPaymentTwByPayRefNo("123","user","004")
		then:
		response == null
	}
	
	@Unroll("test getPaymentTwByPayRefNo method")
	def "test getPaymentTwByPayRefNo method1"() {
		given:
		def restTemplate = Mock(RestTemplate)
	//    def icd = new PaymentCollectionDto();
		ResponseEntity<PaymentCollectionDto> responseEntity = ok(null);
		
		InstrumentReceivablesServiceClientImpl service = new InstrumentReceivablesServiceClientImpl(restTemplate)
		service.restTemplate = restTemplate
		
		when:
		def response = service.getPaymentTwByPayRefNo("123","user","004")
		then:
		response == null
	}
}