package oracle.fsgbu.customer.test.client

import oracle.fsgbu.accountMaintenance.api.model.*
import oracle.fsgbu.obscfcm.services.report.client.AccountMaintenanceServiceClientImpl
import oracle.fsgbu.obscfcm.services.report.client.ObscfcmCoreServiceClientImpl
import oracle.fsgbu.obscfcm.services.report.constants.ReportConstants

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity
import org.springframework.web.client.HttpStatusCodeException
import org.springframework.web.client.RestTemplate
import spock.lang.Specification
import spock.lang.Unroll
import oracle.fsgbu.obscfcm.services.scfcm.dto.RelationshipmasterWebModel;


class ObscfcmCoreServiceClientImplSpec extends Specification {
    RestTemplate restTemplate = Mock()
    ObscfcmCoreServiceClientImpl instance = new ObscfcmCoreServiceClientImpl(restTemplate)

    private void setupResponse(ResponseEntity<RelationshipmasterWebModel> response, Object model) {
        restTemplate.exchange(_, _, _, _) >> response
        response.getBody() >> model
    }
	
	
	private void setupResponse(int value) {
		def httpStatusCodeException = Mock(HttpStatusCodeException)
		
		if(value == 1)
		restTemplate.exchange(_, _, _, _) >> {throw  Exception}; 
			restTemplate.exchange(_, _, _, _) >> {throw  httpStatusCodeException};
			
		if(value ==3)	{
			httpStatusCodeException.getStatusCode()>>HttpStatus.NOT_FOUND
				restTemplate.exchange(_, _, _, _) >> {throw  httpStatusCodeException};
			}
	}

	

    @Unroll("test getByResourceId method")
    def "test getByResourceId method"() {
        given:
        ResponseEntity<RelationshipmasterWebModel> response = Mock()
        RelationshipmasterWebModel model = new RelationshipmasterWebModel()
        setupResponse(response, model)
        when:
        def res = instance.getByResourceId("refNo", "userId", "branchCode")
        then:
        res != null
    }

    @Unroll("test getByResourceId method negative case")
    def "test getByResourceId method negative case"() {
        given:
        restTemplate.exchange(_, _, _, _) >> null
		
        when:
        def res = instance.getByResourceId("refNo", "userId", "branchCode")
        then:
        res == null
    }

    @Unroll("test getByResourceId method")
    def "test getByResourceId method1"() {
        given:
        setupResponse(1)
        when:
        def res = instance.getByResourceId("refNo", "userId", "branchCode")
        then:
	   final Exception exception = thrown()
    }
	
	
	@Unroll("test getByResourceId method")
	def "test getByResourceId method2"() {
		given:
		setupResponse(2)
		when:
		def res = instance.getByResourceId("refNo", "userId", "branchCode")
		then:
	   final Exception exception = thrown()
	}
	
	@Unroll("test getByResourceId method")
	def "test getByResourceId method3"() {
		given:
		setupResponse(3)
		when:
		def res = instance.getByResourceId("refNo", "userId", "branchCode")
		then:
	   final Exception exception = thrown()
	}
}
