package oracle.fsgbu.customer.test.client

import java.sql.Timestamp
import java.time.LocalDate

import org.springframework.http.ResponseEntity
import org.springframework.web.client.RestTemplate
import oracle.fsgbu.gus.response.service.ResponseHandler
import oracle.fsgbu.obscfcm.services.report.client.EventServiceClientImpl
import oracle.fsgbu.obscfcm.services.report.client.ReconEventServiceClientImpl
import oracle.fsgbu.obscfcm.services.report.client.CmcBranchServiceClient
import oracle.fsgbu.obscfcm.services.report.client.CmcCurrencyServiceClient
import oracle.fsgbu.obscfcm.services.report.model.CurrencyRateCalculatorDtoWrapper
import oracle.fsgbu.obscfcm.services.report.model.CurrencyUtilityDto
import oracle.fsgbu.obscfcm.services.report.util.ReportingUtil
import oracle.fsgbu.reconService.api.model.ExpDrCrPmtReconDTO
import oracle.fsgbu.reconService.api.model.FinPmtReconDTO
import oracle.fsgbu.reconService.api.model.InvCnReconDTO
import oracle.fsgbu.reconService.api.model.InvPmtReconDTO
import oracle.fsgbu.reconService.api.model.PmtAllocDTO
import oracle.fsgbu.eventService.api.model.InvoiceDto;
import spock.lang.Shared
import spock.lang.Specification
import spock.lang.Unroll

class ReconEventServiceClientImplSpec extends Specification{

	def restTemplate = Mock(RestTemplate)
	def expDrCrPmtReconDTO = new ExpDrCrPmtReconDTO();
	def invPmtReconDTO = new InvPmtReconDTO();
	def finPmtReconDTO = new FinPmtReconDTO();
	def pmtAllocDTO = new PmtAllocDTO();
	def invCnReconDTO = new InvCnReconDTO();
	@Unroll("test saveExpDrCrData method")
	def"test saveExpDrCrData"(){
		given:
		
		def restTemplate = Mock(RestTemplate);
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true);
		restTemplate.exchange(_,_,_,_)>>responseEntity;
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
		def response = client.saveExpDrCrData(expDrCrPmtReconDTO,"DEV", "004")
	
		then:
		response != null;
	}

	@Unroll("test saveExpDrCrDataWithException method")
	def"test saveExpDrCrDataWithException"(){
		given:

		def restTemplate = Mock(RestTemplate);
		restTemplate.exchange(_,_,_,_)>>new Exception();
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)
		when:
		def response = client.saveExpDrCrData(expDrCrPmtReconDTO,"DEV", "004")
		then:
		response == response;
	}
	@Unroll("test saveExpDrCrData method")
	def"test saveexpDrCrPmtReconDTO"(){
		given:
		
		def restTemplate = Mock(RestTemplate);
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true);
		restTemplate.exchange(_,_,_,_)>>responseEntity;
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
		def response = client.saveExpDrCrData(expDrCrPmtReconDTO,"DEV", "004")
	
		then:
		response != null;
	}

	@Unroll("test saveexpDrCrPmtReconDTOWithException method")
	def"test saveexpDrCrPmtReconDTOWithException"(){
		given:

		def restTemplate = Mock(RestTemplate);
		restTemplate.exchange(_,_,_,_)>>new Exception();
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)
		when:
		def response = client.saveExpDrCrData(expDrCrPmtReconDTO,"DEV", "004")
		then:
		response == response;
	}
	@Unroll("test saveInvPmtData method")
	def"test saveInvPmtData"(){
		given:
		
		def restTemplate = Mock(RestTemplate);
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true);
		restTemplate.exchange(_,_,_,_)>>responseEntity;
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
		def response = client.saveInvPmtData(invPmtReconDTO,"DEV", "004")
	
		then:
		response != null;
	}

	@Unroll("test saveInvPmtDataWithException method")
	def"test saveInvPmtDataWithException"(){
		given:

		def restTemplate = Mock(RestTemplate);
		restTemplate.exchange(_,_,_,_)>>new Exception();
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)
		when:
		def response = client.saveInvPmtData(invPmtReconDTO,"DEV", "004")
	
		then:
		response == response;
	}
	
	@Unroll("test saveFinPmtData method")
	def"test saveFinPmtData"(){
		given:
		
		def restTemplate = Mock(RestTemplate);
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true);
		restTemplate.exchange(_,_,_,_)>>responseEntity;
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
	    def response = client.saveFinPmtData(finPmtReconDTO,"DEV", "004")
	
		then:
		response != null;
	}

	@Unroll("test saveFinPmtDataWithException method")
	def"test saveFinPmtDataWithException"(){
		given:

		def restTemplate = Mock(RestTemplate);
		restTemplate.exchange(_,_,_,_)>>new Exception();
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)
		when:
		def response = client.saveFinPmtData(finPmtReconDTO,"DEV", "004")
		then:
			response == response;
	}
	
	@Unroll("test savePmtAllocData method")
	def"test savePmtAllocData"(){
		given:
		
		def restTemplate = Mock(RestTemplate)
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true)
		restTemplate.exchange(_,_,_,_)>>responseEntity
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
		def response = client.savePmtAllocData(pmtAllocDTO,"DEV", "004")
	
		then:
		response != null;
	}

	@Unroll("test savePmtAllocDataWithException method")
	def"test savePmtAllocDataWithException"(){
		given:

		def restTemplate = Mock(RestTemplate)
		restTemplate.exchange(_,_,_,_)>>new Exception()
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)
		when:
		def response = client.savePmtAllocData(pmtAllocDTO,"DEV", "004")
	
		then:
		response == response;
	}
	
	@Unroll("test saveInvCnData method")
	def"test saveInvCnData"(){
		given:
		
		def restTemplate = Mock(RestTemplate)
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true)
		restTemplate.exchange(_,_,_,_)>>responseEntity;
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
		def response = client.saveInvCnData(invCnReconDTO,"DEV", "004")
	
		then:
		response != null;
	}

	@Unroll("test saveInvCnDataWithException method")
	def"test saveInvCnDataWithException"(){
		given:

		def restTemplate = Mock(RestTemplate)
		restTemplate.exchange(_,_,_,_)>>new Exception()
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)
		when:
		def response = client.saveInvCnData(invCnReconDTO,"DEV", "004")
	
		then:
		response == response;
	}
	
	@Unroll("test getReconTwData method")
	def"test getReconTwData"(){
		given:
		
		def restTemplate = Mock(RestTemplate)
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true)
		restTemplate.exchange(_,_,_,_)>>responseEntity
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
		def response = client.getReconTwData("123","DEV", "004")
	
		then:
		response == null;
	}
	
	@Unroll("test getReconTwData method with exception")
	def"test getReconTwData with exception"(){
		given:
		
		def restTemplate = Mock(RestTemplate)
		restTemplate.exchange(_,_,_,_)>>new Exception()
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
		def response = client.getReconTwData("123","DEV", "004")

		then:
		response == null;
	}


	@Unroll("test getReconTmData method")
	def"test getReconTmData method"(){
		given:

		def restTemplate = Mock(RestTemplate)
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true)
		restTemplate.exchange(_,_,_,_)>>responseEntity
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
		def response = client.getReconTmData("123","DEV", "004")

		then:
		response == null;
	}


	@Unroll("test getReconTmData method exception")
	def"test getReconTmData method exception"(){
		given:

		def restTemplate = Mock(RestTemplate)
		ResponseEntity<String> responseEntity = ResponseEntity.ok(true)
		restTemplate.exchange(_,_,_,_)>>new Exception()
		ReconEventServiceClientImpl client = new ReconEventServiceClientImpl(restTemplate)

		when:
		def response = client.getReconTmData("123","DEV", "004")

		then:
		response == null;
	}
}