package oracle.fsgbu.customer.test.client

import java.sql.Timestamp
import java.time.LocalDate

import org.springframework.http.ResponseEntity
import org.springframework.web.client.RestTemplate
import oracle.fsgbu.gus.response.service.ResponseHandler
import oracle.fsgbu.obscfcm.services.report.client.RelationshipEventServiceClientImpl
import oracle.fsgbu.obscfcm.services.report.util.ReportingUtil
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipMasterDTO;

import spock.lang.Shared
import spock.lang.Specification
import spock.lang.Unroll

class RelationshipEventServiceClientImplSpec extends Specification{

	def restTemplate = Mock(RestTemplate)

	@Unroll("test saveRelationshipData method")
	def"test saveRelationshipData"(){
		given:
		def restTemplate = Mock(RestTemplate)
		def responseEntity = Mock(ResponseEntity)
		ObcmTmRelationshipMasterDTO relationshipDto = new ObcmTmRelationshipMasterDTO()
		restTemplate.exchange(_, _, _, _) >> responseEntity
		RelationshipEventServiceClientImpl client = new RelationshipEventServiceClientImpl()
		when:
		def resposne = client.saveRelationshipData(relationshipDto,"DEV", "004")
		then:
		resposne == resposne;
	}
	
	@Unroll("test saveRelationshipData when return null method")
	def"test saveRelationshipData when null"(){
		given:
		def restTemplate = Mock(RestTemplate)
		def responseEntity = Mock(ResponseEntity)
		ObcmTmRelationshipMasterDTO relationshipDto = new ObcmTmRelationshipMasterDTO()
		restTemplate.exchange(_, _, _, _) >> responseEntity
		RelationshipEventServiceClientImpl client = new RelationshipEventServiceClientImpl()
		when:
		def resposne = client.saveRelationshipData(null,"DEV", "004")
		then:
		resposne == null
	}

	@Unroll("test saveRelationshipDataWithException method")
	def"test saveRelationshipDataWithException"(){
		given:
		ObcmTmRelationshipMasterDTO relationshipDto = new ObcmTmRelationshipMasterDTO()
		def restTemplate = Mock(RestTemplate);
		restTemplate.exchange(_,_,_,_)>>new Exception();
		RelationshipEventServiceClientImpl client = new RelationshipEventServiceClientImpl()

		when:
		def response = client.saveRelationshipData(relationshipDto,"DEV", "004")
		then:
		response == response;
	}
	
}