package oracle.fsgbu.customer.test.entity

import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTmRelationshipDetails;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTmRelationshipDetailsExternalCode;
import spock.lang.Specification;
import spock.lang.Unroll;


class ObcmTmRelationshipDetailsSpec extends Specification {

	@Unroll("#id getters should return \"#id\",\"#\",\"#relationshipMasterId\" \"#autoAcceptance\", \"#counterpartyname\", \"#partyType\", \"#expiresOn\", \"#status\", \"#noOfDays\" ")
    def "test ObcmTmRelationshipDetails accessors"() {
		given:
		def obcmTmRelationshipDetails = new ObcmTmRelationshipDetails()
		List<ObcmTmRelationshipDetailsExternalCode> obcmTmRelationshipDetailsExternalCodeList = new ArrayList <>()
		when:obcmTmRelationshipDetails
		obcmTmRelationshipDetails.setAutoAcceptance(autoAcceptance)
		obcmTmRelationshipDetails.setCounterpartyid(counterpartyid)
		obcmTmRelationshipDetails.setCounterpartyname(counterpartyname)
		obcmTmRelationshipDetails.setId(id)
		obcmTmRelationshipDetails.setPartyType(partyType)
		obcmTmRelationshipDetails.setRelationsMasterId(relationshipMasterId)
		obcmTmRelationshipDetails.setExpiresOn(expiresOn)
		obcmTmRelationshipDetails.setStatus(status)
		obcmTmRelationshipDetails.setNoOfDays(noOfDays)
		obcmTmRelationshipDetails.setObcmTmRelationshipDetailsExternalCodeList(obcmTmRelationshipDetailsExternalCodeList)
		obcmTmRelationshipDetails.setObcmTmRelationshipMaster(null)

		then:
		obcmTmRelationshipDetails.getAutoAcceptance() == autoAcceptance
		obcmTmRelationshipDetails.getCounterpartyid()  ==  counterpartyid
		obcmTmRelationshipDetails.getCounterpartyname() == counterpartyname
		obcmTmRelationshipDetails.getId() ==  id
		obcmTmRelationshipDetails.getPartyType()    ==  partyType
		obcmTmRelationshipDetails.getRelationsMasterId()    ==  relationshipMasterId
		obcmTmRelationshipDetails.getNoOfDays() ==  noOfDays
		obcmTmRelationshipDetails.getObcmTmRelationshipMaster() == null
		obcmTmRelationshipDetails.getExpiresOn() == expiresOn
		obcmTmRelationshipDetails.getStatus() == status
		obcmTmRelationshipDetails.getObcmTmRelationshipDetailsExternalCodeList() == obcmTmRelationshipDetailsExternalCodeList
		obcmTmRelationshipDetails.toString() != null

		where:
		id          |   counterpartyid      |   partyType   |  relationshipMasterId     |   expiresOn   	|   autoAcceptance  | noOfDays	|	status		| counterpartyname	
		"Id_100"    |   "Counterpatyid_1"  |       "B"     |   "Master_1"              |  new Date()      |       "Y"         |   786		|	"Success"	| "counterparty1"	
		"Id_101"    |   "Counterpatyid_2"  |       "S"     |   "Master_1"              |  new Date()      |       "N"         |   null		|	"Failed"	|"counterparty12"
		"Id_102"    |   "Counterpatyid_3"  |       "S"     |   "Master_2"              |  new Date()      |       "Y"         |   100		|	"Success"	|"counterparty12"
	}

	def "Use Spy to test ObcmTmRelationshipDetails::toString()"() {
		given:
		def obcmTmRelationshipDetailsSpy = Spy(ObcmTmRelationshipDetails)
		obcmTmRelationshipDetailsSpy.getAutoAcceptance()    >>  "Y"
		obcmTmRelationshipDetailsSpy.getCounterpartyid()    >>  "Counterpartyid_1"
		obcmTmRelationshipDetailsSpy.getId()                >>  "Id_100"
		obcmTmRelationshipDetailsSpy.getPartyType()         >>  "B"
		obcmTmRelationshipDetailsSpy.getRelationsMasterId() >>  "Master_1"
		obcmTmRelationshipDetailsSpy.getExpiresOn()()     >>  "2019-09-28"
		obcmTmRelationshipDetailsSpy.getNoOfDays()          >>  4
		obcmTmRelationshipDetailsSpy.getObcmTmRelationshipMaster()    >> null
		obcmTmRelationshipDetailsSpy.getStatus()  >> "Success"
		when:
		def s = obcmTmRelationshipDetailsSpy.toString()
		then:
		println s
	}
}