package oracle.fsgbu.customer.test.entity

import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTmRelationshipMaster;
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTmRelationshipDetails;
import spock.lang.Specification;
import spock.lang.Unroll;

class ObcmTmRelationshipMasterSpec extends Specification {

	@Unroll("")
	def "test obcmTmRelationshipMaster accessors"() {
		given:
		def obcmTmRelationshipMaster = new ObcmTmRelationshipMaster()
		List<ObcmTmRelationshipDetails> obcmTmRelationshipDetailsList = new ArrayList <>()
		when:obcmTmRelationshipMaster
		obcmTmRelationshipMaster.setAutoAcceptance(autoAcceptance)
		obcmTmRelationshipMaster.setCorporateId(corporateId)
		obcmTmRelationshipMaster.setCorporateName(corporateName)
		obcmTmRelationshipMaster.setEffFromDate(effFromDate)
		obcmTmRelationshipMaster.setRelationshipCode(relationshipCode)
		obcmTmRelationshipMaster.setRelationshipName(relationshipName)
		obcmTmRelationshipMaster.setExpiresOn(expiresOn)
		obcmTmRelationshipMaster.setProduct(product)
		obcmTmRelationshipMaster.setNoOfDays(noOfDays)

        obcmTmRelationshipMaster.setPayAutoAcceptance(payAutoAcceptance)
        obcmTmRelationshipMaster.setPayNoOfDays(payNoOfDays)
        obcmTmRelationshipMaster.setPayAllowOverdueRcv(payAllowOverdueRcv)
        obcmTmRelationshipMaster.setPayMaxDaysOverdue(payMaxDaysOverdue)
        obcmTmRelationshipMaster.setPayValidateLinkedPo(payValidateLinkedPo)
        obcmTmRelationshipMaster.setPayExcessHandling(payExcessHandling)
        obcmTmRelationshipMaster.setPayExcessRefundParty(payExcessRefundParty)
        obcmTmRelationshipMaster.setPayExcessRefundPaymentMode(payExcessRefundPaymentMode)

		obcmTmRelationshipMaster.setObcmTmRelationshipDetailsList(obcmTmRelationshipDetailsList)
		then:
		obcmTmRelationshipMaster.getAutoAcceptance() == autoAcceptance
		obcmTmRelationshipMaster.getCorporateId()  ==  corporateId
		obcmTmRelationshipMaster.getCorporateName() ==  corporateName
		obcmTmRelationshipMaster.getEffFromDate()	== effFromDate
		obcmTmRelationshipMaster.getRelationshipCode() == relationshipCode
		obcmTmRelationshipMaster.getRelationshipName() == relationshipName
		obcmTmRelationshipMaster.getExpiresOn() == expiresOn
		obcmTmRelationshipMaster.getProduct() == product
		obcmTmRelationshipMaster.getNoOfDays() ==	noOfDays

        obcmTmRelationshipMaster.getPayAutoAcceptance() ==    payAutoAcceptance
        obcmTmRelationshipMaster.getPayNoOfDays() ==    payNoOfDays 
        obcmTmRelationshipMaster.getPayAllowOverdueRcv() == payAllowOverdueRcv
        obcmTmRelationshipMaster.getPayMaxDaysOverdue() == payMaxDaysOverdue
        obcmTmRelationshipMaster.getPayValidateLinkedPo() == payValidateLinkedPo
        obcmTmRelationshipMaster.getPayExcessHandling() == payExcessHandling
        obcmTmRelationshipMaster.getPayExcessRefundParty() == payExcessRefundParty
        obcmTmRelationshipMaster.getPayExcessRefundPaymentMode() == payExcessRefundPaymentMode




		obcmTmRelationshipMaster.getObcmTmRelationshipDetailsList() == obcmTmRelationshipDetailsList

		obcmTmRelationshipMaster.toString() != null
		
		where:
		autoAcceptance	|   corporateId	|   corporateName	|	effFromDate		|	relationshipCode	|	relationshipName	|	expiresOn	|	product	|	noOfDays | payAutoAcceptance | payNoOfDays | payAllowOverdueRcv |payMaxDaysOverdue | payValidateLinkedPo |payExcessHandling | payExcessRefundParty | payExcessRefundPaymentMode
			"test"		|	"C"			|	"CMS"			|	new Date()	|		"4"				|	"Cash Management"	|	new Date() 	|	"new"	|	4             |  "Y"              |  10         | "Y"                | 20               | "Y"                 | "Auto-Reconcile" | "Payment Party"      | "Cheque"
	}

	
}