package oracle.fsgbu.customer.test.entity

import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTwRelationshipDetails
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObcmTwRelationshipMaster

import spock.lang.Specification;
import spock.lang.Unroll;

class ObcmTwRelationshipMasterSpec extends Specification {

	 @Unroll("")
    def "test obcmTwRelationshipMaster accessors"() {
        given:
        def obcmTwRelationshipMaster = new ObcmTwRelationshipMaster()
                                            
        List<ObcmTwRelationshipDetails> obcmTwRelationshipDetailsList = new ArrayList <>()
        when:obcmTwRelationshipMaster
        obcmTwRelationshipMaster.setAutoAcceptance(autoAcceptance)
        obcmTwRelationshipMaster.setCorporateId(corporateId)
        obcmTwRelationshipMaster.setCorporateName(corporateName)
        obcmTwRelationshipMaster.setEffFromDate(effFromDate)
        obcmTwRelationshipMaster.setRelationshipCode(relationshipCode)
        obcmTwRelationshipMaster.setRelationshipName(relationshipName)
        obcmTwRelationshipMaster.setExpiresOn(expiresOn)
        obcmTwRelationshipMaster.setProduct(product)
        obcmTwRelationshipMaster.setNoOfDays(noOfDays)
        
        obcmTwRelationshipMaster.setPayAutoAcceptance(payAutoAcceptance)
        obcmTwRelationshipMaster.setPayNoOfDays(payNoOfDays)
        obcmTwRelationshipMaster.setPayAllowOverdueRcv(payAllowOverdueRcv)
        obcmTwRelationshipMaster.setPayMaxDaysOverdue(payMaxDaysOverdue)
        obcmTwRelationshipMaster.setPayValidateLinkedPo(payValidateLinkedPo)
        obcmTwRelationshipMaster.setPayExcessHandling(payExcessHandling)
        obcmTwRelationshipMaster.setPayExcessRefundParty(payExcessRefundParty)
        obcmTwRelationshipMaster.setPayExcessRefundPaymentMode(payExcessRefundPaymentMode)

        obcmTwRelationshipMaster.setObcmTwRelationshipDetailsList(obcmTwRelationshipDetailsList)
        then:
        obcmTwRelationshipMaster.getAutoAcceptance() == autoAcceptance
        obcmTwRelationshipMaster.getCorporateId()  ==  corporateId
        obcmTwRelationshipMaster.getCorporateName() ==  corporateName
        obcmTwRelationshipMaster.getEffFromDate()    == effFromDate
        obcmTwRelationshipMaster.getRelationshipCode() == relationshipCode
        obcmTwRelationshipMaster.getRelationshipName() == relationshipName
        obcmTwRelationshipMaster.getExpiresOn() == expiresOn
        obcmTwRelationshipMaster.getProduct() == product
        obcmTwRelationshipMaster.getNoOfDays() ==    noOfDays
        
        obcmTwRelationshipMaster.getPayAutoAcceptance() ==    payAutoAcceptance
        obcmTwRelationshipMaster.getPayNoOfDays() ==    payNoOfDays 
        obcmTwRelationshipMaster.getPayAllowOverdueRcv() == payAllowOverdueRcv
        obcmTwRelationshipMaster.getPayMaxDaysOverdue() == payMaxDaysOverdue
        obcmTwRelationshipMaster.getPayValidateLinkedPo() == payValidateLinkedPo
        obcmTwRelationshipMaster.getPayExcessHandling() == payExcessHandling
        obcmTwRelationshipMaster.getPayExcessRefundParty() == payExcessRefundParty
        obcmTwRelationshipMaster.getPayExcessRefundPaymentMode() == payExcessRefundPaymentMode


        obcmTwRelationshipMaster.getObcmTwRelationshipDetailsList() == obcmTwRelationshipDetailsList

        obcmTwRelationshipMaster.toString() != null
        
        where:
        autoAcceptance    |   corporateId    |   corporateName    |    effFromDate        |    relationshipCode    |    relationshipName    |    expiresOn    |    product    |    noOfDays  | payAutoAcceptance | payNoOfDays | payAllowOverdueRcv |payMaxDaysOverdue | payValidateLinkedPo |payExcessHandling | payExcessRefundParty | payExcessRefundPaymentMode
            "test"        |    "C"            |    "CMS"            |    new Date()    |        "4"                |    "Cash Management"    |    new Date()     |    "new"    |    4             |  "Y"              |  10         | "Y"                | 20               | "Y"                 | "Auto-Reconcile" | "Payment Party"      | "Cheque"
    }

	
}