package oracle.fsgbu.customer.test.entity

import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmFile
import spock.lang.Specification;
import spock.lang.Unroll;

class ScfcmFileSpec extends Specification {
	
	   @Unroll("test ScfcmFileSpec accessors")
	   def "test ScfcmFileSpec accessors" () {
		   given:
		   def scfcmFile = new ScfcmFile()
		   when:scfcmFile
		   scfcmFile.setInvoiceFileId(invoiceFileId)
		   scfcmFile.setFileName(fileName)
		   scfcmFile.setUploadDateAndTime(uploadDateAndTime)
		   scfcmFile.setCount(count)
		   scfcmFile.setTotalFileUploadValue(totalFileUploadValue)
	
	
		   then:
		   scfcmFile.getInvoiceFileId() ==  invoiceFileId
		   scfcmFile.getFileName()   ==  fileName
		   scfcmFile.getUploadDateAndTime()   ==  uploadDateAndTime
		   scfcmFile.getCount()  ==  count
		   scfcmFile.getTotalFileUploadValue() ==  totalFileUploadValue
		   
	
		   scfcmFile.toString() != null
	
		   where:
		   invoiceFileId   |  fileName    |   uploadDateAndTime  |  count   |  totalFileUploadValue
           25000   |  "TestFile.csv" | new Date()   |    new BigDecimal(10000)  |      "USD 100"   
	   }
}
	