package oracle.fsgbu.customer.test.entity

import spock.lang.Specification;
import spock.lang.Unroll;
import java.math.BigDecimal
import spock.lang.Shared
import oracle.fsgbu.gus.persistence.provider.GlobalHolder
import oracle.fsgbu.gus.persistence.provider.RequestContext
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmInvoice;

import org.junit.Test

class scfcmInvoiceSpec extends Specification {
	
	   @Unroll("test ScfcmInvoice accessors")
	   def "test ScfcmInvoice accessors" () {
		   given:
		   def scfcmInvoice = new ScfcmInvoice()
		   when:scfcmInvoice
		   scfcmInvoice.setInvoiceId(invoiceId)
		   scfcmInvoice.setIndicator(indicator)
		   scfcmInvoice.setInvoiceNumber(invoiceNumber)
		   scfcmInvoice.setInvoiceDueDate(invoiceDueDate)
		   scfcmInvoice.setCurrency(currency)
		   scfcmInvoice.setAmount(amount)
		   scfcmInvoice.setBuyerId(buyerId)
		   scfcmInvoice.setBuyerName(buyerName)
		   scfcmInvoice.setSupplierId(supplierId)
		   scfcmInvoice.setSupplierName(supplierName)
		   scfcmInvoice.setProgramCode(programCode)
		   scfcmInvoice.setTaxAmount(taxAmount)
		   scfcmInvoice.setTotalInvoiceAmount(totalInvoiceAmount)
		   scfcmInvoice.setPoNumber(poNumber)
		   scfcmInvoice.setInvoiceRefNo(invoiceRefNo)
		   scfcmInvoice.setPaymentStatus(paymentStatus)
		   scfcmInvoice.setReasonCode(reasonCode)
		   scfcmInvoice.setAcceptanceAmount(acceptanceAmount)
		   scfcmInvoice.setInvAcceptanceDate(invAcceptanceDate)
		   scfcmInvoice.setInvoiceStatus(invoiceStatus)
		   scfcmInvoice.setPaidAmount(paidAmount)
		   scfcmInvoice.setRemarks(remarks)
		   scfcmInvoice.setInvoiceProcessStatus(invoiceProcessStatus)
		   scfcmInvoice.setFilter1(filter1)
		   scfcmInvoice.setFilter2(filter2)
		   scfcmInvoice.setFilter3(filter3)
		   scfcmInvoice.setFilter4(filter4)
		   scfcmInvoice.setFilterRef(filterRef)
		   scfcmInvoice.setInvoiceDate(invoiceDate)
		   scfcmInvoice.setPreAccepted(preAccepted)
		   scfcmInvoice.setPaymentTerms(paymentTerms)
		   scfcmInvoice.setShipmentDate(shipmentDate)
		   scfcmInvoice.setOutstandingAmount(outstandingAmount)
		   scfcmInvoice.setPurchaseOrderDate(purchaseOrderDate)
		   scfcmInvoice.setStaleStatus(staleStatus)
		   scfcmInvoice.setDiscountAllowed(discountAllowed)
		   scfcmInvoice.setDiscountPercentage(discountPercentage)
		   scfcmInvoice.setDiscountAmount(discountAmount)
		   scfcmInvoice.setTaxPercentage(taxPercentage)
		   scfcmInvoice.setProgramName(programName)
		   scfcmInvoice.setHierarchyCode(hierarchyCode)
		   scfcmInvoice.setShipmentAddress(shipmentAddress)
		   scfcmInvoice.setShipmentNo(shipmentNo)
		   scfcmInvoice.setShipmentCountry(shipmentCountry)
		   scfcmInvoice.setReasonForExport(reasonForExport)
		   scfcmInvoice.setTermsOfSale(termsOfSale)
		   scfcmInvoice.setCountryOfOrigin(countryOfOrigin)
		   scfcmInvoice.setMiscCharge1Desc(miscCharge1Desc)
		   scfcmInvoice.setMiscCharge1Amount(miscCharge1Amount)
		   scfcmInvoice.setMiscCharge2Desc(miscCharge2Desc)
		   scfcmInvoice.setMiscCharge2Amount(miscCharge2Amount)
		   scfcmInvoice.setMiscCharge1(miscCharge1)
		   scfcmInvoice.setMiscCharge2(miscCharge2)
		   scfcmInvoice.setNetInvoiceAmount(netInvoiceAmount)
		   scfcmInvoice.setFinanceAmount(financeAmount)
		   scfcmInvoice.setFinancePercentage(financePercentage)
		   scfcmInvoice.setBuyerDivCode(buyerDivCode)
		   scfcmInvoice.setSupplierDivCode(supplierDivCode)
		   scfcmInvoice.setBuyerDivName(buyerDivName)
		   scfcmInvoice.setSupplierDivName(supplierDivName)
		   scfcmInvoice.setDivisionCode(divisionCode)
		   scfcmInvoice.setIsDisputed(isDisputed)
		   scfcmInvoice.setDiscrepancyCode(discrepancyCode)
		   scfcmInvoice.setDisputeResolveRemarks(disputeResolveRemarks)
	
	
		   then:
		   scfcmInvoice.getInvoiceId() ==  invoiceId
		   scfcmInvoice.getIndicator()   ==  indicator
		   scfcmInvoice.getInvoiceNumber()   ==  invoiceNumber
		   scfcmInvoice.getInvoiceDueDate()  ==  invoiceDueDate
		   scfcmInvoice.getCurrency() ==  currency
		   scfcmInvoice.getAmount()   ==  amount
		   scfcmInvoice.getBuyerId() ==  buyerId
		   scfcmInvoice.getBuyerName()  ==  buyerName
		   scfcmInvoice.getSupplierId()  ==  supplierId
		   scfcmInvoice.getSupplierName()  ==  supplierName
		   scfcmInvoice.getProgramCode()  ==  programCode
		   scfcmInvoice.getTaxAmount()  ==  taxAmount
		   scfcmInvoice.getTotalInvoiceAmount()  ==  totalInvoiceAmount
		   scfcmInvoice.getPoNumber()  ==  poNumber
		   scfcmInvoice.getInvoiceRefNo()  ==  invoiceRefNo
		   scfcmInvoice.getPaymentStatus()  ==  paymentStatus
		   scfcmInvoice.getReasonCode()  ==  reasonCode
		   scfcmInvoice.getAcceptanceAmount()  ==  acceptanceAmount
		   scfcmInvoice.getInvAcceptanceDate()  ==  invAcceptanceDate
		   scfcmInvoice.getInvoiceStatus()  ==  invoiceStatus
		   scfcmInvoice.getPaidAmount()  ==  paidAmount
		   scfcmInvoice.getRemarks()  ==  remarks
		   scfcmInvoice.getInvoiceProcessStatus()  ==  invoiceProcessStatus
		   scfcmInvoice.getFilter1()  ==  filter1
		   scfcmInvoice.getFilter2()  ==  filter2
		   scfcmInvoice.getFilter3()  ==  filter3
		   scfcmInvoice.getFilter4()  ==  filter4
		   scfcmInvoice.getFilterRef()  ==  filterRef
		   scfcmInvoice.getInvoiceDate()  ==  invoiceDate
		   scfcmInvoice.getPreAccepted()  ==  preAccepted
		   scfcmInvoice.getPaymentTerms()  ==  paymentTerms
		   scfcmInvoice.getShipmentDate()  ==  shipmentDate
		   scfcmInvoice.getOutstandingAmount()  ==  outstandingAmount
		   scfcmInvoice.getPurchaseOrderDate()  ==  purchaseOrderDate
		   scfcmInvoice.getStaleStatus()  ==  staleStatus
		   scfcmInvoice.getDiscountAllowed()  ==  discountAllowed
		   scfcmInvoice.getDiscountPercentage()  ==  discountPercentage
		   scfcmInvoice.getDiscountAmount()  ==  discountAmount
		   scfcmInvoice.getTaxPercentage()  ==  taxPercentage
		   scfcmInvoice.getProgramName()  ==  programName
		   scfcmInvoice.getHierarchyCode()  ==  hierarchyCode
		   scfcmInvoice.getShipmentAddress()  ==  shipmentAddress
		   scfcmInvoice.getShipmentNo()  ==  shipmentNo
		   scfcmInvoice.getShipmentCountry()  ==  shipmentCountry
		   scfcmInvoice.getReasonForExport()  ==  reasonForExport
		   scfcmInvoice.getTermsOfSale()  ==  termsOfSale
		   scfcmInvoice.getCountryOfOrigin()  ==  countryOfOrigin
		   scfcmInvoice.getMiscCharge1Desc()  ==  miscCharge1Desc
		   scfcmInvoice.getMiscCharge1Amount()  ==  miscCharge1Amount
		   scfcmInvoice.getMiscCharge2Desc()  ==  miscCharge2Desc
		   scfcmInvoice.getMiscCharge2Amount()  ==  miscCharge2Amount
		   scfcmInvoice.getMiscCharge1()  ==  miscCharge1
		   scfcmInvoice.getMiscCharge2()  ==  miscCharge2
		   scfcmInvoice.getNetInvoiceAmount()  ==  netInvoiceAmount
		   scfcmInvoice.getFinanceAmount()  ==  financeAmount
		   scfcmInvoice.getFinancePercentage()  ==  financePercentage
		   scfcmInvoice.getBuyerDivCode()  ==  buyerDivCode
		   scfcmInvoice.getSupplierDivCode()  ==  supplierDivCode
		   scfcmInvoice.getBuyerDivName()  ==  buyerDivName
		   scfcmInvoice.getSupplierDivName()  ==  supplierDivName
		   scfcmInvoice.getDivisionCode()  ==  divisionCode
		   scfcmInvoice.getIsDisputed()  ==  isDisputed
		   scfcmInvoice.getDiscrepancyCode()  ==  discrepancyCode
		   scfcmInvoice.getDisputeResolveRemarks()  ==  disputeResolveRemarks
	
		   scfcmInvoice.toString() != null
	
		   where:
		   invoiceId   |  indicator    |   invoiceNumber  |  invoiceDueDate   |  currency |   amount  |    buyerId   |  buyerName   |  supplierId   |  supplierName    |   programCode  |  taxAmount   |  totalInvoiceAmount |   poNumber  |    invoiceRefNo   |  paymentStatus   |  reasonCode   |  acceptanceAmount    |   invAcceptanceDate  |  invoiceStatus   |  paidAmount |   remarks  |    invoiceProcessStatus   |  filter1   |  filter2   |  filter3    |   filter4  |  filterRef   |  invoiceDate |   preAccepted  |   paymentTerms  |  shipmentDate   |  outstandingAmount  |    purchaseOrderDate   |  staleStatus   |  discountAllowed   |  discountPercentage    |   discountAmount  |  taxPercentage   |  programName |   hierarchyCode  |    shipmentAddress   |  shipmentNo   |  shipmentCountry   |  reasonForExport    |   termsOfSale  |  countryOfOrigin   |  miscCharge1Desc |   miscCharge1Amount  |    miscCharge2Desc   |  miscCharge2Amount   |  miscCharge1   |  miscCharge2    |   netInvoiceAmount  |  financeAmount   |  financePercentage |   buyerDivCode  |   supplierDivCode  |  buyerDivName   |  supplierDivName  |  divisionCode   |  isDisputed |   discrepancyCode  |   disputeResolveRemarks
           "25000"   |  "A" |  "2"  |    new Date()  |      "TWD"    |   new BigDecimal(25000)   |   "123"     |   "JON"    |   "456"  |   "TOM"   |  "RTT"  |   new BigDecimal(25000)  |     new BigDecimal(26000)     |    "4"  |   "111"  |   "P"  |   "N"    |   new BigDecimal(26000)  |   new Date()  |   "P"  |   new BigDecimal(29000)  |   "O"   |  "S"    |   new Date()   |   "D"  |   "V"  |  "Z"  |   "F"   |   new Date()    |  "Y"   |  "C"  |   new Date()  |  new BigDecimal(29000)   |   new Date()    |   "P"    |   "Y"  |  new BigDecimal(40)   |   new BigDecimal(40000)   |  new BigDecimal(20)   |   "NEW"  |  "AC"  |  "BOYT"  |  "18"  |  "BQQ"  |   "FR"  | "YEE"  | "INDIA"  |  "CVF"  | new BigDecimal(25000)  |   "VFS"    |    new BigDecimal(25000)  |   new BigDecimal(25000)  |  new BigDecimal(25000)  |  new BigDecimal(25000)  |  new BigDecimal(25000)  |  new BigDecimal(25)  |  "121"  |  "176"  |  "FER"  |   "VBG"   | "322"  |  "Y"  |  "211"  |  "OK"
	   }
}
	