package oracle.fsgbu.customer.test.entity

import oracle.fsgbu.obscfcm.services.report.domain.entity.ScfcmPayment
import spock.lang.Specification;
import spock.lang.Unroll;

class ScfcmPaymentSpec extends Specification {
	
	   @Unroll("test ScfcmPayment accessors")
	   def "test ScfcmPayment accessors" () {
		    given:
		    def scfcmPayment = new ScfcmPayment()
		    when:scfcmPayment
		scfcmPayment.setAccOwner(accOwner)
		scfcmPayment.setAllocatedAmt(allocatedAmt)
			scfcmPayment.setAllocationRequired(allocationRequired)
		scfcmPayment.setAllocStatus(allocStatus)
		scfcmPayment.setAutoReconcile(autoReconcile)
			scfcmPayment.setBankCode(bankCode)
			scfcmPayment.setBeneficiaryCode(beneficiaryCode)
			scfcmPayment.setBeneficiaryId(beneficiaryId)
			scfcmPayment.setBeneficiaryName(beneficiaryName)
			scfcmPayment.setBeneficiaryRole(beneficiaryRole)
			scfcmPayment.setCounterpartyCode(counterpartyCode)
			scfcmPayment.setCounterpartyId(counterpartyId)
			scfcmPayment.setCounterpartyName(counterpartyName)
			scfcmPayment.setCounterpartyRole(counterPartyRole)
			scfcmPayment.setCreditAccNo(creditAccNo)
			scfcmPayment.setCreditNoteRefNo(creditNoteRefNo)
		scfcmPayment.setDcIndicator(dcIndicator)
			scfcmPayment.setDerivedFlag(derivedFlag)
			scfcmPayment.setEftRefNo(eftRefNo)
			scfcmPayment.setEntityRefNo(entityRefNo)
			scfcmPayment.setErrorDesc(errorDesc)
		scfcmPayment.setFileName(fileName)
			scfcmPayment.setFiller1(filler1)
			scfcmPayment.setFiller2(filler2)
			scfcmPayment.setFiller3(filler3)
			scfcmPayment.setFiller4(filler4)
			scfcmPayment.setFiller5(filler5)
			scfcmPayment.setFiller6(filler6)
			scfcmPayment.setFiller7(filler7)
			scfcmPayment.setFiller8(filler8)
			scfcmPayment.setFiller9(filler9)
			scfcmPayment.setFiller10(filler10)
			scfcmPayment.setFlag(flag)
			scfcmPayment.setGenericAppropriation(genericAppropriation)
			scfcmPayment.setIndicator(indicator)
			scfcmPayment.setInstrumentBank(instrumentBank)
			scfcmPayment.setInstrumentBranch(instrumentBranch)
			scfcmPayment.setInstrumentDate(instrumentDate)
			scfcmPayment.setMandateRefNo(mandateRefNo)
			scfcmPayment.setMatchedAmount(matchedAmount)
			scfcmPayment.setPartyPaymentCode(partyPaymentCode)
			scfcmPayment.setPaymentAmount(paymentAmount)
			scfcmPayment.setPaymentBusinessDate(paymentBusinessDate)
			scfcmPayment.setPaymentCurrency(paymentCurrency)
			scfcmPayment.setPaymentDate(paymentDate)
			scfcmPayment.setPaymentMode(paymentMode)
			scfcmPayment.setPaymentNumber(paymentNumber)
			scfcmPayment.setPaymentPartyCategory(paymentPartyCategory)
			scfcmPayment.setPaymentPartyId(paymentPartyId)
			scfcmPayment.setPaymentPartyName(paymentPartyName)
			scfcmPayment.setPaymentPartyRole(paymentPartyRole)
			scfcmPayment.setPaymentProcessStatus(paymentProcessStatus)
			scfcmPayment.setPaymentRefNo(paymentRefNo)
			scfcmPayment.setPaymentStatus(paymentStatus)
			scfcmPayment.setProcBranchCode(procBranchCode)
			scfcmPayment.setProcBranchDate(procBranchDate)
			scfcmPayment.setProgramCode(programCode)
			scfcmPayment.setReasonCode(reasonCode)
		scfcmPayment.setReconTxnStatus(reconTxnStatus)
			scfcmPayment.setRelationshipCode(relationshipCode)
			scfcmPayment.setRemarks(remarks)
			scfcmPayment.setRemitterAccNo(remitterAccNo)
			scfcmPayment.setSeqNo(seqNo)
			scfcmPayment.setSpecificAppropriation(specificAppropriation)
			scfcmPayment.setTransactionRefNo(transactionRefNo)
		scfcmPayment.setUnallocatedAmt(unallocatedAmt)
			scfcmPayment.setUnmatchedAmount(unmatchedAmount)
		scfcmPayment.setVirtualAcFlag(virtualAcFlag)
		scfcmPayment.setIsPUA(isPUA)
		scfcmPayment.setIsIndirectPayment(isIndirectPayment)
		scfcmPayment.setLastActionPerformed(lastActionPerformed)
		scfcmPayment.setExcessHandling(excessHandling)
		scfcmPayment.setExcessRefundParty(excessRefundParty)
		scfcmPayment.setExcessRefundPartyId(excessRefundPartyId)
		scfcmPayment.setExcessRefundPaymentMode(excessRefundPaymentMode)
		scfcmPayment.setParentPaymentRefNo(parentPaymentRefNo)
		scfcmPayment.setRefundAmount(refundAmount)

		then:
		scfcmPayment.getAccOwner() ==  accOwner
		scfcmPayment.getAllocatedAmt() ==  allocatedAmt
			scfcmPayment.getAllocationRequired() ==  allocationRequired
		scfcmPayment.getAllocStatus() ==  allocStatus
		scfcmPayment.getAutoReconcile() ==  autoReconcile
			scfcmPayment.getBankCode() ==  bankCode
			scfcmPayment.getBeneficiaryCode() ==  beneficiaryCode
			scfcmPayment.getBeneficiaryId() ==  beneficiaryId
			scfcmPayment.getBeneficiaryName() ==  beneficiaryName
			scfcmPayment.getBeneficiaryRole() ==  beneficiaryRole
			scfcmPayment.getCounterpartyCode() ==  counterpartyCode
			scfcmPayment.getCounterpartyId() ==  counterpartyId
			scfcmPayment.getCounterpartyName() ==  counterpartyName
			scfcmPayment.getCounterpartyRole() ==  counterPartyRole
			scfcmPayment.getCreditAccNo() ==  creditAccNo
			scfcmPayment.getCreditNoteRefNo() ==  creditNoteRefNo
		scfcmPayment.getDcIndicator() ==  dcIndicator
			scfcmPayment.getDerivedFlag() ==  derivedFlag
			scfcmPayment.getEftRefNo() ==  eftRefNo
			scfcmPayment.getEntityRefNo() ==  entityRefNo
			scfcmPayment.getErrorDesc() ==  errorDesc
		scfcmPayment.getFileName() ==  fileName
			scfcmPayment.getFiller1() ==  filler1
			scfcmPayment.getFiller2() ==  filler2
			scfcmPayment.getFiller3() ==  filler3
			scfcmPayment.getFiller4() ==  filler4
			scfcmPayment.getFiller5() ==  filler5
			scfcmPayment.getFiller6() ==  filler6
			scfcmPayment.getFiller7() ==  filler7
			scfcmPayment.getFiller8() ==  filler8
			scfcmPayment.getFiller9() ==  filler9
			scfcmPayment.getFiller10() ==  filler10
			scfcmPayment.getFlag() ==  flag
			scfcmPayment.getGenericAppropriation() ==  genericAppropriation
			scfcmPayment.getIndicator() ==  indicator
			scfcmPayment.getInstrumentBank() ==  instrumentBank
			scfcmPayment.getInstrumentBranch() ==  instrumentBranch
			scfcmPayment.getInstrumentDate() == instrumentDate
			scfcmPayment.getMandateRefNo() ==  mandateRefNo
			scfcmPayment.getMatchedAmount() ==  matchedAmount
			scfcmPayment.getPartyPaymentCode() ==  partyPaymentCode
			scfcmPayment.getPaymentAmount() ==  paymentAmount
			scfcmPayment.getPaymentBusinessDate() ==  paymentBusinessDate
			scfcmPayment.getPaymentCurrency() ==  paymentCurrency
			scfcmPayment.getPaymentDate() ==  paymentDate
			scfcmPayment.getPaymentMode() ==  paymentMode
			scfcmPayment.getPaymentNumber() ==  paymentNumber
			scfcmPayment.getPaymentPartyCategory() ==  paymentPartyCategory
			scfcmPayment.getPaymentPartyId() ==  paymentPartyId
			scfcmPayment.getPaymentPartyName() ==  paymentPartyName
			scfcmPayment.getPaymentPartyRole() ==  paymentPartyRole
			scfcmPayment.getPaymentProcessStatus() ==  paymentProcessStatus
			scfcmPayment.getPaymentRefNo() ==  paymentRefNo
			scfcmPayment.getPaymentStatus() ==  paymentStatus
			scfcmPayment.getProcBranchCode() ==  procBranchCode
			scfcmPayment.getProcBranchDate() ==  procBranchDate
			scfcmPayment.getProgramCode() ==  programCode
			scfcmPayment.getReasonCode() ==  reasonCode
		scfcmPayment.getReconTxnStatus() ==  reconTxnStatus
			scfcmPayment.getRelationshipCode() ==  relationshipCode
			scfcmPayment.getRemarks() ==  remarks
			scfcmPayment.getRemitterAccNo() ==  remitterAccNo
			scfcmPayment.getSeqNo() ==  seqNo
			scfcmPayment.getSpecificAppropriation() ==  specificAppropriation
			scfcmPayment.getTransactionRefNo() ==  transactionRefNo
		scfcmPayment.getUnallocatedAmt() ==  unallocatedAmt
			scfcmPayment.getUnmatchedAmount() ==  unmatchedAmount
		scfcmPayment.getVirtualAcFlag() ==  virtualAcFlag
		scfcmPayment.getIsPUA() == isPUA
		scfcmPayment.getIsIndirectPayment() == isIndirectPayment
		scfcmPayment.getLastActionPerformed() == lastActionPerformed
		scfcmPayment.getExcessHandling() == excessHandling
		scfcmPayment.getExcessRefundParty() == excessRefundParty
		scfcmPayment.getExcessRefundPartyId() == excessRefundPartyId
		scfcmPayment.getExcessRefundPaymentMode() == excessRefundPaymentMode
		scfcmPayment.getParentPaymentRefNo() == parentPaymentRefNo
		scfcmPayment.getRefundAmount() == refundAmount


		scfcmPayment.toString() != null

		where:
		accOwner  |  allocatedAmt  |  allocationRequired  |  allocStatus  |  autoReconcile  |  bankCode  |  beneficiaryCode  |  beneficiaryId  |  beneficiaryName  |  beneficiaryRole  |  counterpartyCode  |  counterpartyId  |  counterpartyName  |  counterPartyRole  |  creditAccNo  |  creditNoteRefNo  |  dcIndicator  |  derivedFlag  |  eftRefNo  |  entityRefNo  |  errorDesc  |  fileName  |  filler1  |  filler2  |  filler3  |  filler4  |  filler5  |  filler6  |  filler7  |  filler8  |  filler9  |  filler10  |  flag  |  genericAppropriation  |  indicator  |  instrumentBank  |  instrumentBranch  |  instrumentDate  |  mandateRefNo  |  matchedAmount  |  partyPaymentCode  |  paymentAmount  |  paymentBusinessDate  |  paymentCurrency  |  paymentDate  |  paymentMode  |  paymentNumber  |  paymentPartyCategory  |  paymentPartyId  |  paymentPartyName  |  paymentPartyRole  |  paymentProcessStatus  |  paymentRefNo  |  paymentStatus  |  procBranchCode  |  procBranchDate  |  programCode  |  reasonCode  |  reconTxnStatus  |  relationshipCode  |  remarks  |  remitterAccNo  |  seqNo  |  specificAppropriation  |  transactionRefNo  |  unallocatedAmt  |  unmatchedAmount  |  virtualAcFlag | isPUA | isIndirectPayment | lastActionPerformed | excessHandling | excessRefundParty | excessRefundPartyId | excessRefundPaymentMode | parentPaymentRefNo | refundAmount
		"accountOwner"  |  new BigDecimal(25000)  |  "allocationRequired"  |  "allocStatus"  |  "autoReconcile"  |  "bankCode"  |  "beneficiaryCode"  |  "beneficiaryId"  |  "beneficiaryName"  |  "beneficiaryRole"  |  "counterpartyCode"  |  "counterpartyId"  |  "counterpartyName"  |  "counterPartyRole"  |  "creditAccNo"  |  "creditNoteRefNo"  |  "dcIndicator"  |  "derivedFlag"  |  "eftRefNo"  |  "entityRefNo"  |  "errorDesc"  |  "fileName"  |  "filler1"  |  "filler2"  |  "filler3"  |  "filler4"  |  "filler5"  |  "filler6"  |  "filler7"  |  "filler8"  |  "filler9"  |  "filler10"  |  "flag"  |  "genericAppropriation"  |  "indicator"  |  "instrumentBank"  |  "instrumentBranch"  |  new Date()  |  "mandateRefNo"  |  new BigDecimal(25000)  |  "partyPaymentCode"  |  new BigDecimal(25000)  |  new Date()  |  "paymentCurrency"  |  new Date()  |  "paymentMode"  |  "paymentNumber"  |  "paymentPartyCategory"  |  "paymentPartyId"  |  "paymentPartyName"  |  "paymentPartyRole"  |  "paymentProcessStatus"  |  "paymentRefNo"  |  "paymentStatus"  |  "procBranchCode"  |  new Date()  |  "programCode"  |  "reasonCode"  |  "reconTxnStatus"  |  "relationshipCode"  |  "remarks"  |  "remitterAccNo"  |  1  |  "specificAppropriation"  |  "transactionRefNo"  |  new BigDecimal(25000)  |  new BigDecimal(25000)  |  "virtualAcFlag" | "isPUA" | "isIndirectPayment" | "CREATE" | "excessHandling" | "excessRefundParty" | "excessRefundPartyId" | "excessRefundPaymentMode" | "parentPaymentRefNo" | new BigDecimal(100)
	}
}
