package oracle.fsgbu.customer.test.model

import spock.lang.Shared
import spock.lang.Specification
import spock.lang.Unroll
import  oracle.fsgbu.obscfcm.services.report.model.CurrencyUtilityDto
 
class CurrencyUtilityDtoSpec extends Specification {
 
		@Unroll("#amount getters should return TxnRefNo ")
		def"test currencyUtilityDto accessors"(){
			given:
			def currencyUtilityDto = new CurrencyUtilityDto();
			when:
				currencyUtilityDto.setAmount (10)
				currencyUtilityDto.setRate (10)
 
			then:
				currencyUtilityDto.getAmount() == amount
				currencyUtilityDto.getRate() == rate
 
			where:
			amount | rate
			 10       |  10
		}
		def"use Spy to test currencyUtilityDto::toString() using partial mocking."(){
			def currencyUtilityDto = Spy(CurrencyUtilityDto);
			given:
			currencyUtilityDto.getAmount() >> 10
			currencyUtilityDto.getRate() >> 10
 
			when:
			def s = currencyUtilityDto.toString()
			then:
			println(s)
		}
		@Unroll("test equals method")
		def"test equals method"(){
			given:
			def currencyUtilityDto = new CurrencyUtilityDto();
			when:
				currencyUtilityDto.setAmount (10)
				currencyUtilityDto.setRate (10)
 
			then:
				currencyUtilityDto.getAmount() == amount
				currencyUtilityDto.getRate() == rate
 
			where:
			amount | rate
			 10       |  10
		}
}