package oracle.fsgbu.customer.test.service


import oracle.fsgbu.accountMaintenance.api.model.*
import oracle.fsgbu.obscfcm.services.report.domain.entity.*
import oracle.fsgbu.obscfcm.services.report.persistence.*
import oracle.fsgbu.obscfcm.services.report.service.AccountMaintenanceListenerServiceImpl
import spock.lang.Specification
import spock.lang.Unroll

class AccountMaintenanceListenerServiceImplSpec extends Specification {

    AccountMaintenanceListenerServiceImpl instance = new AccountMaintenanceListenerServiceImpl();

    @Unroll("test dateConverter method")
    def "test dateConverter method"() {
        when:
        def res = instance.dateConverter("2022-03-31")
        then:
        res != null
    }
    @Unroll("test dateConverter null date")
    def "test dateConverter null date"() {
        when:
        def res = instance.dateConverter(null)
        then:
        res == null
    }

    @Unroll("test saveAccousaveAccountRoleTWDatantRoleTWData method")
    def "test saveAccountRoleTWData method"() {
        given:

        List<ScfTmAccountRoleMasterWork> scfTmAccountRoleMasterWorkList = new ArrayList<>();
        ScfTmAccountRoleMasterWorkRepository scfTmAccountRoleMasterWorkRepository = Mock();
        scfTmAccountRoleMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterWorkList
        instance.scfTmAccountRoleMasterWorkRepository = scfTmAccountRoleMasterWorkRepository
        when:
        def response = instance.saveAccountRoleTWData(getRoleWebModel(), "userId", "branchCode")
        then:
        response == true

    }
    @Unroll("test saveAccousaveAccountRoleTWDatantRoleTWData throws exception")
    def "test saveAccountRoleTWData method throws exception"() {
        given:

        List<ScfTmAccountRoleMasterWork> scfTmAccountRoleMasterWorkList = new ArrayList<>();
        ScfTmAccountRoleMasterWorkRepository scfTmAccountRoleMasterWorkRepository = Mock();
        scfTmAccountRoleMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterWorkList
        instance.scfTmAccountRoleMasterWorkRepository = scfTmAccountRoleMasterWorkRepository
        when:
        def response = instance.saveAccountRoleTWData(null, "userId", "branchCode")
        then:
        response == false
    }
	
	@Unroll("test saveAccousaveAccountRoleTWDatantRoleTWData method")
	def "test saveAccountRoleTWData method1"() {
		given:

		List<ScfTmAccountRoleMasterWork> scfTmAccountRoleMasterWorkList = new ArrayList<>();
		ScfTmAccountRoleMasterWork ScfTmAccountRoleMasterWork = new ScfTmAccountRoleMasterWork()
		scfTmAccountRoleMasterWorkList.add(ScfTmAccountRoleMasterWork)
		ScfTmAccountRoleMasterWorkRepository scfTmAccountRoleMasterWorkRepository = Mock();
		scfTmAccountRoleMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterWorkList
		instance.scfTmAccountRoleMasterWorkRepository = scfTmAccountRoleMasterWorkRepository
		when:
		def response = instance.saveAccountRoleTWData(getRoleWebModel(), "userId", "branchCode")
		then:
		response == true

	}


    @Unroll("test saveAccountRoleTMData method")
    def "test saveAccountRoleTMData method"() {
        given:
        List<ScfTmAccountRoleMaster> scfTmAccountRoleMasterWorkList = new ArrayList<>();
        ScfTmAccountRoleMasterRepository scfTmAccountRoleMasterRepository = Mock()
        scfTmAccountRoleMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterWorkList
        instance.scfTmAccountRoleMasterRepository = scfTmAccountRoleMasterRepository
        when:
        def response = instance.saveAccountRoleTMData(getRoleWebModel(), "userId", "branchCode")
        then:
        response == true
    }
    @Unroll("test saveAccountRoleTMData method throws exception")
    def "test saveAccountRoleTMData method throws exception"() {
        given:
        List<ScfTmAccountRoleMaster> scfTmAccountRoleMasterWorkList = new ArrayList<>();
        ScfTmAccountRoleMasterRepository scfTmAccountRoleMasterRepository = Mock()
        scfTmAccountRoleMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterWorkList
        instance.scfTmAccountRoleMasterRepository = scfTmAccountRoleMasterRepository
        when:
        def response = instance.saveAccountRoleTMData(null, "userId", "branchCode")
        then:
        response == false
    }

	@Unroll("test saveAccountRoleTMData method")
	def "test saveAccountRoleTMData method1"() {
		given:
		List<ScfTmAccountRoleMaster> scfTmAccountRoleMasterWorkList = new ArrayList<>();
		ScfTmAccountRoleMaster ScfTmAccountRoleMaster = new ScfTmAccountRoleMaster()
		scfTmAccountRoleMasterWorkList.add(ScfTmAccountRoleMaster)
		ScfTmAccountRoleMasterRepository scfTmAccountRoleMasterRepository = Mock()
		scfTmAccountRoleMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterWorkList
		instance.scfTmAccountRoleMasterRepository = scfTmAccountRoleMasterRepository
		when:
		def response = instance.saveAccountRoleTMData(getRoleWebModel(), "userId", "branchCode")
		then:
		response == true
	}

	
    @Unroll("test saveAccountEntryTMData method")
    def "test saveAccountEntryTMData method"() {
        given:
        List<ScfcmTmAccEntryMaster> scfTmAccountRoleMasterList = new ArrayList<>()
        ScfcmTmAccEntryMasterRepository scfcmTmAccEntryMasterRepository = Mock()
        instance.scfcmTmAccEntryMasterRepository = scfcmTmAccEntryMasterRepository
        scfcmTmAccEntryMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterList
        when:
        def res = instance.saveAccountEntryTMData(getAccentryWebModel(), "userId", "branchCode")
        then:
        res == true
    }

    @Unroll("test saveAccountEntryTMData method throws exception")
    def "test saveAccountEntryTMData method throws exception"() {
        given:
        List<ScfcmTmAccEntryMaster> scfTmAccountRoleMasterList = new ArrayList<>()
        ScfcmTmAccEntryMasterRepository scfcmTmAccEntryMasterRepository = Mock()
        instance.scfcmTmAccEntryMasterRepository = scfcmTmAccEntryMasterRepository
        scfcmTmAccEntryMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterList
        when:
        def res = instance.saveAccountEntryTMData(null, "userId", "branchCode")
        then:
        res == false
    }
	
	@Unroll("test saveAccountEntryTMData method")
	def "test saveAccountEntryTMData method1"() {
		given:
		List<ScfcmTmAccEntryMaster> scfTmAccountRoleMasterList = new ArrayList<>()
		ScfcmTmAccEntryMaster ScfcmTmAccEntryMaster = new ScfcmTmAccEntryMaster()
		scfTmAccountRoleMasterList.add(ScfcmTmAccEntryMaster)
		ScfcmTmAccEntryMasterRepository scfcmTmAccEntryMasterRepository = Mock()
		instance.scfcmTmAccEntryMasterRepository = scfcmTmAccEntryMasterRepository
		scfcmTmAccEntryMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterList
		when:
		def res = instance.saveAccountEntryTMData(getAccentryWebModel(), "userId", "branchCode")
		then:
		res == true
	}

    @Unroll("test saveAccountEntryTWData method")
    def "test saveAccountEntryTWData method"() {
        given:
        List<ScfcmTmAccEntryMaster> scfTmAccountRoleMasterList = new ArrayList<>()
        ScfcmTmAccEntryMasterWorkRepository scfcmTmAccEntryMasterWorkRepository = Mock()
        instance.scfcmTmAccEntryMasterWorkRepository = scfcmTmAccEntryMasterWorkRepository
        scfcmTmAccEntryMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterList
        when:
        def res = instance.saveAccountEntryTWData(getAccentryWebModel(), "userId", "branchCode")
        then:
        res == true
    }

    @Unroll("test saveAccountEntryTWData method throws exception")
    def "test saveAccountEntryTWData method throws exception"() {
        given:
        List<ScfcmTmAccEntryMaster> scfTmAccountRoleMasterList = new ArrayList<>()
        ScfcmTmAccEntryMasterWorkRepository scfcmTmAccEntryMasterWorkRepository = Mock()
        instance.scfcmTmAccEntryMasterWorkRepository = scfcmTmAccEntryMasterWorkRepository
        scfcmTmAccEntryMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterList
        when:
        def res = instance.saveAccountEntryTWData(null, "userId", "branchCode")
        then:
        res == false
    }

	@Unroll("test saveAccountEntryTWData method")
	def "test saveAccountEntryTWData method1"() {
		given:
		List<ScfcmTmAccEntryMaster> scfTmAccountRoleMasterList = new ArrayList<>()
		ScfcmTmAccEntryMaster scfcmTmAccEntryMaster = new ScfcmTmAccEntryMaster()
		scfTmAccountRoleMasterList.add(scfcmTmAccEntryMaster)
		ScfcmTmAccEntryMasterWorkRepository scfcmTmAccEntryMasterWorkRepository = Mock()
		instance.scfcmTmAccEntryMasterWorkRepository = scfcmTmAccEntryMasterWorkRepository
		scfcmTmAccEntryMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfTmAccountRoleMasterList
		scfcmTmAccEntryMasterWorkRepository.save(_) >> null
		
		when:
		def res = instance.saveAccountEntryTWData(getAccentryWebModel(), "userId", "branchCode")
		then:
		res == false
	}
	
    @Unroll("test saveAccountEntryCodeTWData method")
    def "test saveAccountEntryCodeTWData method"() {
        given:
        List<ScfcmTmAccEntryCodeMasterWork> scfcmTmAccEntryCodeMasterWorkList = new ArrayList<>()
        ScfcmTmAccEntryCodeMasterWorkRepository scfcmTmAccEntryCodeMasterWorkRepository = Mock()
        instance.scfcmTmAccEntryCodeMasterWorkRepository = scfcmTmAccEntryCodeMasterWorkRepository
        scfcmTmAccEntryCodeMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmAccEntryCodeMasterWorkList
        when:
        def res = instance.saveAccountEntryCodeTWData(getAccentryCodeWebModel(), "userId", "branchCode")
        then:
        res == true
    }

    @Unroll("test saveAccountEntryCodeTWData method throws exception")
    def "test saveAccountEntryCodeTWData method throws exception"() {
        given:
        List<ScfcmTmAccEntryCodeMasterWork> scfcmTmAccEntryCodeMasterWorkList = new ArrayList<>()
        ScfcmTmAccEntryCodeMasterWorkRepository scfcmTmAccEntryCodeMasterWorkRepository = Mock()
        instance.scfcmTmAccEntryCodeMasterWorkRepository = scfcmTmAccEntryCodeMasterWorkRepository
        scfcmTmAccEntryCodeMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmAccEntryCodeMasterWorkList
        when:
        def res = instance.saveAccountEntryCodeTWData(null, "userId", "branchCode")
        then:
        res == false
    }

	@Unroll("test saveAccountEntryCodeTWData method")
	def "test saveAccountEntryCodeTWData method1"() {
		given:
		List<ScfcmTmAccEntryCodeMasterWork> scfcmTmAccEntryCodeMasterWorkList = new ArrayList<>()
		ScfcmTmAccEntryCodeMasterWork ScfcmTmAccEntryCodeMasterWork = new ScfcmTmAccEntryCodeMasterWork()
		scfcmTmAccEntryCodeMasterWorkList.add(ScfcmTmAccEntryCodeMasterWork)
		ScfcmTmAccEntryCodeMasterWorkRepository scfcmTmAccEntryCodeMasterWorkRepository = Mock()
		instance.scfcmTmAccEntryCodeMasterWorkRepository = scfcmTmAccEntryCodeMasterWorkRepository
		scfcmTmAccEntryCodeMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmAccEntryCodeMasterWorkList
		when:
		def res = instance.saveAccountEntryCodeTWData(getAccentryCodeWebModel(), "userId", "branchCode")
		then:
		res == true
	}
	
    @Unroll("test saveAccountEntryCodeTMData method")
    def "test saveAccountEntryCodeTMData method"() {
        given:
        List<ScfcmTmAccEntryCodeMasterWork> scfcmTmAccEntryCodeMasterWorkList = new ArrayList<>()
        ScfcmTmAccEntryCodeMasterRepository scfcmTmAccEntryCodeMasterRepository = Mock()
        instance.scfcmTmAccEntryCodeMasterRepository = scfcmTmAccEntryCodeMasterRepository
        scfcmTmAccEntryCodeMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmAccEntryCodeMasterWorkList
        when:
        def res = instance.saveAccountEntryCodeTMData(getAccentryCodeWebModel(), "userId", "branchCode")
        then:
        res == true
    }

    @Unroll("test saveAccountEntryCodeTMData method throws exception")
    def "test saveAccountEntryCodeTMData method throws exception"() {
        given:
        List<ScfcmTmAccEntryCodeMasterWork> scfcmTmAccEntryCodeMasterWorkList = new ArrayList<>()
        ScfcmTmAccEntryCodeMasterRepository scfcmTmAccEntryCodeMasterRepository = Mock()
        instance.scfcmTmAccEntryCodeMasterRepository = scfcmTmAccEntryCodeMasterRepository
        scfcmTmAccEntryCodeMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmAccEntryCodeMasterWorkList
        when:
        def res = instance.saveAccountEntryCodeTMData(null, "userId", "branchCode")
        then:
        res == false
    }

	@Unroll("test saveAccountEntryCodeTMData method")
	def "test saveAccountEntryCodeTMData method1"() {
		given:
		List<ScfcmTmAccEntryCodeMasterWork> scfcmTmAccEntryCodeMasterWorkList = new ArrayList<>()
		ScfcmTmAccEntryCodeMasterWork ScfcmTmAccEntryCodeMasterWork = new ScfcmTmAccEntryCodeMasterWork()
		scfcmTmAccEntryCodeMasterWorkList.add(ScfcmTmAccEntryCodeMasterWork)
		ScfcmTmAccEntryCodeMasterRepository scfcmTmAccEntryCodeMasterRepository = Mock()
		instance.scfcmTmAccEntryCodeMasterRepository = scfcmTmAccEntryCodeMasterRepository
		scfcmTmAccEntryCodeMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmAccEntryCodeMasterWorkList
		scfcmTmAccEntryCodeMasterRepository.save(_) >> null
		when:
		def res = instance.saveAccountEntryCodeTMData(getAccentryCodeWebModel(), "userId", "branchCode")
		then:
		res == false
	}
    @Unroll("test saveInternalAccountMapTWData method")
    def "test saveInternalAccountMapTWData method"() {
        given:
        List<ScfcmTmIntAccMapMasterWork> scfcmTmIntAccMapMasterWorkList = new ArrayList<>()
        ScfcmTmIntAccMapMasterWorkRepository scfcmTmIntAccMapMasterWorkRepository = Mock()
        instance.scfcmTmIntAccMapMasterWorkRepository = scfcmTmIntAccMapMasterWorkRepository
        scfcmTmIntAccMapMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmIntAccMapMasterWorkList
        when:
        def res = instance.saveInternalAccountMapTWData(getIntaccmapWebModel(), "userId", "branchCode")
        then:
        res == true
    }

    @Unroll("test saveInternalAccountMapTWData method throws exception")
    def "test saveInternalAccountMapTWData method throws exception"() {
        given:
        List<ScfcmTmIntAccMapMasterWork> scfcmTmIntAccMapMasterWorkList = new ArrayList<>()
        ScfcmTmIntAccMapMasterWorkRepository scfcmTmIntAccMapMasterWorkRepository = Mock()
        instance.scfcmTmIntAccMapMasterWorkRepository = scfcmTmIntAccMapMasterWorkRepository
        scfcmTmIntAccMapMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmIntAccMapMasterWorkList
        when:
        def res = instance.saveInternalAccountMapTWData(null, "userId", "branchCode")
        then:
        res == false
    }

	@Unroll("test saveInternalAccountMapTWData method")
	def "test saveInternalAccountMapTWData method1"() {
		given:
		List<ScfcmTmIntAccMapMasterWork> scfcmTmIntAccMapMasterWorkList = new ArrayList<>()
		ScfcmTmIntAccMapMasterWork ScfcmTmIntAccMapMasterWork = new ScfcmTmIntAccMapMasterWork()
		scfcmTmIntAccMapMasterWorkList.add(ScfcmTmIntAccMapMasterWork)
		ScfcmTmIntAccMapMasterWorkRepository scfcmTmIntAccMapMasterWorkRepository = Mock()
		instance.scfcmTmIntAccMapMasterWorkRepository = scfcmTmIntAccMapMasterWorkRepository
		scfcmTmIntAccMapMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmIntAccMapMasterWorkList
		when:
		def res = instance.saveInternalAccountMapTWData(getIntaccmapWebModel(), "userId", "branchCode")
		then:
		res == true
	}
    @Unroll("test saveInternalAccountMapTMData method")
    def "test saveInternalAccountMapTMData method"() {
        given:
        List<ScfcmTmIntAccMapMaster> scfcmTmIntAccMapMasterList = new ArrayList<>()
        ScfcmTmIntAccMapMasterRepository scfcmTmIntAccMapMasterRepository = Mock()
        instance.scfcmTmIntAccMapMasterRepository = scfcmTmIntAccMapMasterRepository
        scfcmTmIntAccMapMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmIntAccMapMasterList
        when:
        def res = instance.saveInternalAccountMapTMData(getIntaccmapWebModel(), "userId", "branchCode")
        then:
        res == true

    }

    @Unroll("test saveInternalAccountMapTMData method throws exception")
    def "test saveInternalAccountMapTMData method throws exception"() {
        given:
        List<ScfcmTmIntAccMapMaster> scfcmTmIntAccMapMasterList = new ArrayList<>()
        ScfcmTmIntAccMapMasterRepository scfcmTmIntAccMapMasterRepository = Mock()
        instance.scfcmTmIntAccMapMasterRepository = scfcmTmIntAccMapMasterRepository
        scfcmTmIntAccMapMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmIntAccMapMasterList
        when:
        def res = instance.saveInternalAccountMapTMData(null, "userId", "branchCode")
        then:
        res == false

    }

	@Unroll("test saveInternalAccountMapTMData method")
	def "test saveInternalAccountMapTMData method1"() {
		given:
		List<ScfcmTmIntAccMapMaster> scfcmTmIntAccMapMasterList = new ArrayList<>()
		ScfcmTmIntAccMapMaster ScfcmTmIntAccMapMaster = new ScfcmTmIntAccMapMaster()
		scfcmTmIntAccMapMasterList.add(ScfcmTmIntAccMapMaster)
		ScfcmTmIntAccMapMasterRepository scfcmTmIntAccMapMasterRepository = Mock()
		instance.scfcmTmIntAccMapMasterRepository = scfcmTmIntAccMapMasterRepository
		scfcmTmIntAccMapMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmIntAccMapMasterList
		when:
		def res = instance.saveInternalAccountMapTMData(getIntaccmapWebModel(), "userId", "branchCode")
		then:
		res == true

	}
    @Unroll("test saveExternalAccountMapTWData method")
    def "test saveExternalAccountMapTWData method"() {
        given:
        List<ScfcmTmExtAccMapMasterWork> scfcmTmExtAccMapMasterWorkList = new ArrayList<>()
        ScfcmTmExtAccMapMasterWorkRepository scfcmTmExtAccMapMasterWorkRepository = Mock()
        instance.scfcmTmExtAccMapMasterWorkRepository = scfcmTmExtAccMapMasterWorkRepository
        scfcmTmExtAccMapMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmExtAccMapMasterWorkList
        when:
        def res = instance.saveExternalAccountMapTWData(getExternalWebModel(), "userId", "branchCode")
        then:
        res == true
    }

    @Unroll("test saveExternalAccountMapTWData method throws exception")
    def "test saveExternalAccountMapTWData method throws exception"() {
        given:
        List<ScfcmTmExtAccMapMasterWork> scfcmTmExtAccMapMasterWorkList = new ArrayList<>()
        ScfcmTmExtAccMapMasterWorkRepository scfcmTmExtAccMapMasterWorkRepository = Mock()
        instance.scfcmTmExtAccMapMasterWorkRepository = scfcmTmExtAccMapMasterWorkRepository
        scfcmTmExtAccMapMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmExtAccMapMasterWorkList
        when:
        def res = instance.saveExternalAccountMapTWData(null, "userId", "branchCode")
        then:
        res == false
    }

	
	@Unroll("test saveExternalAccountMapTWData method")
	def "test saveExternalAccountMapTWData method1"() {
		given:
		List<ScfcmTmExtAccMapMasterWork> scfcmTmExtAccMapMasterWorkList = new ArrayList<>()
		ScfcmTmExtAccMapMasterWork ScfcmTmExtAccMapMasterWork = new ScfcmTmExtAccMapMasterWork()
		scfcmTmExtAccMapMasterWorkList.add(ScfcmTmExtAccMapMasterWork)
		ScfcmTmExtAccMapMasterWorkRepository scfcmTmExtAccMapMasterWorkRepository = Mock()
		instance.scfcmTmExtAccMapMasterWorkRepository = scfcmTmExtAccMapMasterWorkRepository
		scfcmTmExtAccMapMasterWorkRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmExtAccMapMasterWorkList
		when:
		def res = instance.saveExternalAccountMapTWData(getExternalWebModel(), "userId", "branchCode")
		then:
		res == true
	}

    @Unroll("test saveExternalAccountMapTMData method")
    def "test saveExternalAccountMapTMData method"() {
        given:
        List<ScfcmTmExtAccMapMaster> scfcmTmExtAccMapMasterList = new ArrayList<>()
        ScfcmTmExtAccMapMasterRepository scfcmTmExtAccMapMasterRepository = Mock()
        instance.scfcmTmExtAccMapMasterRepository = scfcmTmExtAccMapMasterRepository
        scfcmTmExtAccMapMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmExtAccMapMasterList
        when:
        def res = instance.saveExternalAccountMapTMData(getExternalWebModel(), "userId", "branchCode")
        then:
        res == true
    }

    @Unroll("test saveExternalAccountMapTMData method throws exception")
    def "test saveExternalAccountMapTMData method throws exception"() {
        given:
        List<ScfcmTmExtAccMapMaster> scfcmTmExtAccMapMasterList = new ArrayList<>()
        ScfcmTmExtAccMapMasterRepository scfcmTmExtAccMapMasterRepository = Mock()
        instance.scfcmTmExtAccMapMasterRepository = scfcmTmExtAccMapMasterRepository
        scfcmTmExtAccMapMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmExtAccMapMasterList
        when:
        def res = instance.saveExternalAccountMapTMData(null, "userId", "branchCode")
        then:
        res == false
    }
	
	@Unroll("test saveExternalAccountMapTMData method")
	def "test saveExternalAccountMapTMData method1"() {
		given:
		List<ScfcmTmExtAccMapMaster> scfcmTmExtAccMapMasterList = new ArrayList<>()
		ScfcmTmExtAccMapMaster ScfcmTmExtAccMapMaster = new ScfcmTmExtAccMapMaster()
		scfcmTmExtAccMapMasterList.add(ScfcmTmExtAccMapMaster)
		ScfcmTmExtAccMapMasterRepository scfcmTmExtAccMapMasterRepository = Mock()
		
		instance.scfcmTmExtAccMapMasterRepository = scfcmTmExtAccMapMasterRepository
		scfcmTmExtAccMapMasterRepository.executeNamedQueryByCondition(_, _, _) >> scfcmTmExtAccMapMasterList
		when:
		def res = instance.saveExternalAccountMapTMData(getExternalWebModel(), "userId", "branchCode")
		then:
		res == true
	}


    def getAccentryWebModel() {
        AccentryWebModel accentryWebModel = new AccentryWebModel()
        accentryWebModel.setResourceId("id")
        accentryWebModel.setResourceName("resname")
        accentryWebModel.setOperationType("optype")
        accentryWebModel.setMakerId("makerid")
        accentryWebModel.setMakerDateStamp(new Date())
        accentryWebModel.setCheckerId("checkid")
        accentryWebModel.setCheckerDateStamp(new Date())
        accentryWebModel.setModNo(1)
        accentryWebModel.setRecordStatus("status")
        accentryWebModel.setAuthStatus("authstatus")
        accentryWebModel.setOnceAuth("onceauth")
        accentryWebModel.setDoerRemarks("remarks")
        accentryWebModel.setApproverRemarks("approverremarks")
        ScfTmAccEntryMasterDTO scfcmTmAccEntryMaster = getScfcmTmAccEntryMaster()
        accentryWebModel.setScfcmTmAccEntryMaster(scfcmTmAccEntryMaster)
        List<Object> extendedDS = new ArrayList<>()
        accentryWebModel.setExtendedDatasegments(extendedDS)
        return accentryWebModel
    }

    def getRoleWebModel() {
        RoleWebModel accRoleWebModel = new RoleWebModel()
        accRoleWebModel.setResourceId("resourceId")
        accRoleWebModel.setResourceName("name")
        accRoleWebModel.setOperationType("operationType")
        accRoleWebModel.setMakerId("makerId")
        accRoleWebModel.setMakerDateStamp(new Date())
        accRoleWebModel.setCheckerId("checkerId")
        accRoleWebModel.setCheckerDateStamp(new Date())
        accRoleWebModel.setModNo(1)
        accRoleWebModel.setRecordStatus("recordStatus")
        accRoleWebModel.setAuthStatus("authStatus")
        accRoleWebModel.setOnceAuth("onceAuth")
        accRoleWebModel.setDoerRemarks("doerremarks")
        accRoleWebModel.setApproverRemarks("approverRemarks")
        ScfTmAccountRoleMasterDTO masterDTO = getScfTmAccountRoleMasterDTO()
        accRoleWebModel.setScfTmAccountRoleMaster(masterDTO)
        accRoleWebModel.setExtendedDatasegments(new ArrayList<Object>())
        return accRoleWebModel
    }

    def getScfTmAccountRoleMasterDTO() {
        ScfTmAccountRoleMasterDTO dto = new ScfTmAccountRoleMasterDTO()
        dto.setId("id")
        dto.setAction("action")
        dto.setAutoAuth("autoauth")
        dto.setModificationStatus("modstatus")
        dto.setDatasegmentCode("segmentcode")
        dto.setCheckerRemarks("checkerremarks")
        dto.setMakerRemarks("makerremarks")
        dto.setAccRoleCode("accrolecode")
        dto.setAccRoleDescription("accroledesc")
        return dto
    }

    def ScfTmAccEntryMasterDTO getScfcmTmAccEntryMaster() {
        ScfTmAccEntryMasterDTO dto = new ScfTmAccEntryMasterDTO()
        dto.setId("id")
        dto.setAction("action")
        dto.setAutoAuth("autoauto")
        dto.setModificationStatus("modstatus")
        dto.setDatasegmentCode("dscode")
        dto.setCheckerRemarks("checkerermarks")
        dto.setMakerRemarks("makerremarks")
        dto.setBranchCode("bcode")
        dto.setEventCode("ecode")
        dto.setFilterAttr1("fa1")
        dto.setFilterAttr1Name("faname")
        dto.setFilterAttr2("fa2")
        dto.setFilterAttr2Name("faname")
        dto.setFilterAttr3("fa2")
        dto.setFilterAttr3Name("faname")
        dto.setFilterAttr4("fa4")
        dto.setFilterAttr4Name("faname")
        dto.setFilterAttr5("fa5")
        dto.setFilterAttr5Name("faname")
        dto.setFilterAttr6("fa6")
        dto.setFilterAttr6Name("faname")
        dto.setFilterAttr7("fa7")
        dto.setFilterAttr7Name("faname")
        dto.setFilterAttr8("fa8")
        dto.setFilterAttr8Name("faname")
        dto.setFilterAttr9("fa9")
        dto.setFilterAttr9Name("faname")
        dto.setFilterAttr10("fa10")
        dto.setFilterAttr10Name("faname")
        dto.setFilterCriteria("fcriteria")
        dto.setFilterCriteriaDesc("cdesc")
        dto.setFilterParameters("fParam")
        dto.setProductCode("pcode")
        dto.setApplicationCode("appcode")
        List<ScfTmAccEntryDetailsDTO> scfTmAccEntryDetailsDTO = getScfTmAccEntryDetailsDTO()
        dto.setScfTmAccEntryDetailsDTO(scfTmAccEntryDetailsDTO)
        return dto
    }

    List<ScfTmAccEntryDetailsDTO> getScfTmAccEntryDetailsDTO() {
        List<ScfTmAccEntryDetailsDTO> list = new ArrayList<>()
        ScfTmAccEntryDetailsDTO dto = new ScfTmAccEntryDetailsDTO()
        dto.setId("id")
        dto.setAccEntryCode("entrycode")
        dto.setAccEntryMasterId("masterid")
        dto.setSequence(new BigDecimal("1"))
        list.add(dto)
        return list
    }

    def AccentrycodeWebModel getAccentryCodeWebModel() {
        AccentrycodeWebModel model = new AccentrycodeWebModel()
        model.setResourceId("resourceid")
        model.setResourceName("name")
        model.setOperationType("type")
        model.setMakerId("makerId")
        model.setMakerDateStamp(new Date())
        model.setCheckerId("chekerId")
        model.setCheckerDateStamp(new Date())
        model.setModNo(1)
        model.setRecordStatus("status")
        model.setAuthStatus("authstatus")
        model.setOnceAuth("onceauth")
        model.setDoerRemarks("doerremarks")
        model.setApproverRemarks("appRemarks")
        ScfTmAccEntryCodeMasterDTO scfcmTmAccEntryCodeMaster = getScfcmTmAccEntryCodeMaster()
        model.setScfcmTmAccEntryCodeMaster(scfcmTmAccEntryCodeMaster)
        List<Object> ds = new ArrayList<>()
        ds.add(new Object())
        model.setExtendedDatasegments(ds)
        return model
    }

    def ScfTmAccEntryCodeMasterDTO getScfcmTmAccEntryCodeMaster() {
        ScfTmAccEntryCodeMasterDTO dto = new ScfTmAccEntryCodeMasterDTO()
        dto.setId("id")
        dto.setAction("action")
        dto.setAutoAuth("autoauth")
        dto.setModificationStatus("status")
        dto.setDatasegmentCode("dscode")
        dto.setCheckerRemarks("cremarks")
        dto.setMakerRemarks("mremarks")
        dto.setAccEntryCode("entrycode")
        dto.setAccEntryDescription("entrydesc")
        dto.setApplicationCode("appcode")
        dto.setSequence(new BigDecimal("1"))
        List<ScfTmAccEntryCodeDetailsDTO> scfDto = getScfTmAccEntryCodeDetailsDTO()
        dto.setScfTmAccEntryCodeDetailsDTO(scfDto)
        return dto
    }

    def List<ScfTmAccEntryCodeDetailsDTO> getScfTmAccEntryCodeDetailsDTO() {
        List<ScfTmAccEntryCodeDetailsDTO> list = new ArrayList<>();
        ScfTmAccEntryCodeDetailsDTO dto = new ScfTmAccEntryCodeDetailsDTO()
        dto.setId("id")
        dto.setAccEntryCode("entrycode")
        dto.setAccEntryCodeMasterId("masterid")
        dto.setCreditAccRoleCode("roleCode")
        dto.setCreditAmountType("type")
        dto.setCreditPartyType("partytype")
        dto.setCreditSettlementMethod("method")
        dto.setDebitAccRoleCode("accrolecode")
        dto.setDebitAmountType("amttype")
        dto.setDebitPartyType("partytype")
        dto.setDebitSettlementMethod("settlementmethod")
        list.add(dto)
        return list
    }

    def IntaccmapWebModel getIntaccmapWebModel() {
        IntaccmapWebModel model = new IntaccmapWebModel()

        model.setResourceId("id")
        model.setResourceName("ame")
        model.setOperationType("optype")
        model.setMakerId("makerId")
        model.setMakerDateStamp(new Date())
        model.setCheckerId("chkId")
        model.setCheckerDateStamp(new Date())
        model.setModNo(1)
        model.setRecordStatus("status")
        model.setAuthStatus("authstatus")
        model.setOnceAuth("onceauth")
        model.setDoerRemarks("doinerremarks")
        model.setApproverRemarks("appRemarks")

        ScfTmIntAccMapMasterDTO mapMaster = getScfTmIntAccMapMasterDTO()
        model.setScfcmTmIntAccMapMaster(mapMaster)

        List<Object> ds = new ArrayList<>()
        ds.add(new Object())
        model.setExtendedDatasegments(ds)
        return model
    }

    def ScfTmIntAccMapMasterDTO getScfTmIntAccMapMasterDTO() {
        ScfTmIntAccMapMasterDTO dto = new ScfTmIntAccMapMasterDTO()
        dto.setId("id")
        dto.setAction("action")
        dto.setAutoAuth("auth")
        dto.setModificationStatus("status")
        dto.setDatasegmentCode("dscode")
        dto.setCheckerRemarks("remarks")
        dto.setMakerRemarks("mkremarks")
        dto.setAccInTxnCcy("inccy")
        dto.setAccRoleCode("rolecode")
        dto.setAccType("acctype")
        dto.setBranchCode("branchcode")
        dto.setFilterAttr1("a1")
        dto.setFilterAttr1Name("aname")
        dto.setFilterAttr2("a1")
        dto.setFilterAttr2Name("aname")
        dto.setFilterAttr3("a1")
        dto.setFilterAttr3Name("aname")
        dto.setFilterAttr4("a1")
        dto.setFilterAttr4Name("aname")
        dto.setFilterAttr5("a1")
        dto.setFilterAttr5Name("aname")
        dto.setFilterCriteria("fcriteria")
        dto.setFilterCriteriaDesc("fdesc")
        dto.setFilterParameters("fparams")
        dto.setProductCode("pcode")
        dto.setSettlementMethod("smethod")
        dto.setApplicationCode("appcode")
        List<ScfTmIntAccMapDetailsDTO> intDto = getScfTmIntAccMapDetailsDTO()
        dto.setScfTmIntAccMapDetailsDTO(intDto)
        return dto
    }

    def List<ScfTmIntAccMapDetailsDTO> getScfTmIntAccMapDetailsDTO() {
        List<ScfTmIntAccMapDetailsDTO> list = new ArrayList<>()
        ScfTmIntAccMapDetailsDTO dto = new ScfTmIntAccMapDetailsDTO()

        dto.setId("id")
        dto.setAccountCcy("ccy")
        dto.setAccountName("name")
        dto.setAccountNo("no")
        dto.setDefaultAccount("defAcc")
        dto.setIntMasterId("masterId")
        dto.setVaFlagYn("N")
        dto.setContraAccNo("accNo")

        list.add(dto)
        return list
    }

    ExternalWebModel getExternalWebModel() {
        ExternalWebModel model = new ExternalWebModel()
        model.setResourceId("rid")
        model.setResourceName("rname")
        model.setOperationType("optype")
        model.setMakerId("mkid")
        model.setMakerDateStamp(new Date())
        model.setCheckerId("cid")
        model.setCheckerDateStamp(new Date())
        model.setModNo(1)
        model.setRecordStatus("rstatus")
        model.setAuthStatus("athstatus")
        model.setOnceAuth("onceauth")
        model.setDoerRemarks("dremarks")
        model.setApproverRemarks("aremarks")

        ScfTmExtAccMapMasterDTO master = getScfTmExtAccMapMasterDTO()
        model.setScfcmTmExtAccMapMaster(master)

        List<Object> ds = new ArrayList<>()
        ds.add(new Object())
        model.setExtendedDatasegments(ds)
        return model
    }

    ScfTmExtAccMapMasterDTO getScfTmExtAccMapMasterDTO() {
        ScfTmExtAccMapMasterDTO dto = new ScfTmExtAccMapMasterDTO()
        dto.setId("id")
        dto.setAction("action")
        dto.setAutoAuth("auto")
        dto.setModificationStatus("modstatus")
        dto.setDatasegmentCode("dscode")
        dto.setCheckerRemarks("cremarks")
        dto.setMakerRemarks("mremarks")
        dto.setAccountNumber("accno")
        dto.setBankId("bid")
        dto.setBankName("bname")
        dto.setBranchCode("bcode")
        dto.setBranchName("brname")
        dto.setDefaultAccount("defAcc")
        dto.setEventCode("eventcode")
        dto.setFilterAttr1("att1")
        dto.setFilterAttr1Name("attName")
        dto.setFilterAttr2("att1")
        dto.setFilterAttr2Name("attName")
        dto.setFilterAttr3("att1")
        dto.setFilterAttr3Name("attName")
        dto.setFilterAttr4("att1")
        dto.setFilterAttr4Name("attName")
        dto.setFilterAttr5("att1")
        dto.setFilterAttr5Name("attName")
        dto.setFilterCriteria("fcriteria")
        dto.setFilterCriteriaDesc("cdesc")
        dto.setFilterParameters("fParams")
        dto.setFilterType("ftype")
        dto.setIfscCode("icode")
        dto.setPartyId("pid")
        dto.setPaymentMode("pmode")
        dto.setProductCode("pcode")
        dto.setApplicationCode("acode")
        dto.setAccountCcy("ccy")
        return dto
    }
}
