package oracle.fsgbu.customer.test.service


import oracle.fsgbu.obscfcm.services.ob.services.charges.web.api.model.FinanceTxnDTO
import oracle.fsgbu.obscfcm.services.ob.services.charges.web.api.model.InstrumentTxnDTO
import oracle.fsgbu.obscfcm.services.ob.services.charges.web.api.model.ObChargesTxnDTO
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObChargesTxn
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObChargesTxnTw
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObFinanceTxnTwDetails
import oracle.fsgbu.obscfcm.services.report.domain.entity.ObInvoiceTxnDetails
import oracle.fsgbu.obscfcm.services.report.persistence.ObChargeTxnRepository
import oracle.fsgbu.obscfcm.services.report.persistence.ObChargeTxnTwRepository
import oracle.fsgbu.obscfcm.services.report.persistence.ObFinanceTwDetailsRepository
import oracle.fsgbu.obscfcm.services.report.persistence.ObInvoiceTxnRepository
import oracle.fsgbu.obscfcm.services.report.persistence.ObInvoiceTxnTwRepository
import oracle.fsgbu.obscfcm.services.report.service.ChargesListenerServiceImpl
import spock.lang.Specification
import spock.lang.Unroll

class ChargesListenerServiceImplSpec extends Specification {
	ChargesListenerServiceImpl instance = new ChargesListenerServiceImpl();
	@Unroll("test dateConverter method")
	def "test dateConverter method"() {
		when:
		def res = instance.dateConverter("2022-03-31")
		then:
		res != null
	}
	@Unroll("test dateConverter null date")
	def "test dateConverter null date"() {
		when:
		def res = instance.dateConverter(null)
		then:
		res == null
	}

	@Unroll("test saveOBChargesData method")
	def "test saveOBChargesData method"() {
		given:

		List<ObChargesTxnTw> onChargesTxnTwList  = new ArrayList<>();
		ObChargeTxnTwRepository obChargeTxnTwRepository = Mock();
		obChargeTxnTwRepository.executeNamedQueryByCondition(_, _, _) >> onChargesTxnTwList
		instance.obChargeTxnTwRepository = obChargeTxnTwRepository
		when:
		def response = instance.saveOBChargesData("txnref","INT","INT",new ObChargesTxnDTO (),new ObChargesTxnDTO(),"user","004")
		then:
		response == true
	}
	
	@Unroll("test saveOBChargesData method")
	def "test saveOBChargesData method1"() {
		given:

		List<ObChargesTxnTw> onChargesTxnTwList  = new ArrayList<>();
		ObChargesTxnTw ObChargesTxnTw = new ObChargesTxnTw()
		ObChargesTxnTw.setInstrumentType("FINANCE")
		onChargesTxnTwList.add(ObChargesTxnTw)
		ObChargeTxnTwRepository obChargeTxnTwRepository = Mock();
		ObChargeTxnRepository obChargeTxnRepository = Mock()
		obChargeTxnTwRepository.executeNamedQueryByCondition(_, _, _) >> onChargesTxnTwList
		
		List<ObChargesTxn> onChargesTxnTmList  = new ArrayList<>();
		ObChargesTxn ObChargesTxn = new ObChargesTxn()
		ObChargesTxn.setChargeAmount(new BigDecimal(12))
		onChargesTxnTmList.add(ObChargesTxn)
		obChargeTxnRepository.executeNamedQueryByCondition(_, _, _) >> onChargesTxnTmList
		obChargeTxnTwRepository.delete(_) >> null
		obChargeTxnRepository.save(_) >> null
		instance.obChargeTxnTwRepository = obChargeTxnTwRepository
		instance.obChargeTxnRepository = obChargeTxnRepository
		
		def obChargesTxnDTO = new ObChargesTxnDTO ()
		obChargesTxnDTO.setInstrumentType("FINANCE1")
		                                   
		
		when:
		def response = instance.saveOBChargesData("txnref","INT","INT",obChargesTxnDTO,new ObChargesTxnDTO(),"user","004")
		then:
		response == true
	}

	
	@Unroll("test saveOBChargesData method")
	def "test saveOBChargesData method2"() {
		given:

		List<ObChargesTxnTw> onChargesTxnTwList  = new ArrayList<>();
		ObChargesTxnTw ObChargesTxnTw = new ObChargesTxnTw()
		ObChargesTxnTw.setInstrumentType("FINANCE")
		onChargesTxnTwList.add(ObChargesTxnTw)
		ObChargeTxnTwRepository obChargeTxnTwRepository = Mock();
		ObChargeTxnRepository obChargeTxnRepository = Mock()
		obChargeTxnTwRepository.executeNamedQueryByCondition(_, _, _) >> onChargesTxnTwList
		
		List<ObChargesTxn> onChargesTxnTmList  = new ArrayList<>();
		ObChargesTxn ObChargesTxn = new ObChargesTxn()
		onChargesTxnTmList.add(ObChargesTxn)
		obChargeTxnRepository.executeNamedQueryByCondition(_, _, _) >> onChargesTxnTmList
		obChargeTxnTwRepository.delete(_) >> null
		obChargeTxnRepository.save(_) >> null
		instance.obChargeTxnTwRepository = obChargeTxnTwRepository
		instance.obChargeTxnRepository = obChargeTxnRepository
		
		def obChargesTxnDTO = new ObChargesTxnDTO ()
		obChargesTxnDTO.setInstrumentType("FINANCE1")
										   
		
		when:
		def response = instance.saveOBChargesData("txnref","INT","INT",obChargesTxnDTO,new ObChargesTxnDTO(),"user","004")
		then:
		response == true
	}

	
	@Unroll("test saveOBChargesData method")
	def "test saveOBChargesData method3"() {
		given:

		List<ObChargesTxnTw> onChargesTxnTwList  = new ArrayList<>();
		ObChargesTxnTw ObChargesTxnTw = new ObChargesTxnTw()
		ObChargesTxnTw.setInstrumentType("FINANCE")
		onChargesTxnTwList.add(ObChargesTxnTw)
		ObChargeTxnTwRepository obChargeTxnTwRepository = Mock();
		ObChargeTxnRepository obChargeTxnRepository = Mock()
		obChargeTxnTwRepository.executeNamedQueryByCondition(_, _, _) >> onChargesTxnTwList
		
		List<ObChargesTxn> onChargesTxnTmList  = new ArrayList<>();
		obChargeTxnRepository.executeNamedQueryByCondition(_, _, _) >> onChargesTxnTmList
		obChargeTxnTwRepository.delete(_) >> null
		obChargeTxnRepository.save(_) >> null
		instance.obChargeTxnTwRepository = obChargeTxnTwRepository
		instance.obChargeTxnRepository = obChargeTxnRepository
		
		def obChargesTxnDTO = new ObChargesTxnDTO ()
		obChargesTxnDTO.setInstrumentType("FINANCE1")
										   
		
		when:
		def response = instance.saveOBChargesData("txnref","INT","INT",obChargesTxnDTO,new ObChargesTxnDTO(),"user","004")
		then:
		response == true
	}

	
	@Unroll("test saveOBChargesData method")
	def "test saveOBChargesData method4"() {
		given:										   
		
		when:
		def response = instance.saveOBChargesData("txnref","INT","INT",null,null,"user","004")
		then:
		response == false
	}


	@Unroll("test saveOBFinanceDetailsData method")
	def "test saveOBFinanceDetailsData method"() {
		given:

		List<ObFinanceTxnTwDetails> obFinTxnTwList   = new ArrayList<>();
		ObFinanceTwDetailsRepository obFinanceTwDetailsRepository = Mock();
		obFinanceTwDetailsRepository.executeNamedQueryByCondition(_, _, _) >> obFinTxnTwList
		instance.obFinanceTwDetailsRepository = obFinanceTwDetailsRepository
		when:
		def response = instance.saveOBFinanceDetailsData("txnref","INT",new FinanceTxnDTO(),"user","004")
		then:
		response == true
	}
	
	
	@Unroll("test saveOBFinanceDetailsData method")
	def "test saveOBFinanceDetailsData method1"() {
		given:

		List<ObFinanceTxnTwDetails> obFinTxnTwList   = new ArrayList<>();
		ObFinanceTxnTwDetails ObFinanceTxnTwDetails = new ObFinanceTxnTwDetails()
		obFinTxnTwList.add(ObFinanceTxnTwDetails)
		ObFinanceTwDetailsRepository obFinanceTwDetailsRepository = Mock();
		obFinanceTwDetailsRepository.executeNamedQueryByCondition(_, _, _) >> obFinTxnTwList
		obFinanceTwDetailsRepository.deleteByKey(_) >> null
		instance.obFinanceTwDetailsRepository = obFinanceTwDetailsRepository
		when:
		def response = instance.saveOBFinanceDetailsData("txnref","INT",new FinanceTxnDTO(),"user","004")
		then:
		response == true
	}
	
	@Unroll("test saveOBFinanceDetailsData method")
	def "test saveOBFinanceDetailsData method2"() {
		given:

		when:
		def response = instance.saveOBFinanceDetailsData("txnref","INT",new FinanceTxnDTO(),"user","004")
		then:
		response == false
	}
	
	@Unroll("test saveOBInvoiceDetailsData method")
	def "test saveOBInvoiceDetailsData method"() {
		given:

		List<ObInvoiceTxnDetails> invTxnMainCollection    = new ArrayList<>();
		ObInvoiceTxnRepository obInvoiceTxnRepository = Mock();
		obInvoiceTxnRepository.executeNamedQueryByCondition(_, _, _) >> invTxnMainCollection
		instance.obInvoiceTxnRepository = obInvoiceTxnRepository
		when:
		def response = instance.saveOBInvoiceDetailsData("txnref","invref","paid","USD",new InstrumentTxnDTO (),"user","004")
		then:
		response == false
	}
	
	
	@Unroll("test saveOBInvoiceDetailsData method2")
	def "test saveOBInvoiceDetailsData method2"() {
		given:

		List<ObInvoiceTxnDetails> invTxnMainCollection    = new ArrayList<>();
		ObInvoiceTxnDetails ObInvoiceTxnDetails = new ObInvoiceTxnDetails()
		invTxnMainCollection.add(ObInvoiceTxnDetails)
		ObInvoiceTxnRepository obInvoiceTxnRepository = Mock();
		ObInvoiceTxnTwRepository obInvoiceTxnTwRepository = Mock()
		obInvoiceTxnRepository.executeNamedQueryByCondition(_, _, _) >> invTxnMainCollection
		obInvoiceTxnTwRepository.save(_) >> null
		instance.obInvoiceTxnRepository = obInvoiceTxnRepository
		instance.obInvoiceTxnTwRepository = obInvoiceTxnTwRepository
		
		when:
		def response = instance.saveOBInvoiceDetailsData("txnref","invref","paid","USD",new InstrumentTxnDTO (),"user","004")
		then:
		response == true
	}
	
	@Unroll("test saveOBInvoiceDetailsData method3")
	def "test saveOBInvoiceDetailsData method3"() {
		given:

		List<ObInvoiceTxnDetails> invTxnMainCollection    = new ArrayList<>();
		ObInvoiceTxnRepository obInvoiceTxnRepository = Mock();
		ObInvoiceTxnTwRepository obInvoiceTxnTwRepository = Mock()
		obInvoiceTxnRepository.executeNamedQueryByCondition(_, _, _) >> invTxnMainCollection
		obInvoiceTxnTwRepository.save(_) >> null
		instance.obInvoiceTxnRepository = obInvoiceTxnRepository
		instance.obInvoiceTxnTwRepository = obInvoiceTxnTwRepository
		
		when:
		def response = instance.saveOBInvoiceDetailsData("txnref","invref","paid","USD",new InstrumentTxnDTO (),"user","004")
		then:
		response == true
	}
	
}
