package oracle.fsgbu.customer.test.service


import javax.persistence.EntityManager

import oracle.fsgbu.obscfcm.services.report.domain.entity.ScftmCustomerDelinqStatus
import oracle.fsgbu.obscfcm.services.report.domain.entity.ScftmExtCustomerDelinqStatus
import oracle.fsgbu.obscfcm.services.report.persistence.ScftmCustomerDelinqStatusHisRepository
import oracle.fsgbu.obscfcm.services.report.persistence.ScftmCustomerDelinqStatusRepository
import oracle.fsgbu.obscfcm.services.report.persistence.ScftmExtCustomerDelinqStatusHisRepository
import oracle.fsgbu.obscfcm.services.report.persistence.ScftmExtCustomerDelinqStatusRepository
import oracle.fsgbu.obscfcm.services.report.service.CustomerListenerServiceImpl
import oracle.fsgbu.obscfcm.services.scfcm.dto.ScftmCustomerDelinqStatusDTO
import oracle.fsgbu.obscfcm.services.scfcm.dto.ScftmExtCustomerDelinqStatusHisDTO
import spock.lang.Specification
import spock.lang.Unroll

class CustomerListenerServiceImplSpec extends Specification {
	CustomerListenerServiceImpl instance = new CustomerListenerServiceImpl();
	@Unroll("test dateConverter method")
	def "test dateConverter method"() {
		when:
		def res = instance.dateConverter("2022-03-31")
		then:
		res != null
	}
	@Unroll("test dateConverter null date")
	def "test dateConverter null date"() {
		when:
		def res = instance.dateConverter(null)
		then:
		res == null
	}
	
	@Unroll("test saveExtCustomerDelinqStatusData method")
	def "test saveExtCustomerDelinqStatusData method"() {
		given:

		List<ScftmExtCustomerDelinqStatus> scftmExtCustomerDelinqStatusToHist = new ArrayList<>();
		ScftmExtCustomerDelinqStatusRepository scftmExtCustomerDelinqStatusRepository = Mock();
		scftmExtCustomerDelinqStatusRepository.executeNamedQueryByCondition(_, _, _) >> scftmExtCustomerDelinqStatusToHist
		instance.scftmExtCustomerDelinqStatusRepository = scftmExtCustomerDelinqStatusRepository
		when:
		def response = instance.saveExtCustomerDelinqStatusData("extCustomerDelinqStatusId", new ScftmExtCustomerDelinqStatusHisDTO(), "userId", "branchCode")
		then:
		response == true

	}
	
	@Unroll("test saveCustomerDelinqStatusData method")
	def "test saveCustomerDelinqStatusData method"() {
		given:

		ScftmExtCustomerDelinqStatusRepository scftmExtCustomerDelinqStatusRepository = Mock();
		scftmExtCustomerDelinqStatusRepository.find(_) >> new ScftmCustomerDelinqStatus()
		instance.scftmExtCustomerDelinqStatusRepository = scftmExtCustomerDelinqStatusRepository
		when:
		def response = instance.saveCustomerDelinqStatusData(new ScftmCustomerDelinqStatusDTO(), "userId", "branchCode")
		then:
		response == false

	}

	
	@Unroll("test saveExtCustomerDelinqStatusData method")
	def "test saveExtCustomerDelinqStatusData method1"() {
		given:

		def entityManager = Mock(EntityManager)
		entityManager.flush()
		ScftmExtCustomerDelinqStatus ScftmExtCustomerDelinqStatus = new ScftmExtCustomerDelinqStatus()
		ScftmExtCustomerDelinqStatus.setId("1")
		List<ScftmExtCustomerDelinqStatus> scftmExtCustomerDelinqStatusToHist = new ArrayList<>();
		scftmExtCustomerDelinqStatusToHist.add(ScftmExtCustomerDelinqStatus)
		ScftmExtCustomerDelinqStatusRepository scftmExtCustomerDelinqStatusRepository = Mock();
		ScftmExtCustomerDelinqStatusHisRepository scftmExtCustomerDelinqStatusHisRepository = Mock();
		scftmExtCustomerDelinqStatusRepository.executeNamedQueryByCondition(_, _, _) >> scftmExtCustomerDelinqStatusToHist
		scftmExtCustomerDelinqStatusRepository.deleteByKey(_) >> null
		scftmExtCustomerDelinqStatusHisRepository.save(_) >> null
		instance.scftmExtCustomerDelinqStatusRepository = scftmExtCustomerDelinqStatusRepository
		instance.scftmExtCustomerDelinqStatusHisRepository = scftmExtCustomerDelinqStatusHisRepository
		instance.entityManager = entityManager
		
		when:
		def response = instance.saveExtCustomerDelinqStatusData("extCustomerDelinqStatusId", new ScftmExtCustomerDelinqStatusHisDTO(), "userId", "branchCode")
		then:
		response == true

	}
	
	
	@Unroll("test saveCustomerDelinqStatusData method1")
	def "test saveCustomerDelinqStatusData method1"() {
		given:

		ScftmCustomerDelinqStatusHisRepository scftmCustomerDelinqStatusHisRepository = Mock();
		ScftmCustomerDelinqStatusRepository scftmCustomerDelinqStatusRepository = Mock();
		def entityManager = Mock(EntityManager)
		
	    ScftmCustomerDelinqStatus ScftmCustomerDelinqStatus = new ScftmCustomerDelinqStatus()
		
		scftmCustomerDelinqStatusRepository.find(_) >> ScftmCustomerDelinqStatus
		scftmCustomerDelinqStatusRepository.deleteByKey(_) >> null
		scftmCustomerDelinqStatusHisRepository.save(_) >> null
		entityManager.flush() 

				instance.scftmCustomerDelinqStatusRepository = scftmCustomerDelinqStatusRepository
		instance.scftmCustomerDelinqStatusHisRepository = scftmCustomerDelinqStatusHisRepository
		instance.entityManager = entityManager
		
		ScftmCustomerDelinqStatusDTO ScftmCustomerDelinqStatusDTO = new ScftmCustomerDelinqStatusDTO()
		ScftmCustomerDelinqStatusDTO.setCustomerId("1")
		when:
		def response = instance.saveCustomerDelinqStatusData(new ScftmCustomerDelinqStatusDTO(), "userId", "branchCode")
		then:
		response == true

	}

}
