package oracle.fsgbu.customer.test.service

import oracle.fsgbu.ob.adapter.dto.OBIntegrationServiceResponse
import oracle.fsgbu.ob.adapter.provider.OBIntegrationAdapter
import org.springframework.messaging.Message
import org.springframework.messaging.support.MessageBuilder

import avro.oracle.fsgbu.obscf.invoicing.dto.*
import avro.oracle.fsgbu.obscf.manualrecon.dto.*
import oracle.fsgbu.obscfcm.services.report.client.*
import oracle.fsgbu.obscfcm.services.report.service.*
import oracle.fsgbu.reconService.api.model.*
import spock.lang.Shared
import spock.lang.Specification
import spock.lang.Unroll
import oracle.fsgbu.obscfcm.services.report.service.*
import oracle.fsgbu.eventService.api.model.*
import oracle.fsgbu.gus.persistence.provider.GlobalHolder
import oracle.fsgbu.accountMaintenance.api.model.*
import avro.oracle.fsgbu.obscfcm.accounting.dto.*
import avro.oracle.fsgbu.obscfcm.services.dto.*;
import avro.oracle.fsgbu.obscfcm.charges.dto.*;
import oracle.cashflow.scfcm.adapter.dto.CashflowResponse;
import oracle.fsgbu.reconService.api.model.ReconTxnDto;
import oracle.fsgbu.reconService.api.model.ReconInvCnDto;
import oracle.fsgbu.reconService.api.model.ReconInvPmtDto;



class PlatoCloudStreamListenerServiceSpec extends Specification{
	
	def eventServiceClient = Mock(EventServiceClient)
	def reconEventServiceClient = Mock(ReconEventServiceClient)
	def eventListenerService = Mock(EventListenerService)


	@Shared updateFinPmtReconDTOCollection = new UpdateFinPmtReconDTOCollection()
	
	@Shared updatePmtAllocDTOCollection = new UpdatePmtAllocDTOCollection()
	
	@Shared updatePmtAllocDTO = new UpdatePmtAllocDTO(reconId:"null", 
   reconTxnRefNo:"null", 
   reconCategory:"null", 
   reconDate:"null", 
   branchCode:"null", 
   reconType:"null", 
   reconRuleType:"null", 
   reconRule:"null", 
   lhsEntity:"null", 
   rhsEntity:"null", 
   makerId:"null", 
   makerDtStamp:"null", 
   authId:"null", 
   authDtStamp:"null", 
   transactionStatus:"null", 
   stage:"null", 
   reconcileBy:"null", 
   matchSeqNo:"null", 
   allocVirtualAccNo:"null", 
   allocEntity:"null", 
   allocAttributes:"null", 
   allocStatus:"null", 
   allocatedAmt:"null", 
   allocationPct:"null", 
   pmtAllocatedAmt:"null", 
   obvamRefNo:"null", 
   corporateId:"null", 
   corporateName:"null", 
   counterpartyId:"null", 
   counterpartyName:"null", 
   obdxRefNo:"null", 
   beneficiaryId:"null", 
   beneficiaryName:"null", 
   paymentPartyId:"null", 
   paymentDate:"null", 
   paymentMode:"null", 
   beneCode:"null", 
   paymentAmount:"null", 
   paymentCcy:"null", 
   reconciledPmtAmt:"null", 
   beneVirtualAccNo:"null", 
   pmtReconStatus:"null", 
   pmtAllocationStatus:"null", 
   reconAction:"null", 
   extPmtRefNo:"null", 
   paymentRefNo:"null", 
   remitterAccNo:"null", 
   creditAccNo:"null", 
   dcIndicator:"null", 
   isPmtAccVA:"null", 
   counterpartyCode:"null", 
   partyPaymentCode:"null", 
   beneficiaryCode:"null", 
   accOwner:"null", 
   allocBasis:"null", 
   paymentPartyName:"null", 
   reconAllocPmtId:"null")
	
	@Shared updateInvCnReconDTO = new UpdateInvCnReconDTO(reconId:"null", 
   reconTxnRefNo:"null", 
   reconCategory:"null", 
   reconDate:"null", 
   branchCode:"null", 
   reconType:"null", 
   reconRuleType:"null", 
   reconRule:"null", 
   lhsEntity:"null", 
   rhsEntity:"null", 
   makerId:"null", 
   makerDtStamp:"null", 
   authId:"null", 
   authDtStamp:"null", 
   transactionStatus:"null", 
   reconAction:"null", 
   stage:"null", 
   reconcileBy:"null", 
   corporateId:"null", 
   invCnReconId:"null", 
   matchSeqNo:"null", 
   cnNumber:"null", 
   cnDate:"null", 
   cnExpiryDate:"null", 
   cnBuyerCode:"null", 
   cnBuyerId:"null", 
   cnSupplierCode:"null", 
   cnSupplierId:"null", 
   cnBuyerDivCode:"null", 
   cnSupplierDivCode:"null", 
   cnSupplierName:"null", 
   cnBuyerName:"null", 
   cnCurrecny:"null", 
   cnBaseAmount:"null", 
   netCnAmount:"null", 
   cnProgramCode:"null", 
   cnReconStatus:"null", 
   procBranchCode:"null", 
   procBranchDate:"null", 
   cnInternalId:"null", 
   remarks:"null", 
   filler1:"null", 
   filler2:"null", 
   filler3:"null", 
   filler4:"null", 
   filler5:"null", 
   filler6:"null", 
   filler7:"null", 
   filler8:"null", 
   filler9:"null", 
   filler10:"null", 
   intInvRefNo:"null", 
   invBuyerId:"null", 
   invBuyerName:"null", 
   invCcy:"null", 
   invDate:"null", 
   invDueDate:"null", 
   invFinanced:"null", 
   invOsAmt:"null", 
   invProgramCode:"null", 
   invRelationCode:"null", 
   invSupplierId:"null", 
   extInvRefNo:"null", 
   invSupplierName:"null", 
   invVirtualAccNo:"null", 
   netInvAmt:"null", 
   varianceAmount:"null", 
   accountNumber:"null", 
   accOwner:"null", 
   amtMatched:"null", 
   deReconFlag:"null", 
   exchRate:"null", 
   importFactorId:"null", 
   importFactorName:"null", 
   insuranceCoId:"null", 
   insuranceCoName:"null", 
   extSysRefNo:"null", 
   isInvAccVa:"null", 
   isCnAccVa:"null", 
   linkedDeReconTxnRef:"null", 
   reconciledCnAmt:"null", 
   reconStatus:"null", 
   remitterAccNo:"null")
	
	@Shared updatedFileUpload = new UpdateFileUploadDto(fileName:"null", 
   count:"null", 
   totalFileUploadValue:"null", 
   uploadDateAndTime:"null" )
	
	@Shared updateInvoiceTmDto = new UpdateInvoiceTmDto(transactionReferenceNo:"004080822INV33777",
		userId:"SUNIL",
		branchCode:"004")
	
	@Shared updateReconTwDto = new UpdateReconTwDto(reconTxnRefNo:"null",
		userId:"null",
		branchCode:"null")
	
	@Shared updateExpDrCrReconDTO = new UpdateExpDrCrReconDTO(reconId: "null", reconTxnRefNo: "null", reconCategory: "null", reconDate: "null", branchCode: "null", reconType: "null", reconRuleType: "null", reconRule: "null", lhsEntity: "null", rhsEntity: "null", makerId: "null", makerDtStamp: "null", authId: "null", authDtStamp: "null", transactionStatus: "null", reconAction: "null", stage: "null", reconcileBy: "null", matchSeqNo: "null", expDrcrCcy: "null", expDrcrVirtualAccNo: "null", amtMatched: "null", paymentPartyId: "null", paymentPartyName: "null", paymentDate: "null", paymentMode: "null", beneCode: "null", beneName: "null", paymentAmount: "null", paymentCcy: "null", exchRate: "null", reconciledPmtAmt: "null", beneVirtualAccNo: "null", pmtStatus: "null", reconStatus: "null", expDrcrCode: "null", expDrcrCodeDesc: "null", expDrcrIndicator: "null", expDrcrBankAccNumber: "null", expDrcrNarration: "null", expDrcrAmt: "null", externalAccNo: "null", expDrcrDate: "null", revisedDrcrDate: "null", expDrcrRefNo: "null", paymentRefNo: "null", externalPmtRefNo: "null", externalDrcrRefNo: "null", corporateId: "null", counterpartyId: "null", expDrCrReconId: "null")
	@Shared updateInvPmtReconDTO = new UpdateInvPmtReconDTO(reconId: "null", reconTxnRefNo: "null", reconCategory: "null", reconDate: "null", branchCode: "null", reconType: "null", reconRuleType: "null", reconRule: "null", lhsEntity: "null", rhsEntity: "null", makerId: "null", makerDtStamp: "null", authId: "null", authDtStamp: "null", transactionStatus: "null", reconAction: "null", stage: "null", reconcileBy: "null", matchSeqNo: "null", invBuyerId: "null", invSupplierId: "null", invBuyerName: "null", invSupplierName: "null", invRelationCode: "null", extInvRefNo: "null", intInvRefNo: "null", invDate: "null", invDueDate: "null", netInvAmt: "null", invCcy: "null", invVirtualAccNo: "null", invOsAmt: "null", invFinanced: "null", amtMatched: "null", paymentRefNo: "null", paymentPartyId: "null", paymentPartyName: "null", paymentDate: "null", paymentMode: "null", beneCode: "null", beneName: "null", paymentAmount: "null", paymentCcy: "null", exchRate: "null", reconciledPmtAmt: "null", beneVirtualAccNo: "null", pmtStatus: "null", reconStatus: "null", invPmtReconId: "null")
	@Shared updateFinPmtReconDTO = new UpdateFinPmtReconDTO(reconId: "123", reconTxnRefNo: "null", reconCategory: "FPR", reconDate: "null", branchCode: "null", reconType: "null", reconRuleType: "null", reconRule: "null", lhsEntity: "null", rhsEntity: "null", makerId: "null", makerDtStamp: "null", authId: "null", authDtStamp: "null", transactionStatus: "null", reconAction: "null", stage: "null", matchSeqNo: "null", finBuyerId: "null", finSupplierId: "null", finBuyerName: "null", finSupplierName: "null", finProgramCode: "null", finRefNo: "null", finSeqNo: "null", finStartDt: "null", finEndDt: "null", finPastDueDt: "null", finCcy: "null", finAmt: "null", finOsAmt: "null", intOsAmt: "null", penIntOsAmt: "null", overdueIntOsAmt: "null", totIntOsAmt: "null", amtMatched: "null", paymentRefNo: "null", paymentPartyId: "null", paymentPartyName: "null", paymentDate: "null", paymentMode: "null", beneCode: "null", beneName: "null", paymentAmount: "null", paymentCcy: "null", exchRate: "null", reconciledPmtAmt: "null", beneVirtualAccNo: "null", pmtProgramCode: "null", pmtStatus: "null", reconStatus: "null", finPmtReconId: "null")
	@Shared updateInvoiceTwDto = new UpdateInvoiceTwDto(transactionReferenceNo:"123",userId:"user","branchCode":"004")
	@Shared invoiceTmCashflowDto = new InvoiceTmCashflowDto(transactionReferenceNo:"123",userId:"user","branchCode":"004")
	
	@Shared updatedPayment = new UpdatePaymentDto(serviceBranchCode:"004",PaymentRefNo:"123",userId:"user")
	@Unroll("test getExpDrCrReconData method")
	def"test getExpDrCrReconData method"(){
	 given:
	 def reconEventServiceClient = Mock(ReconEventServiceClient)
	 List<UpdateExpDrCrReconDTO> list = new ArrayList<>()
	 list.add(updateExpDrCrReconDTO) 
	 def updateExpDrCrReconDTOCollection = new UpdateExpDrCrReconDTOCollection(list,"DEV","004")
	 Message<UpdateExpDrCrReconDTOCollection> message = MessageBuilder.withPayload(updateExpDrCrReconDTOCollection).build();
	  PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
	 
	 when:
	 def responce = service.getExpDrCrReconData(message)
	 then:
		 responce == null;
	
	}
	def"test getExpDrCrReconData NULL method"(){
		given:
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		List<UpdateExpDrCrReconDTO> list = new ArrayList<>()
		def updateExpDrCrReconDTO = null
		list.add(updateExpDrCrReconDTO)
		def updateExpDrCrReconDTOCollection = new UpdateExpDrCrReconDTOCollection(list,"DEV","004")
		Message<UpdateExpDrCrReconDTOCollection> message = MessageBuilder.withPayload(updateExpDrCrReconDTOCollection).build();
		 PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		
		when:
		def responce = service.getExpDrCrReconData(message)
		then:
			responce == null;
	   
	   }
	
	@Unroll("test getInvPmtReconData method")
	def"test getInvPmtReconData method"(){
	 given:

	 def eventServiceClient = Mock(EventServiceClient)
	 def reconEventServiceClient = Mock(ReconEventServiceClient)
	 List<UpdateInvPmtReconDTO> list = new ArrayList<>()
	 list.add(updateInvPmtReconDTO)
	 def updateInvPmtReconDTOCollection = new UpdateInvPmtReconDTOCollection(list,"DEV","004")
	 Message<UpdateInvPmtReconDTOCollection> message = MessageBuilder.withPayload(updateInvPmtReconDTOCollection).build();
	 PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
	 
	 when:
	 def responce = service.getInvPmtReconData(message)
	 then:
		 responce == null;
	
	}
	def"test getInvPmtReconData null method"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		List<UpdateInvPmtReconDTO> list = new ArrayList<>()
		def updateInvPmtReconDTO =null
		list.add(updateInvPmtReconDTO)
		def updateInvPmtReconDTOCollection = new UpdateInvPmtReconDTOCollection(list,"DEV","004")
		Message<UpdateInvPmtReconDTOCollection> message = MessageBuilder.withPayload(updateInvPmtReconDTOCollection).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		
		when:
		def responce = service.getInvPmtReconData(message)
		then:
			responce == null;
	   
	   }
	
	@Unroll("test getFinPmtReconData method")
	def"test getFinPmtReconData method"(){
	 given:

	 def eventServiceClient = Mock(EventServiceClient)
	 def reconEventServiceClient = Mock(ReconEventServiceClient)
	 List<UpdateFinPmtReconDTO> list = new ArrayList<>()
	 list.add(updateFinPmtReconDTO)
	 
	 def updateFinPmtReconDTOCollection = new UpdateFinPmtReconDTOCollection(list,"DEV", "004")
	 Message<UpdateFinPmtReconDTOCollection> message = MessageBuilder.withPayload(updateFinPmtReconDTOCollection).build();

	 PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
	 when:
	 def responce = service.getFinPmtReconData(message)
	 then:
		 responce == null;
	 
	}
	def"test getFinPmtReconData null method"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		List<UpdateFinPmtReconDTO> list = new ArrayList<>()
		def updateFinPmtReconDTO = null
		list.add(updateFinPmtReconDTO)

		def updateFinPmtReconDTOCollection = new UpdateFinPmtReconDTOCollection(list,"DEV", "004")
		Message<UpdateFinPmtReconDTOCollection> message = MessageBuilder.withPayload(updateFinPmtReconDTOCollection).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		
		when:
		def responce = service.getFinPmtReconData(message)
		then:
			responce == null;
		
	   }
	   
	   @Unroll("test getPaymentData method")
	   def"test getPaymentData method"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		Message<UpdatePaymentDto> message = MessageBuilder.withPayload(updatedPayment).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.eventListenerService = eventListenerService
		when:
		def responce = service.getPaymentData(message)
		then:
		responce == null;
	   }

	@Unroll("test getPaymentTwData method")
	def"test getPaymentTwData method"(){
		given:


		def eventListenerService = Mock(EventListenerService)
		def instrumentReceivablesServiceClient = Mock(InstrumentReceivablesServiceClient)

		def  dto = new PaymentCollectionDto()
		def payTwList = new  ArrayList<PaymentDto> ()
		dto.setData(payTwList)
		instrumentReceivablesServiceClient.getPaymentTwByPayRefNo(_,_,_) >> dto
		eventListenerService.savePaymentTWData(_,_,_) >> true
		Message<UpdatePaymentDto> message = MessageBuilder.withPayload(updatedPayment).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.eventListenerService = eventListenerService
		service.instrumentReceivablesServiceClient = instrumentReceivablesServiceClient


		when:
		def response = service.getPaymentTwData(message)
		then:
		response == null;
	   }
	   
	   @Unroll("test getPaymentAllocationData method")
	   def"test getPaymentAllocationData method"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		List<UpdatePmtAllocDTO> list = new ArrayList<>()
		list.add(updatePmtAllocDTO)
		def updatePmtAllocDTOCollection = new UpdatePmtAllocDTOCollection(list,"DEV", "004")
		Message<UpdatePmtAllocDTOCollection> message = MessageBuilder.withPayload(updatePmtAllocDTOCollection).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		when:
		def responce = service.getPaymentAllocationData(message)
		then:
			responce == null;
		
	   }
	   
	   @Unroll("test getInvCnData method")
	   def"test getInvCnData method"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		List<UpdateInvCnReconDTO> list = new ArrayList<>()
		list.add(updateInvCnReconDTO)
		def updateInvCnReconDTOCollection = new UpdateInvCnReconDTOCollection(list,"DEV", "004")
		Message<UpdateInvCnReconDTOCollection> message = MessageBuilder.withPayload(updateInvCnReconDTOCollection).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		when:
		def responce = service.getInvCnData(message)
		then:
			responce == null;
		
	   }
	   
	   @Unroll("test getFileData method")
	   def"test getFileData method"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		Message<UpdateFileUploadDto> message = MessageBuilder.withPayload(updatedFileUpload).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		
		when:
		def responce = service.getFileData(message)
		then:
		responce == null;
		
		
	   }
	   
	   @Unroll("test 1 getReconTwData method")
	   def"test 1 getReconTwData method"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		def reconEventListenerService = Mock(ReconEventListenerService)
		ReconDataCollection reconDataCollection = new ReconDataCollection()
		List<ReconTxnDto> reconTxnList = new ArrayList<ReconTxnDto>()
		reconTxnList.add(new ReconTxnDto())
		reconDataCollection.setData(reconTxnList)
		reconEventServiceClient.getReconTwData(_,_,_) >> reconDataCollection
		Message<UpdateFileUploadDto> message = MessageBuilder.withPayload(updateReconTwDto).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.reconEventListenerService = reconEventListenerService
		
		when:
		def response = service.getReconTwData(message)
		then:
		response == null;
		
	   }
	   
	   @Unroll("test 2 getReconTwData method")
	   def"test 2 getReconTwData method"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		def reconEventListenerService = Mock(ReconEventListenerService)
		ReconDataCollection reconDataCollection = new ReconDataCollection()
		List<ReconTxnDto> reconTxnList = new ArrayList<ReconTxnDto>()
		reconDataCollection.setData(reconTxnList)
		reconEventServiceClient.getReconTwData(_,_,_) >> reconDataCollection
		Message<UpdateFileUploadDto> message = MessageBuilder.withPayload(updateReconTwDto).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.reconEventListenerService = reconEventListenerService
		
		when:
		def response = service.getReconTwData(message)
		then:
		response == null;
		
	   }
	   
	   @Unroll("test 3 getReconTwData method exception")
	   def"test 3 getReconTwData method exception"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		def reconEventServiceClient = Mock(ReconEventServiceClient)
		def reconEventListenerService = Mock(ReconEventListenerService)
		reconEventServiceClient.getReconTwData(_,_,_) >> new Exception()
		Message<UpdateFileUploadDto> message = MessageBuilder.withPayload(updateReconTwDto).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.reconEventListenerService = reconEventListenerService
		
		when:
		def response = service.getReconTwData(message)
		then:
		response == null;
		
	   }
	   
	   @Unroll("test getInvoiceTmData method")
	   def "test getInvoiceTmData method"(){
		   
		   given:
		   
		   def eventListenerService = Mock(EventListenerService)
		   Message<UpdateInvoiceTmDto> message = MessageBuilder.withPayload(updateInvoiceTmDto).build();
		   
		   PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		   service.eventListenerService = eventListenerService
		   when:
		   def responce = service.getInvoiceTmData(message)
		   then:
		   responce == null;
		   
	   }
	   
	   @Unroll("test 1 getInvoiceTwData method")
	   def"test 1 getInvoiceTwData method"(){
		given:
   
		def eventListenerService = Mock(EventListenerService)
		def instrumentReceivablesServiceClient = Mock(InstrumentReceivablesServiceClient)
		
		def  dto = new InvoiceCollectionDto()
		def invoiceModelList = new ArrayList<InvoiceModel> ()
		def invoiceModel = new InvoiceModel()
		invoiceModel.setId("1")
		invoiceModelList.add(invoiceModel)
		dto.setData(invoiceModelList)

		instrumentReceivablesServiceClient.getInvoiceByTxnRefNo(_,_,_) >> dto
		eventListenerService.saveInvoiceTwData(_,_,_) >> true
		Message<UpdateInvoiceTwDto> message = MessageBuilder.withPayload(updateInvoiceTwDto).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.eventListenerService = eventListenerService
		service.instrumentReceivablesServiceClient = instrumentReceivablesServiceClient
		
		
		when:
		def response = service.getInvoiceTwData(message)
		then:
		response == null;
		
	   }
	   
	   @Unroll("test 1 getCreditNoteData method")
	   def"test 1 getCreditNoteData method"(){
		given:
   
		def eventServiceClient = Mock(EventServiceClient)
		eventServiceClient.saveCreditNote(_,_,_) >> true
		
		def updateCnCommodityGridDto = new UpdateCnCommodityGridDto(seqNo:2,commodityCode:"1",costPerUnit:100,netCost:1050,quantity:10,taxAmount:100,totalCost:1000,discountAmount:100,discountPercentage:1,taxPercentage:1,unitWeight:1,totalWeight:1);
		def updateDrCrNoteLinkInvoiceDto = new UpdateDrCrNoteLinkInvoiceDto(seqNo:2)
		def lista =new ArrayList<UpdateCnCommodityGridDto>(Arrays.asList(updateCnCommodityGridDto))
		def listb = new ArrayList<UpdateDrCrNoteLinkInvoiceDto>(Arrays.asList(updateDrCrNoteLinkInvoiceDto))
		def updateCreditNotesDto = new UpdateCreditNotesDto(seqNo:2,matchedAmount:123,unmatchedAmount:123,totalAmount:123,taxAmount:123,discountPercentage:1,discountAmount:1,taxPercentage:1,miscCharge1Amount:1,miscCharge2Amount:1 ,amount:1 ,netCnAmount:1,UpdateDrCrNoteLinkInvoiceDto : listb,UpdateCnCommodityGridDto: lista)
		
		Message<UpdateCreditNotesDto> message = MessageBuilder.withPayload(updateCreditNotesDto).build();
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.eventServiceClient = eventServiceClient
		
		
		when:
		def response = service.getCreditNoteData(message)
		then:
		response == null;
		
	   }
	   @Unroll("test 1 getAccountRoleTwData method")
	   def"test 1 getAccountRoleTwData method"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountRoleTWData(_,_,_) >> new RoleWebModel()

		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
		accountMaintenanceListenerService.saveAccountRoleTWData(_,_,_)>> true
		
		def updateAccountRoleTWDto = new UpdateAccountRoleTWDto() 
        Message<UpdateAccountRoleTWDto> message = MessageBuilder.withPayload(updateAccountRoleTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountRoleTwData(message)
		
		then:
		response == null;
		
	   }
	   
	   @Unroll("test 1 getAccountRoleTwData method null")
	   def"test 1 getAccountRoleTwData method null"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountRoleTWData(_,_,_) >>null

		
		def updateAccountRoleTWDto = new UpdateAccountRoleTWDto()
		Message<UpdateAccountRoleTWDto> message = MessageBuilder.withPayload(updateAccountRoleTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountRoleTwData(message)
		
		then:
		response == null;
		
	   }
	   
	   @Unroll("test 1 getAccountRoleTwData method exception")
	   def"test 1 getAccountRoleTwData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountRoleTWData(_,_,_) >> new Exception()

		
		def UpdateAccountRoleTWDto = new UpdateAccountRoleTWDto()
		Message<UpdateAccountRoleTWDto> message = MessageBuilder.withPayload(UpdateAccountRoleTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountRoleTwData(message)
		
		then:
		response == null;
		
	   }	   
	

	   @Unroll("test 1 getAccountRoleTmData method")
	   def"test 1 getAccountRoleTmData method"(){
		given:
   	
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountRoleTMData(_,_,_) >> new RoleWebModel()

		
		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
		accountMaintenanceListenerService.saveAccountRoleTMData(_,_,_)>> true
	
			def updateAccountRoleDto = new UpdateAccountRoleDto()
		Message<UpdateAccountRoleDto> message = MessageBuilder.withPayload(updateAccountRoleDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountRoleTmData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountRoleTmData method exception")
	   def"test 1 getAccountRoleTmData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountRoleTMData(_,_,_) >> new Exception()

		
		def updateAccountRoleDto = new UpdateAccountRoleDto()
		Message<UpdateAccountRoleDto> message = MessageBuilder.withPayload(updateAccountRoleDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountRoleTmData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountRoleTmData method null")
	   def"test 1 getAccountRoleTmData method null"(){
		given:
   	
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountRoleTMData(_,_,_) >> null

		
		def updateAccountRoleDto = new UpdateAccountRoleDto()
		Message<UpdateAccountRoleDto> message = MessageBuilder.withPayload(updateAccountRoleDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountRoleTmData(message)
		
		then:
		response == null;
		
	   }

	   
	   @Unroll("test 1 getAccountEntryTwData method")
	   def"test 1 getAccountEntryTwData method"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryTWData(_,_,_) >> new AccentryWebModel()
		
		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
		accountMaintenanceListenerService.saveAccountEntryTWData(_,_,_)>> true
		
		def UpdateAccountEntryTWDto = new UpdateAccountEntryTWDto()
		Message<UpdateAccountEntryTWDto> message = MessageBuilder.withPayload(UpdateAccountEntryTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryTwData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountEntryTwData method exception")
	   def"test 1 getAccountEntryTwData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryTWData(_,_,_) >> new Exception()
		
		
		def UpdateAccountEntryTWDto = new UpdateAccountEntryTWDto()
		Message<UpdateAccountEntryTWDto> message = MessageBuilder.withPayload(UpdateAccountEntryTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryTwData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountEntryTwData method null")
	   def"test 1 getAccountEntryTwData method null"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryTWData(_,_,_) >> null
		
		
		def UpdateAccountEntryTWDto = new UpdateAccountEntryTWDto()
		Message<UpdateAccountEntryTWDto> message = MessageBuilder.withPayload(UpdateAccountEntryTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryTwData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountEntryTmData method")
	   def"test 1 getAccountEntryTmData method"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryTMData(_,_,_) >> new AccentryWebModel()

		
	
		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
     	accountMaintenanceListenerService.saveAccountEntryTMData(_,_,_)>> true
	
		def UpdateAccountEntryDto = new UpdateAccountEntryDto()
		Message<UpdateAccountEntryDto> message = MessageBuilder.withPayload(UpdateAccountEntryDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryTmData(message)
		
		then:
		response == null;
		
	   }
	   
	   
	   @Unroll("test 1 getAccountEntryTmData method exception")
	   def"test 1 getAccountEntryTmData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryTMData(_,_,_) >> new Exception()
		
		def UpdateAccountEntryDto = new UpdateAccountEntryDto()
		Message<UpdateAccountEntryDto> message = MessageBuilder.withPayload(UpdateAccountEntryDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryTmData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountEntryTmData method null")
	   def"test 1 getAccountEntryTmData method null"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryTMData(_,_,_) >> null

	
		def UpdateAccountEntryDto = new UpdateAccountEntryDto()
		Message<UpdateAccountEntryDto> message = MessageBuilder.withPayload(UpdateAccountEntryDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryTmData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountEntryCodeTmData method")
	   def"test 1 getAccountEntryCodeTmData method"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryCodeTMData(_,_,_) >> new AccentrycodeWebModel()

		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
		accountMaintenanceListenerService.saveAccountEntryCodeTMData(_,_,_)>> true
		
		def UpdateAccountEntryCodeDto = new UpdateAccountEntryCodeDto()
		Message<UpdateAccountEntryCodeDto> message = MessageBuilder.withPayload(UpdateAccountEntryCodeDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryCodeTmData(message)
		
		then:
		response == null;
		
	   }
	   @Unroll("test 1 getAccountEntryCodeTmData method exception")
	   def"test 1 getAccountEntryCodeTmData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryCodeTMData(_,_,_) >> new Exception()

		
		def UpdateAccountEntryCodeDto = new UpdateAccountEntryCodeDto()
		Message<UpdateAccountEntryCodeDto> message = MessageBuilder.withPayload(UpdateAccountEntryCodeDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryCodeTmData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountEntryCodeTmData method null")
	   def"test 1 getAccountEntryCodeTmData method null"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryCodeTMData(_,_,_) >> null

		def UpdateAccountEntryCodeDto = new UpdateAccountEntryCodeDto()
		Message<UpdateAccountEntryCodeDto> message = MessageBuilder.withPayload(UpdateAccountEntryCodeDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryCodeTmData(message)
		
		then:
		response == null;
		
	   }
	
	    @Unroll("test 1 getAccountEntryCodeTwData method")
	   def"test 1 getAccountEntryCodeTwData method"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryCodeTWData(_,_,_) >> new AccentrycodeWebModel()

		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
		accountMaintenanceListenerService.saveAccountEntryCodeTWData(_,_,_)>> true
		
		def UpdateAccountEntryTWDto = new UpdateAccountEntryTWDto()
		Message<UpdateAccountEntryTWDto> message = MessageBuilder.withPayload(UpdateAccountEntryTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryCodeTwData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountEntryCodeTwData method")
	   def"test 1 getAccountEntryCodeTwData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryCodeTWData(_,_,_) >>new Exception()

		
		def UpdateAccountEntryTWDto = new UpdateAccountEntryTWDto()
		Message<UpdateAccountEntryTWDto> message = MessageBuilder.withPayload(UpdateAccountEntryTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
				service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryCodeTwData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getAccountEntryCodeTwData method null")
	   def"test 1 getAccountEntryCodeTwData method null"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getAccountEntryCodeTWData(_,_,_) >> null

		
		def UpdateAccountEntryTWDto = new UpdateAccountEntryTWDto()
		Message<UpdateAccountEntryTWDto> message = MessageBuilder.withPayload(UpdateAccountEntryTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getAccountEntryCodeTwData(message)
		
		then:
		response == null;
		
	   }


	   @Unroll("test 1 getInternalAccountMapTwData method")
	   def"test 1 getInternalAccountMapTwData method"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getInternalAccountMapTWData(_,_,_) >> new IntaccmapWebModel()

		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
		accountMaintenanceListenerService.getInternalAccountMapTWData(_,_,_)>> true
		
		def UpdateInternalAccountMapTWDto = new UpdateInternalAccountMapTWDto()
		Message<UpdateInternalAccountMapTWDto> message = MessageBuilder.withPayload(UpdateInternalAccountMapTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getInternalAccountMapTwData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getInternalAccountMapTwData method exception")
	   def"test 1 getInternalAccountMapTwData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getInternalAccountMapTWData(_,_,_) >> new Exception()

		
		def UpdateInternalAccountMapTWDto = new UpdateInternalAccountMapTWDto()
		Message<UpdateInternalAccountMapTWDto> message = MessageBuilder.withPayload(UpdateInternalAccountMapTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getInternalAccountMapTwData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getInternalAccountMapTwData method null")
	   def"test 1 getInternalAccountMapTwData method null"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getInternalAccountMapTWData(_,_,_) >> null

		
		def UpdateInternalAccountMapTWDto = new UpdateInternalAccountMapTWDto()
		Message<UpdateInternalAccountMapTWDto> message = MessageBuilder.withPayload(UpdateInternalAccountMapTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getInternalAccountMapTwData(message)
		
		then:
		response == null;
		
	   }

	   
	   @Unroll("test 1 getInternalAccountMapTmData method")
	   def"test 1 getInternalAccountMapTmData method"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getInternalAccountMapTMData(_,_,_) >> new IntaccmapWebModel()

		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
		accountMaintenanceListenerService.saveInternalAccountMapTMData(_,_,_)>> true
		
		def UpdateInternalAccountMapDto = new UpdateInternalAccountMapDto()
		Message<UpdateInternalAccountMapDto> message = MessageBuilder.withPayload(UpdateInternalAccountMapDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getInternalAccountMapTmData(message)
		
		then:
		response == null;
		
	   }


	   @Unroll("test 1 getInternalAccountMapTmData method")
	   def"test 1 getInternalAccountMapTmData method null"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getInternalAccountMapTMData(_,_,_) >> null

		
		def UpdateInternalAccountMapDto = new UpdateInternalAccountMapDto()
		Message<UpdateInternalAccountMapDto> message = MessageBuilder.withPayload(UpdateInternalAccountMapDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getInternalAccountMapTmData(message)
		
		then:
		response == null;
		
	   }
	   @Unroll("test 1 getInternalAccountMapTmData method")
	   def"test 1 getInternalAccountMapTmData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getInternalAccountMapTMData(_,_,_) >> new Exception()

		
		def UpdateInternalAccountMapDto = new UpdateInternalAccountMapDto()
		Message<UpdateInternalAccountMapDto> message = MessageBuilder.withPayload(UpdateInternalAccountMapDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getInternalAccountMapTmData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getExternalAccountMapTwData method")
	   def"test 1 getExternalAccountMapTwData method"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getExternalAccountMapTWData(_,_,_) >> new ExternalWebModel()

		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
		accountMaintenanceListenerService.saveExternalAccountMapTWData(_,_,_)>> true
		
		def UpdateExternalAccountMapTWDto = new UpdateExternalAccountMapTWDto()
		Message<UpdateExternalAccountMapTWDto> message = MessageBuilder.withPayload(UpdateExternalAccountMapTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getExternalAccountMapTwData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getExternalAccountMapTwData method")
	   def"test 1 getExternalAccountMapTwData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getExternalAccountMapTWData(_,_,_) >> new Exception()
		
		def UpdateExternalAccountMapTWDto = new UpdateExternalAccountMapTWDto()
		Message<UpdateExternalAccountMapTWDto> message = MessageBuilder.withPayload(UpdateExternalAccountMapTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getExternalAccountMapTwData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getExternalAccountMapTwData method")
	   def"test 1 getExternalAccountMapTwData method null"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getExternalAccountMapTWData(_,_,_) >> null
		
		def UpdateExternalAccountMapTWDto = new UpdateExternalAccountMapTWDto()
		Message<UpdateExternalAccountMapTWDto> message = MessageBuilder.withPayload(UpdateExternalAccountMapTWDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getExternalAccountMapTwData(message)
		
		then:
		response == null;
		
	   }

	   
	   @Unroll("test 1 getExternalAccountMapTmData method")
	   def"test 1 getExternalAccountMapTmData method"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getExternalAccountMapTMData(_,_,_) >> new ExternalWebModel()

		def accountMaintenanceListenerService = Mock(AccountMaintenanceListenerService)
		accountMaintenanceListenerService.saveExternalAccountMapTMData(_,_,_)>> true
		
		def UpdateExternalAccountMapDto = new UpdateExternalAccountMapDto()
		Message<UpdateExternalAccountMapDto> message = MessageBuilder.withPayload(UpdateExternalAccountMapDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceListenerService = accountMaintenanceListenerService
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getExternalAccountMapTmData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getExternalAccountMapTmData method")
	   def"test 1 getExternalAccountMapTmData method exception"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getExternalAccountMapTMData(_,_,_) >> new Exception()
	
		def UpdateExternalAccountMapDto = new UpdateExternalAccountMapDto()
		Message<UpdateExternalAccountMapDto> message = MessageBuilder.withPayload(UpdateExternalAccountMapDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getExternalAccountMapTmData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getExternalAccountMapTmData method")
	   def"test 1 getExternalAccountMapTmData method null"(){
		given:
   
		
		def accountMaintenanceServiceClient = Mock(AccountMaintenanceServiceClient)
		accountMaintenanceServiceClient.getExternalAccountMapTMData(_,_,_) >> null
	
		def UpdateExternalAccountMapDto = new UpdateExternalAccountMapDto()
		Message<UpdateExternalAccountMapDto> message = MessageBuilder.withPayload(UpdateExternalAccountMapDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountMaintenanceServiceClient = accountMaintenanceServiceClient
		
		when:
		def response = service.getExternalAccountMapTmData(message)
		
		then:
		response == null;
		
	   }
	   
	
	   @Unroll("test 1 getUpdatedAutoDebitInstrument method")
	   def"test 1 getUpdatedAutoDebitInstrument method null"(){
		given:
   
		
		def instrumentReceivablesServiceClient = Mock(InstrumentReceivablesServiceClient)
		
		def autoDebitTxnDetailsDto = new AutoDebitTxnDetailsDto()
		 def list3 = new ArrayList()
		 list3.add(autoDebitTxnDetailsDto)
		 //def autoDebitTxnDetails = new AutoDebitTxnDetails()
		 
		 def autoDebitTxnDto = new AutoDebitTxnDto()
	    // def list = new ArrayList()
		 //list.add(autoDebitTxnDetails)
		 autoDebitTxnDto.setAutoDebitTxnDetails(list3)
		
		 def list2 = new ArrayList()
		 list2.add(autoDebitTxnDto)
		 def autoDebitTxnCollection = new AutoDebitTxnCollection()
		 autoDebitTxnCollection.setData(list2)
		 instrumentReceivablesServiceClient.getAutoDebitTxns(_,_,_) >> autoDebitTxnCollection
		 
		def accountServiceClient = Mock(AccountMaintenanceServiceClient)
		AccountingTransactionCollection accountingTransactionCollection = new AccountingTransactionCollection()
	    def accountingTransactionModel = new AccountingTransactionModel(id:"1")
		List<AccountingTransactionModel> accountingTxnist = new ArrayList<>()
		accountingTxnist.add(accountingTransactionModel)
		accountingTransactionCollection.setData(accountingTxnist)
		accountServiceClient.getAccountingDataByFinRefNo(_,_,_,_) >> accountingTransactionCollection
		
		eventListenerService.saveAccountsTwData(_) >> null
		eventListenerService.saveAccountsTmData(_) >> null
		eventListenerService.saveAutoDebitData(_) >> true
		
		def UpdateAutoDebitInstrumentDto = new UpdateAutoDebitInstrumentDto()
		Message<UpdateAutoDebitInstrumentDto> message = MessageBuilder.withPayload(UpdateAutoDebitInstrumentDto).build();
		
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.accountServiceClient = accountServiceClient
		service.instrumentReceivablesServiceClient = instrumentReceivablesServiceClient
		service.eventListenerService = eventListenerService
		
		
		
		
		when:
		def response = 	service.getUpdatedAutoDebitInstrument(message)

		
		then:
		response == null;
		
	   }
	   
	   @Unroll("test 1 getExternalDelinqStatusData method")
	   def"test 1 getExternalDelinqStatusData method"(){
		given:
   
		
		def customerListenerService = Mock(CustomerListenerService)
		customerListenerService.saveExtCustomerDelinqStatusData(_,_,_) >> true
	
		def createExternalDelinqDto = new CreateExternalDelinqDto()
		Message<CreateExternalDelinqDto> message = MessageBuilder.withPayload(createExternalDelinqDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.customerListenerService = customerListenerService
		
		when:
		def response = service.getExternalDelinqStatusData(message)
		
		then:
		response == null;
		
	   }
	   
	   

	   @Unroll("test 1 getExternalDelinqStatusData CreateExtCustomerDelinqStatusHisDto method")
	   def"test 1 getExternalDelinqStatusData CreateExtCustomerDelinqStatusHisDto method"(){
		given:
   
		
		def customerListenerService = Mock(CustomerListenerService)
		customerListenerService.saveExtCustomerDelinqStatusData(_,_,_) >> true
	
		def createExtCustomerDelinqStatusHisDto = new CreateExtCustomerDelinqStatusHisDto()
		def listc = new ArrayList<CreateExtCustomerDelinqStatusHisDto>(Arrays.asList(createExtCustomerDelinqStatusHisDto))
		def createExternalDelinqDto = new CreateExternalDelinqDto(createExtCustomerDelinqStatusHisDto : listc)
		Message<CreateExternalDelinqDto> message = MessageBuilder.withPayload(createExternalDelinqDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.customerListenerService = customerListenerService
		
		when:
		def response = service.getExternalDelinqStatusData(message)
		
		then:
		response == null;
		
	   }
	   
	   
	   @Unroll("test 1 getCustomerDelinqStatusData method")
	   def"test 1 getCustomerDelinqStatusData method"(){
		given:
   
		
		def customerListenerService = Mock(CustomerListenerService)
		customerListenerService.saveCustomerDelinqStatusData(_,_,_) >> true
	
		def createCustomerDelinqDto = new CreateCustomerDelinqDto()
		Message<CreateCustomerDelinqDto> message = MessageBuilder.withPayload(createCustomerDelinqDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.customerListenerService = customerListenerService
		
		when:
		def response = service.getCustomerDelinqStatusData(message)
		
		then:
		response == null;
		
	   }
	   
	   

	   @Unroll("test 1 getCustomerDelinqStatusData CreateCustomerDelinqStatusDto method")
	   def"test 1 getCustomerDelinqStatusData CreateCustomerDelinqStatusDto method"(){
		given:
   
		
		def customerListenerService = Mock(CustomerListenerService)
		customerListenerService.saveExtCustomerDelinqStatusData(_,_,_) >> true
	
		def CreateCustomerDelinqStatusDto = new CreateCustomerDelinqStatusDto()
		def listc = new ArrayList<CreateCustomerDelinqStatusDto>(Arrays.asList(CreateCustomerDelinqStatusDto))
		def CreateCustomerDelinqDto = new CreateCustomerDelinqDto(createCustomerDelinqStatusDto : listc)
		Message<CreateCustomerDelinqDto> message = MessageBuilder.withPayload(CreateCustomerDelinqDto).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.customerListenerService = customerListenerService
		
		when:
		def response = service.getCustomerDelinqStatusData(message)
		
		then:
		response == null;
		
	   }
	   
	   @Unroll("test 1 UpdateOBChargesCollection method")
	   def"test 1 UpdateOBChargesCollection method"(){
		given:
   
		
		def customerListenerService = Mock(CustomerListenerService)
		customerListenerService.saveExtCustomerDelinqStatusData(_,_,_) >> true
	
		def UpdateOBChargesDto = new UpdateOBChargesDto()
		def listc = new ArrayList<UpdateOBChargesDto>(Arrays.asList(UpdateOBChargesDto))
		def UpdateOBChargesCollection = new UpdateOBChargesCollection(txnRefNo:"123", chargeCode:"cd",eventCode:"ec",userId:"userId",serviceBranchCode:"004",UpdateOBChargesDto : listc,UpdateOBChargesTWDto:listc)
		Message<UpdateOBChargesCollection> message = MessageBuilder.withPayload(UpdateOBChargesCollection).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.customerListenerService = customerListenerService
		
		when:
		def response = service.getOBChargesData(message)
		
		then:
		response == null;
		
	   }
	   
	   @Unroll("test 1 UpdateOBChargesCollection method 1")
	   def"test 1 UpdateOBChargesCollection method 1"(){
		given:
   
		
		def chargesListenerService = Mock(ChargesListenerService)
		chargesListenerService.saveOBChargesData(_,_,_,_,_,_,_) >> true
	
		def UpdateOBChargesDto = new UpdateOBChargesDto(calcUnits:1,chargeAmount:1,chargeCriteriaValue:1,chgSharingPct:1,collectionUnits:1,exchangeRate:1)
		def listc = new ArrayList<UpdateOBChargesDto>(Arrays.asList(UpdateOBChargesDto))
		def UpdateOBChargesCollection = new UpdateOBChargesCollection(txnRefNo:"123", chargeCode:"cd",eventCode:"ec",userId:"userId",serviceBranchCode:"004",UpdateOBChargesDto : listc,UpdateOBChargesTWDto:listc)
		Message<UpdateOBChargesCollection> message = MessageBuilder.withPayload(UpdateOBChargesCollection).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.chargesListenerService = chargesListenerService
		
		when:
		def response = service.getOBChargesData(message)
		
		then:
		response == null;
		
	   }
	
	   
	   @Unroll("test 1 getOBFinanceDetailsData method 1")
	   def"test 1 getOBFinanceDetailsData method 1"(){
		given:
   
		
		def chargesListenerService = Mock(ChargesListenerService)
		chargesListenerService.saveOBFinanceDetailsData(_,_,_,_,_) >> true
	
		def UpdateOBFinanceDto = new UpdateOBFinanceDto(financeAmt:1,outdtandingAmt:1,repaymentAmt:1)
		def listc = new ArrayList<UpdateOBFinanceDto>(Arrays.asList(UpdateOBFinanceDto))
		def UpdateOBFinanceCollection = new UpdateOBFinanceCollection(UpdateOBFinanceDto:listc)
		Message<UpdateOBFinanceCollection> message = MessageBuilder.withPayload(UpdateOBFinanceCollection).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.chargesListenerService = chargesListenerService
		
		when:
		def response = service.getOBFinanceDetailsData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getOBFinanceDetailsData catch")
	   def"test 1 getOBFinanceDetailsData catch"(){
		given:
   
		
		def chargesListenerService = Mock(ChargesListenerService)
		chargesListenerService.saveOBFinanceDetailsData(_,_,_,_,_) >> true
	
		def UpdateOBFinanceDto = new UpdateOBFinanceDto()
		def listc = new ArrayList<UpdateOBFinanceDto>(Arrays.asList(UpdateOBFinanceDto))
		def UpdateOBFinanceCollection = new UpdateOBFinanceCollection(UpdateOBFinanceDto:listc)
		Message<UpdateOBFinanceCollection> message = MessageBuilder.withPayload(UpdateOBFinanceCollection).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.chargesListenerService = chargesListenerService
		
		when:
		def response = service.getOBFinanceDetailsData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getOBInvoiceDetailsData method 1")
	   def"test 1 getOBInvoiceDetailsData method 1"(){
		given:
   
		
		def chargesListenerService = Mock(ChargesListenerService)
		chargesListenerService.saveOBInvoiceDetailsData(_,_,_,_,_,_,_) >> true
	
		def UpdateOBInvoiceDetailsDto = new UpdateOBInvoiceDetailsDto(acceptanceAmount:1,netInvoiceAmt:1)
		def listc = new ArrayList<UpdateOBInvoiceDetailsDto>(Arrays.asList(UpdateOBInvoiceDetailsDto))
		def UpdateOBInvoiceDetailsCollection = new UpdateOBInvoiceDetailsCollection(UpdateOBInvoiceDetailsDto:listc)
		Message<UpdateOBInvoiceDetailsCollection> message = MessageBuilder.withPayload(UpdateOBInvoiceDetailsCollection).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.chargesListenerService = chargesListenerService
		
		when:
		def response = service.getOBInvoiceDetailsData(message)
		
		then:
		response == null;
		
	   }

	   @Unroll("test 1 getOBInvoiceDetailsData catch")
	   def"test 1 getOBInvoiceDetailsData catch"(){
		given:
   
		def UpdateOBInvoiceDetailsCollection = new UpdateOBInvoiceDetailsCollection()
		Message<UpdateOBInvoiceDetailsCollection> message = MessageBuilder.withPayload(UpdateOBInvoiceDetailsCollection).build();
		
		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		
		when:
		def response = service.getOBInvoiceDetailsData(message)
		
		then:
		response == null;
		
	   }

	@Unroll("test sendInvoiceCashflowData method")
	def"test sendInvoiceCashflowData method"(){
		given:

		EventListenerService eventListenerService = Mock(EventListenerService)
		InstrumentReceivablesServiceClient instrumentReceivablesServiceClient = Mock(InstrumentReceivablesServiceClient)
		OBIntegrationAdapter obIntegrationAdapter = Mock(OBIntegrationAdapter)

		PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
		service.eventListenerService = eventListenerService
		service.instrumentReceivablesServiceClient = instrumentReceivablesServiceClient
		service.obIntegrationAdapter = obIntegrationAdapter

		InvoiceCollectionDto  dto = new InvoiceCollectionDto()
		List invoiceModelList = new ArrayList<InvoiceModel> ()
		InvoiceModel invoiceModel = new InvoiceModel(id:"1")
		invoiceModelList.add(invoiceModel)
		dto.setData(invoiceModelList)

		instrumentReceivablesServiceClient.getInvoiceMaintByTxnRefNo(_,_,_) >> dto
		obIntegrationAdapter.handleTransaction(_)>> new OBIntegrationServiceResponse()

		Message<InvoiceTmCashflowDto> message = MessageBuilder.withPayload(invoiceTmCashflowDto).build();

		when:
		def response = service.sendInvoiceCashflowData(message)
		then:
		response == null;
	}
	@Unroll("test sendInvoiceCashflowData ")
	def"test sendInvoiceCashflowData "(){
	 given:
	 
	 def obIntegrationAdapter= Mock(OBIntegrationAdapter)
	 def instrumentReceivablesServiceClient=Mock(InstrumentReceivablesServiceClient)
	 PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
	 service.obIntegrationAdapter=obIntegrationAdapter
	 service.instrumentReceivablesServiceClient=instrumentReceivablesServiceClient
	 InvoiceTmCashflowDto invoiceTmCashflowDto = new InvoiceTmCashflowDto()
	 InvoiceCollectionDto invoiceCollectionDto = new InvoiceCollectionDto()
	 InvoiceModel invoiceModel=new InvoiceModel()
	 List<InvoiceModel> invoiceModelList = new ArrayList()
	 invoiceModelList.add(invoiceModel)
	 invoiceCollectionDto.setData(invoiceModelList)
	 instrumentReceivablesServiceClient.getInvoiceMaintByTxnRefNo(_, _, _)>>invoiceCollectionDto
	 Message<ReconTmCashflowDto> message = MessageBuilder.withPayload(invoiceTmCashflowDto).build();
 
	 when:
	 def response = service.sendInvoiceCashflowData(message)
	 
	 then:
	 response == null;
	 
	}
	@Unroll("test sendReconInvPmtCnToCashflow ")
	def"test sendReconInvPmtCnToCashflow "(){
	 given:
	 
	 def obIntegrationAdapter= Mock(OBIntegrationAdapter)
	 ReconTmCashflowDto reconTmCashflowDto = new ReconTmCashflowDto()
	 reconTmCashflowDto.userId="userId"
	 reconTmCashflowDto.branchCode="branchCode"
	 reconTmCashflowDto.reconTxnRefNo="reconTxnRefNo"
	 List<ReconInvPmtDto> requestIPRList=new ArrayList()
	 ReconInvPmtDto reconInvPmtDto=new ReconInvPmtDto()
	 requestIPRList.add(reconInvPmtDto)
	 List<ReconInvCnDto> requestICRList=new ArrayList()
	 ReconInvCnDto reconInvCnDto=new ReconInvCnDto()
	 requestICRList.add(reconInvCnDto)
	 ReconTxnDto reconTxnDto=new ReconTxnDto()
	 reconTxnDto.setObReconInvPmtTxnTwDtoList(requestIPRList)
	 reconTxnDto.setObReconInvCnTxnTwDtoList(requestICRList)
	 reconEventServiceClient.getReconTmData(_,_,_)>>reconTxnDto
	 Message<ReconTmCashflowDto> message = MessageBuilder.withPayload(reconTmCashflowDto).build();
	 PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
	 service.obIntegrationAdapter=obIntegrationAdapter
	 OBIntegrationServiceResponse resp=new OBIntegrationServiceResponse()
	 resp.setStatus("SUCCESS")
	 HashMap<String, Object> responseParams = new HashMap<>();
	 CashflowResponse cashflowResponseDetails=new CashflowResponse()
	 responseParams.put("cashflowResponse", cashflowResponseDetails)
	 resp.setResponseParams(responseParams);
	 obIntegrationAdapter.handleTransaction(_)>>resp
	 when:
	 def response = service.sendReconInvPmtCnToCashflow(message)
	 
	 then:
	 response == null;
	 
	}
 
 @Unroll("test sendInvoiceCashflowData method")
 def"test sendInvoiceCashflowData 1 method"(){
	 given:

	 EventListenerService eventListenerService = Mock(EventListenerService)
	 InstrumentReceivablesServiceClient instrumentReceivablesServiceClient = Mock(InstrumentReceivablesServiceClient)
	 OBIntegrationAdapter obIntegrationAdapter = Mock(OBIntegrationAdapter)

	 PlatoCloudStreamListenerService service = new PlatoCloudStreamListenerService(eventServiceClient,reconEventServiceClient)
	 service.eventListenerService = eventListenerService
	 service.instrumentReceivablesServiceClient = instrumentReceivablesServiceClient
	 service.obIntegrationAdapter = obIntegrationAdapter

	 InvoiceCollectionDto  dto = new InvoiceCollectionDto()
	 List invoiceModelList = new ArrayList<InvoiceModel> ()
	 InvoiceModel invoiceModel = new InvoiceModel(id:"1")
	 invoiceModelList.add(invoiceModel)
	 dto.setData(invoiceModelList)

	 instrumentReceivablesServiceClient.getInvoiceMaintByTxnRefNo(_,_,_) >> dto
	 obIntegrationAdapter.handleTransaction(_)>> new OBIntegrationServiceResponse()

	 Message<InvoiceTmCashflowDto> message = MessageBuilder.withPayload(invoiceTmCashflowDto).build();

	 when:
	 def response = service.sendInvoiceCashflowData(message)
	 then:
	 response == null;
 }
	   
}