package oracle.fsgbu.customer.test.service

import static org.junit.Assert.*

import java.text.DateFormat
import java.text.SimpleDateFormat
import java.sql.Timestamp
import java.time.LocalDate

import org.springframework.messaging.Message;
import org.springframework.stereotype.Service;
import avro.oracle.fsgbu.obscfcm.services.relationship.dto.UpdateRelationshipMasterDto;
import oracle.fsgbu.obscfcm.services.report.client.ObscfcmCoreServiceClient;
import oracle.fsgbu.obscfcm.services.report.client.RelationshipEventServiceClient;
import oracle.fsgbu.obscfcm.services.report.constants.ReportConstants;
import oracle.fsgbu.obscfcm.services.report.kafka.PlatoMessageChannels;
import oracle.fsgbu.obscfcm.services.report.service.RelationshipCloudStreamListenerService
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipMasterDTO;
import oracle.fsgbu.obscfcm.services.scfcm.dto.RelationshipmasterWebModel;
import org.junit.Test

import spock.lang.Shared
import spock.lang.Specification
import spock.lang.Unroll
import org.springframework.messaging.Message
import org.springframework.messaging.support.MessageBuilder
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipMasterDTO.*;
import oracle.fsgbu.obscfcm.services.report.service.*;
class RelationshipCloudStreamListenerImplSpec extends Specification{
	
	//@Shared UpdateRelationshipMasterDto = new UpdateRelationshipMasterDto()
	
	
	@Unroll("test getRelationshipData method")
	def"test getRelationshipData method"(){
		given:
	
		// Message<UpdateRelationshipMasterDto> message = MessageBuilder.withPayload(UpdateRelationshipMasterDto).build();

		UpdateRelationshipMasterDto.Builder updatedRelationship = UpdateRelationshipMasterDto.newBuilder();
		
		final Message<UpdateRelationshipMasterDto> message = MessageBuilder.withPayload(updatedRelationship.build())
		.build();
		def obscfcmCoreServiceClient = Mock(ObscfcmCoreServiceClient)
		def relationshipEventListenerService = Mock(RelationshipEventListenerService)
		obscfcmCoreServiceClient.getByResourceId(_, _, _) >> new RelationshipmasterWebModel()
		relationshipEventListenerService.saveRelationshipData(null) >> null
		relationshipEventListenerService.saveRelationshipTwData(null) > null

		
		RelationshipCloudStreamListenerService relationshipCloudStreamListenerService= new RelationshipCloudStreamListenerService()
		
		
		relationshipCloudStreamListenerService.obscfcmCoreServiceClient = obscfcmCoreServiceClient
		relationshipCloudStreamListenerService.relationshipEventListenerService = relationshipEventListenerService

				when:	
		def response = relationshipCloudStreamListenerService.getRelationshipData(message)
		then:
		response==null
	}
	
	
	
	
	@Unroll("test getRelationshipTwData method")
	def"test getRelationshipTwData method"(){
		given:
	
UpdateRelationshipMasterDto.Builder updatedRelationship = UpdateRelationshipMasterDto.newBuilder();
		
		final Message<UpdateRelationshipMasterDto> message = MessageBuilder.withPayload(updatedRelationship.build())
		.build();
		def obscfcmCoreServiceClient = Mock(ObscfcmCoreServiceClient)
		def relationshipEventListenerService = Mock(RelationshipEventListenerService)
		RelationshipmasterWebModel RelationshipmasterWebModel = new RelationshipmasterWebModel()
		ObcmTmRelationshipMasterDTO ObcmTmRelationshipMasterDTO = new ObcmTmRelationshipMasterDTO()
		RelationshipmasterWebModel.setObcmTmRelationshipMaster(ObcmTmRelationshipMasterDTO);
		obscfcmCoreServiceClient.getByResourceId(_, _, _) >> RelationshipmasterWebModel
		relationshipEventListenerService.saveRelationshipData(null) >> null
		relationshipEventListenerService.saveRelationshipTwData(null) > null

		
		RelationshipCloudStreamListenerService relationshipCloudStreamListenerService= new RelationshipCloudStreamListenerService()
		
		
		relationshipCloudStreamListenerService.obscfcmCoreServiceClient = obscfcmCoreServiceClient
		relationshipCloudStreamListenerService.relationshipEventListenerService = relationshipEventListenerService

				when:
		def response = relationshipCloudStreamListenerService.getRelationshipTwData(message)
		then:
		response==null
	}

	
	
	}

