package oracle.fsgbu.customer.test.service

import java.text.DateFormat
import java.text.SimpleDateFormat
import java.sql.Timestamp
import java.time.LocalDate
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipMasterDTO;
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipDetailsDTO;
import oracle.fsgbu.obscfcm.services.scfcm.dto.ObcmTmRelationshipDetailsExternalCodeDTO;


import oracle.fsgbu.obscfcm.services.report.persistence.*
import oracle.fsgbu.obscfcm.services.report.service.RelationshipEventListenerServiceImpl

import org.junit.Test

import spock.lang.Specification
import spock.lang.Unroll

class RelationshipEventListenerServiceImplSpec extends Specification{

	def mockRelationshipRepository = Mock(ObcmTmRelationshipMasterRepository)

	@Unroll("test saveRelationshipData method")
	def"test saveRelationshipData method exception"(){
		given:
		ObcmTmRelationshipMasterDTO relationshipDto = new ObcmTmRelationshipMasterDTO();
		def mockRelationshipRepository = Mock(ObcmTmRelationshipMasterRepository)

		RelationshipEventListenerServiceImpl service = new RelationshipEventListenerServiceImpl()

		when:
		def response = service.saveRelationshipData(relationshipDto)
		then:
		response == false;
	}

	@Unroll("test saveRelationshipData method")
	def"test saveRelationshipData method "(){
		given:

		RelationshipEventListenerServiceImpl eventListenerServiceImpl = new RelationshipEventListenerServiceImpl()
		ObcmTmRelationshipMasterDTO relationshipDto = new ObcmTmRelationshipMasterDTO();
		def mockRelationshipRepository = Mock(ObcmTmRelationshipMasterRepository)
		eventListenerServiceImpl.relationshipRepository=mockRelationshipRepository
		
		relationshipDto.setAuthStatus("A");
		relationshipDto.setAutoAcceptance("Y");
		relationshipDto.setCheckerId("SWETA");
		relationshipDto.setCorporateId("123");
		relationshipDto.setCorporateName("nova");
		relationshipDto.setEffFromDate("2020-02-09");
		relationshipDto.setExpiresOn("2020-02-09");
		relationshipDto.setId("87777");
		relationshipDto.setMakerId("SUNIL");
		relationshipDto.setNoOfDays(1);
		relationshipDto.setOnceAuth("Y");
		relationshipDto.setProduct("P");
		relationshipDto.setRecordStatus("O");
		relationshipDto.setRelationshipCode("KAFKA1");
		relationshipDto.setRelationshipName("TEST");

		List<ObcmTmRelationshipDetailsDTO> detailsDTOList = new ArrayList<>();

		ObcmTmRelationshipDetailsDTO detailsDTO = new ObcmTmRelationshipDetailsDTO()
		detailsDTO.setAutoAcceptance("Y");
		detailsDTO.setCounterpartyid("122");
		detailsDTO.setCounterpartyname("abc");
		detailsDTO.setExpiresOn("2020-12-11");
		detailsDTO.setId("122");
		detailsDTO.setNoOfDays(23);
		detailsDTO.setPartyType("B");
		detailsDTO.setRelationsMasterId("ijh6666");
		detailsDTO.setStatus("A");

		List<ObcmTmRelationshipDetailsExternalCodeDTO> extCodeList = new ArrayList<>();
		ObcmTmRelationshipDetailsExternalCodeDTO extCodes = new ObcmTmRelationshipDetailsExternalCodeDTO();
		extCodes.setCorporateDivisionCode("33errr");
		extCodes.setDivisionCode("4rrrf");
		extCodes.setExternalCode("ext123");
		extCodes.setId("123");
		extCodes.setRelationshipDetailId("233");
		extCodeList.add(extCodes);

		detailsDTO.setExternalCodes(extCodeList);
		detailsDTOList.add(detailsDTO);
		relationshipDto.setObcmTmRelationshipDetailsDTO(detailsDTOList);
		
		List list = new ArrayList();
		mockRelationshipRepository.executeNamedQueryByCondition(_,_,_) >> list
		when:
		def response = eventListenerServiceImpl.saveRelationshipData(relationshipDto)
		then:
		response == false;
	}
	
	
	
	
	
	@Unroll("test saveRelationshipTwData method")
	def"test saveRelationshipTwData method exception"(){
		given:
		ObcmTmRelationshipMasterDTO relationshipDto = new ObcmTmRelationshipMasterDTO();
		def mockRelationshipRepository = Mock(ObcmTwRelationshipMasterRepository)

		RelationshipEventListenerServiceImpl service = new RelationshipEventListenerServiceImpl()

		when:
		def response = service.saveRelationshipTwData(relationshipDto)
		then:
		response == false;
	}

	@Unroll("test saveRelationshipTwData method")
	def"test saveRelationshipTwData method "(){
		given:

		RelationshipEventListenerServiceImpl eventListenerServiceImpl = new RelationshipEventListenerServiceImpl()
		ObcmTmRelationshipMasterDTO relationshipDto = new ObcmTmRelationshipMasterDTO();
		def mockRelationshipRepository = Mock(ObcmTwRelationshipMasterRepository)
		eventListenerServiceImpl.obcmTwRelationshipMasterRepository=mockRelationshipRepository
		
		relationshipDto.setAuthStatus("A");
		relationshipDto.setAutoAcceptance("Y");
		relationshipDto.setCheckerId("SWETA");
		relationshipDto.setCorporateId("123");
		relationshipDto.setCorporateName("nova");
		relationshipDto.setEffFromDate("2020-02-09");
		relationshipDto.setExpiresOn("2020-02-09");
		relationshipDto.setId("87777");
		relationshipDto.setMakerId("SUNIL");
		relationshipDto.setNoOfDays(1);
		relationshipDto.setOnceAuth("Y");
		relationshipDto.setProduct("P");
		relationshipDto.setRecordStatus("O");
		relationshipDto.setRelationshipCode("KAFKA1");
		relationshipDto.setRelationshipName("TEST");

		List<ObcmTmRelationshipDetailsDTO> detailsDTOList = new ArrayList<>();

		ObcmTmRelationshipDetailsDTO detailsDTO = new ObcmTmRelationshipDetailsDTO()
		detailsDTO.setAutoAcceptance("Y");
		detailsDTO.setCounterpartyid("122");
		detailsDTO.setCounterpartyname("abc");
		detailsDTO.setExpiresOn("2020-12-11");
		detailsDTO.setId("122");
		detailsDTO.setNoOfDays(23);
		detailsDTO.setPartyType("B");
		detailsDTO.setRelationsMasterId("ijh6666");
		detailsDTO.setStatus("A");

		List<ObcmTmRelationshipDetailsExternalCodeDTO> extCodeList = new ArrayList<>();
		ObcmTmRelationshipDetailsExternalCodeDTO extCodes = new ObcmTmRelationshipDetailsExternalCodeDTO();
		extCodes.setCorporateDivisionCode("33errr");
		extCodes.setDivisionCode("4rrrf");
		extCodes.setExternalCode("ext123");
		extCodes.setId("123");
		extCodes.setRelationshipDetailId("233");
		extCodeList.add(extCodes);

		detailsDTO.setExternalCodes(extCodeList);
		detailsDTOList.add(detailsDTO);
		relationshipDto.setObcmTmRelationshipDetailsDTO(detailsDTOList);
		
		List list = new ArrayList();
		mockRelationshipRepository.executeNamedQueryByCondition(_,_,_) >> list
		when:
		def response = eventListenerServiceImpl.saveRelationshipTwData(relationshipDto)
		then:
		response == true;
	}
}