package oracle.fsgbu.customer.test.web
import oracle.fsgbu.eventService.api.model.FileUploadDto
import oracle.fsgbu.eventService.api.model.InvoiceDto
import oracle.fsgbu.eventService.api.model.InvoiceModel
import oracle.fsgbu.eventService.api.model.InvoiceTmDto
import oracle.fsgbu.eventService.api.model.PaymentDto
import oracle.fsgbu.obscfcm.services.report.service.EventListenerService
import oracle.fsgbu.obscfcm.services.report.web.EventListenerServiceController
import spock.lang.Specification;
import spock.lang.Unroll;


class EventListenerServiceControllerSpec extends Specification {
	
	
	
	def EventListenerService mockEventService = Mock(EventListenerService)
	
	@Unroll("test saveInvoiceData method")
	def"test saveInvoiceData method"(){
		given:
		
		def EventListenerService mockEventService = Mock(EventListenerService)
		EventListenerServiceController eventServiceController = new EventListenerServiceController(mockEventService)
		
		when:
		def response = eventServiceController.saveInvoiceData("SCFREPORT", "SWETA", "004", new InvoiceTmDto())
		
		then:
		response!= null
		
	}
	
	@Unroll("test savePaymentData method")
	def"test savePaymentData method"(){
		given:
		
		def EventListenerService mockEventService = Mock(EventListenerService)
		EventListenerServiceController eventServiceController = new EventListenerServiceController(mockEventService)
		
		when:
		def response = eventServiceController.savePaymentData("SCFREPORT", "SWETA", "004", new PaymentDto())
		
		then:
		response!= null
		
	}
	
	@Unroll("test saveUploadedFileData method")
	def"test saveUploadedFileData method"(){
		given:
		
		def EventListenerService mockEventService = Mock(EventListenerService)
		EventListenerServiceController eventServiceController = new EventListenerServiceController(mockEventService)
		
		when:
		def response = eventServiceController.saveUploadedFileData("SCFREPORT", "SWETA", "004", new FileUploadDto())
		
		then:
		response!= null
		
	}
	
	
}