package oracle.fsgbu.customer.test.web;


import oracle.fsgbu.obscfcm.services.report.exception.InvalidDateRangeException
import oracle.fsgbu.obscfcm.services.report.exception.InvalidTrendLineDateException
import oracle.fsgbu.obscfcm.services.report.service.ReconDashboardService
import oracle.fsgbu.obscfcm.services.report.web.ReconDashboardServiceController

import javax.validation.Valid

import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.RequestHeader
import org.springframework.web.bind.annotation.RequestParam

import io.swagger.annotations.ApiParam
import spock.lang.Shared
import spock.lang.Specification
import spock.lang.Unroll


class ReconDashboardControllerSpec extends Specification {
	
	
	def ReconDashboardService reconDashboardService = Mock(ReconDashboardService)
	
	@Unroll("test getInvoiceReconCategoryList method")
	def"test getInvoiceReconCategoryList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconCategoryList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getInvoiceReconCategoryList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01", "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getInvoiceReconCategoryList method1")
	def"test getInvoiceReconCategoryList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconCategoryList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getInvoiceReconCategoryList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01", "12345")
		
		then:
		thrown Exception
		
	}
	
	@Unroll("test getInvoiceReconTrendGraphList method")
	def"test getInvoiceReconTrendGraphList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getInvoiceReconTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01", "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getInvoiceReconTrendGraphList method1")
	def"test getInvoiceReconTrendGraphList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getInvoiceReconTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01", "12345")
		
		then:
		thrown Exception
		
	}
	
	@Unroll("test getCashFlowReconCategoryList method")
	def"test getCashFlowReconCategoryList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getCashFlowReconCategoryList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getCashFlowReconCategoryList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01", "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getCashFlowReconCategoryList method1")
	def"test getCashFlowReconCategoryList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getCashFlowReconCategoryList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getCashFlowReconCategoryList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01", "12345")
		
		then:
		thrown Exception
		
	}
	
	@Unroll("test getCashFlowReconTrendGraphList method")
	def"test getCashFlowReconTrendGraphList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getCashFlowReconTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getCashFlowReconTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01", "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getCashFlowReconTrendGraphList method1")
	def"test getCashFlowReconTrendGraphList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getCashFlowReconTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getCashFlowReconTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01", "12345")
		
		then:
		thrown Exception
		
	}
	@Unroll("test getAllocationReconCategoryList method")
	def"test getAllocationReconCategoryList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getAllocationReconCategoryList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getAllocationReconCategoryList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01", "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getAllocationReconCategoryList method1")
	def"test getAllocationReconCategoryList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getAllocationReconCategoryList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getAllocationReconCategoryList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01", "12345")
		
		then:
		thrown Exception
		
	}
	
	
	@Unroll("test getAllocationReconTrendGraphList method")
	def"test getAllocationReconTrendGraphList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getAllocationReconTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getAllocationReconTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01", "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getAllocationReconTrendGraphList method1")
	def"test getAllocationReconTrendGraphList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getAllocationReconTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getAllocationReconTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01", "12345")
		
		then:
		thrown Exception
		
	}
	
	
	@Unroll("test getFinanceReconCategoryList method")
	def"test getFinanceReconCategoryList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getFinanceReconCategoryList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getFinanceReconCategoryList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01", "12345")
		
		then:
		response!= null
		
	}
	
	
	@Unroll("test getFinanceReconCategoryList method1")
	def"test getFinanceReconCategoryList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getFinanceReconCategoryList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getFinanceReconCategoryList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01", "12345")
		
		then:
		thrown Exception
		
	}

	@Unroll("test getFinanceReconTrendGraphList method")
	def"test getFinanceReconTrendGraphList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getFinanceReconTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getFinanceReconTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01", "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getFinanceReconTrendGraphList method1")
	def"test getFinanceReconTrendGraphList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getFinanceReconTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getFinanceReconTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01", "12345")
		
		then:
		thrown Exception
		
	}
	
	@Unroll("test getAllocationReconTopCorporateList method")
	def"test getAllocationReconTopCorporateList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getAllocationReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getAllocationReconTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01","M", null, null, "12345")
		
		then:
		response!= null
		
	}
	
	
	@Unroll("test getAllocationReconTopCorporateList method1")
	def"test getAllocationReconTopCorporateList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getAllocationReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getAllocationReconTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01","M", null, null, "12345")
		
		then:
		thrown Exception
		
	}
	@Unroll("test getInvoiceReconTopCorporateList method")
	def"test getInvoiceReconTopCorporateList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getInvoiceReconTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01","M", null, null, "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getCashflowReconTopCorporateList method")
	def"test getCashflowReconTopCorporateList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getCashflowReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getCashflowReconTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01","M", null, null, "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getFinanceReconTopCorporateList method")
	def"test getFinanceReconTopCorporateList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getFinanceReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getFinanceReconTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01","M", null, null, "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getReconciliationTrendGraphList method")
	def"test getReconciliationTrendGraphList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getReconciliationTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getReconciliationTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01", "12345")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getReconciliationTrendGraphList method")
	def"test getReconciliationTrendGraphList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getReconciliationTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getReconciliationTrendGraphList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01", "12345")
		
		then:
		thrown Exception
		
	}
	
	
	
	@Unroll("test getInvoiceReconTopCorporateList method")
	def"test getInvoiceReconTopCorporateList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getInvoiceReconTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01","M", null, null, "12345")
		
		then:
		thrown Exception
		
	}
	
	@Unroll("test getCashflowReconTopCorporateList method")
	def"test getCashflowReconTopCorporateList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getCashflowReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getCashflowReconTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01","M", null, null, "12345")
		
		then:
		thrown Exception
		
	}
	
	@Unroll("test getFinanceReconTopCorporateList method")
	def"test getFinanceReconTopCorporateList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getFinanceReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getFinanceReconTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01","M", null, null, "12345")
		
		then:
		thrown Exception
		
	}
	
	@Unroll("test getReconciliationTopCorporateList method")
	def"test getReconciliationTopCorporateList method1"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getReconciliationTrendGraphList("DEV","004","2019-01-13","2020-01-13", "12345")
		
		when:
		def response = controller.getReconciliationTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2022-01-01","M", null, null, "12345")
		
		then:
		thrown Exception
		
	}
	
	
	
	@Unroll("test getInvoiceReconTopCorporateList method")
	def"test getReconciliationTopCorporateList method"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getReconciliationTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01","M", null, null, "12345")
		
		then:
		response!=null
		
	}
	
	
	@Unroll("test getInvoiceReconTopCorporateList method")
	def"test getInvoiceReconTopCorporateList method2"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getInvoiceReconTopCorporateList("SCFREPORT","DEV","004","2019-08-01", "2020-01-01","M", "Y", "JAN-2020", "12345")
		
		then:
		response!= null
		
	} 
	
	@Unroll("test getInvoiceReconTopCorporateList method")
	def"test getInvoiceReconTopCorporateList method3"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getInvoiceReconTopCorporateList("SCFREPORT","DEV","004","2019-02-02", "2019-01-01","M", "Y", "2020-03-03", "12345")
		
		then:
		thrown InvalidTrendLineDateException
		
	}
	
	
	
	@Unroll("test getReconciliationTopCorporateList method2")
	def"test getReconciliationTopCorporateList method2"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getInvoiceReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getReconciliationTopCorporateList("SCFREPORT","DEV","004","2019-02-02","2019-01-01","M", "Y", "2020-03-03", "12345")
		
		then:
		thrown InvalidTrendLineDateException
		
	}
	
	
	@Unroll("test getFinanceReconTopCorporateList method")
	def"test getFinanceReconTopCorporateList method2"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getFinanceReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getFinanceReconTopCorporateList("SCFREPORT","DEV","004","2019-02-02","2019-01-01","M", "Y", "2020-03-03", "12345")
		
		then:
	thrown InvalidTrendLineDateException
			
	}
	
	
	@Unroll("test getCashflowReconTopCorporateList method")
	def"test getCashflowReconTopCorporateList method2"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getCashflowReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getCashflowReconTopCorporateList("SCFREPORT","DEV","004","2019-02-02","2019-01-01","M", "Y", "2020-03-03", "12345")
		
		then:
	thrown InvalidTrendLineDateException
			
	}
	
	
	@Unroll("test getAllocationReconTopCorporateList method")
	def"test getAllocationReconTopCorporateList method2"(){
		given:
		
		def mockreconDashboardService = Mock(ReconDashboardService)
		ReconDashboardServiceController controller = new ReconDashboardServiceController(reconDashboardService)
		reconDashboardService.getAllocationReconTopCorporateList("DEV","004","2019-01-13","2020-01-13","M", null, null, "12345")
		
		when:
		def response = controller.getAllocationReconTopCorporateList("SCFREPORT","DEV","004","2019-02-02","2019-01-01","M", "Y", "2020-03-03", "12345")
		
		then:
	thrown InvalidTrendLineDateException
		
	}
}