package oracle.fsgbu.customer.test.web
import spock.lang.Specification;
import spock.lang.Unroll;
import java.math.BigDecimal
import spock.lang.Shared
import oracle.fsgbu.eventService.api.model.InvoiceDto
import oracle.fsgbu.gus.persistence.provider.GlobalHolder
import oracle.fsgbu.gus.persistence.provider.RequestContext
import oracle.fsgbu.obscfcm.services.report.util.ReportingUtil
import org.junit.Test

import oracle.fsgbu.obscfcm.services.report.service.EventListenerService
import oracle.fsgbu.obscfcm.services.report.service.ReconEventListenerService
import oracle.fsgbu.obscfcm.services.report.service.ReportCreationService;
import oracle.fsgbu.obscfcm.services.report.web.EventListenerServiceController
import oracle.fsgbu.obscfcm.services.report.web.ReconEventListenerServiceController
import oracle.fsgbu.obscfcm.services.report.web.ReportCreationServiceController
import oracle.fsgbu.reconService.api.model.ExpDrCrPmtReconDTO
import oracle.fsgbu.reconService.api.model.FinPmtReconDTO
import oracle.fsgbu.reconService.api.model.InvPmtReconDTO


class ReconEventListenerServiceControllerSpec extends Specification {
	
	
	
	def ReconEventListenerService mockEventService = Mock(ReconEventListenerService)
	
	@Unroll("test saveExpDrCrRecon method")
	def"test saveExpDrCrRecon method"(){
		given:
		
		def ReconEventListenerService mockEventService = Mock(ReconEventListenerService)
		ReconEventListenerServiceController eventServiceController = new ReconEventListenerServiceController(mockEventService)
		
		when:
		def response = eventServiceController.saveExpDrCrRecon("SCFREPORT", "SWETA", "004", new ExpDrCrPmtReconDTO())
		
		then:
		response!= null
		
	}
	@Unroll("test saveFinPmtRecon method")
	def"test saveFinPmtRecon method"(){
		given:
		
		def ReconEventListenerService mockEventService = Mock(ReconEventListenerService)
		ReconEventListenerServiceController eventServiceController = new ReconEventListenerServiceController(mockEventService)
		
		when:
		def response = eventServiceController.saveFinPmtRecon("SCFREPORT", "SWETA", "004", new FinPmtReconDTO())
		
		then:
		response!= null
		
	}
	@Unroll("test saveInvPmtRecon method")
	def"test saveInvPmtRecon method"(){
		given:
		
		def ReconEventListenerService mockEventService = Mock(ReconEventListenerService)
		ReconEventListenerServiceController eventServiceController = new ReconEventListenerServiceController(mockEventService)
		
		when:
		def response = eventServiceController.saveInvPmtRecon("SCFREPORT", "SWETA", "004", new InvPmtReconDTO())
		
		then:
		response!= null
		
	}
	
	
	
	
}