package oracle.fsgbu.customer.test.web
import spock.lang.Specification;
import spock.lang.Unroll;
import java.math.BigDecimal
import spock.lang.Shared
import oracle.fsgbu.gus.persistence.provider.GlobalHolder
import oracle.fsgbu.gus.persistence.provider.RequestContext
import oracle.fsgbu.obscfcm.services.report.util.ReportingUtil
import org.junit.Test
import oracle.fsgbu.obscfcm.services.report.service.ReportCreationService;
import oracle.fsgbu.obscfcm.services.report.web.ReportCreationServiceController


class ReportCreationServiceControllerSpec extends Specification {
	
	
	
	def ReportCreationService mockReportTransactionService = Mock(ReportCreationService)
	
	@Unroll("test getRaisedInvoices method")
	def"test getRaisedInvoices method"(){
		given:
		
		def mockReportCreationService = Mock(ReportCreationService)
		ReportCreationServiceController reportTransactionController = new ReportCreationServiceController()
		reportTransactionController.reportCreationService=mockReportCreationService
		mockReportTransactionService.getRaisedInvoices("SWETA","004","25-FEB-2018","25-JUN-2018","GBP")
		
		when:
		def response = reportTransactionController.getRaisedInvoices("SCFREPORT", "SWETA","004","25-FEB-2018","25-JUN-2018","GBP")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getAgingInvoices method")
	def"test getAgingInvoices method"(){
		given:
		
		def mockReportCreationService = Mock(ReportCreationService)
		ReportCreationServiceController reportTransactionController = new ReportCreationServiceController()
		reportTransactionController.reportCreationService=mockReportCreationService
		mockReportTransactionService.getAgingInvoices("SWETA","004",0,10)
		
		when:
		def response = reportTransactionController.getAgingInvoices("SCFREPORT","SWETA","004",0,10)
		
		then:
		response!= null
		
	}
	
	@Unroll("test getOverdueAgingInvoices method")
	def"test getOverdueAgingInvoices method"(){
		given:
		
		def mockReportCreationService = Mock(ReportCreationService)
		ReportCreationServiceController reportTransactionController = new ReportCreationServiceController()
		reportTransactionController.reportCreationService=mockReportCreationService
		mockReportTransactionService.getOverdueAgingInvoices("SWETA","004")
		
		when:
		def response = reportTransactionController.getOverdueAgingInvoices("SCFREPORT","SWETA","004")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getBusinessTrend method")
	def"test getBusinessTrend method"(){
		given:
		
		def mockReportCreationService = Mock(ReportCreationService)
		ReportCreationServiceController reportTransactionController = new ReportCreationServiceController()
		reportTransactionController.reportCreationService=mockReportCreationService
		mockReportTransactionService.getBusinessTrend("SWETA","004")
		
		when:
		def response = reportTransactionController.getBusinessTrend("SCFREPORT","SWETA","004")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getPayableReceivables method")
	def"test getPayableReceivables method"(){
		given:
		
		def mockReportCreationService = Mock(ReportCreationService)
		ReportCreationServiceController reportTransactionController = new ReportCreationServiceController()
		reportTransactionController.reportCreationService=mockReportCreationService
		mockReportTransactionService.getPayableReceivables("SWETA","004")
		
		when:
		def response = reportTransactionController.getPayableReceivables("SCFREPORT","SWETA","004")
		
		then:
		response!= null
		
	}
	
	@Unroll("test getRaisedInvoiceDetails method")
	def"test getRaisedInvoiceDetails method"(){
		given:
		
		def mockReportCreationService = Mock(ReportCreationService)
		ReportCreationServiceController reportTransactionController = new ReportCreationServiceController()
		reportTransactionController.reportCreationService=mockReportCreationService
		mockReportTransactionService.getRaisedInvoiceDetails("SCFREPORT","SWETA","004","25-FEB-2018","25-JUN-2018","Y","GBP",0,10)
		
		when:
		def response = reportTransactionController.getRaisedInvoiceDetails("SCFREPORT", "SWETA","004","25-FEB-2018","25-JUN-2018","Y","GBP",0,10)
		
		then:
		response!= null
		
	}
	@Unroll("test getAgingInvoiceDetails method")
	def"test getAgingInvoiceDetails method"(){
		given:
		
		def mockReportCreationService = Mock(ReportCreationService)
		ReportCreationServiceController reportTransactionController = new ReportCreationServiceController()
		reportTransactionController.reportCreationService=mockReportCreationService
		mockReportTransactionService.getAgingInvoiceDetails("SWETA","004","25-FEB-2018","25-JUN-2018",0,0)
		
		when:
		def response = reportTransactionController.getAgingInvoiceDetails("SCFREPORT", "SWETA","004","25-FEB-2018","25-JUN-2018",0,0)
		
		then:
		response!= null
		
	}
	@Unroll("test getInvoices method")
	def"test getInvoices method"(){
		given:
		
		def mockReportCreationService = Mock(ReportCreationService)
		ReportCreationServiceController reportTransactionController = new ReportCreationServiceController()
		reportTransactionController.reportCreationService=mockReportCreationService
		mockReportTransactionService.getInvoices("SWETA","004","25-FEB-2018","25-JUN-2018","25-FEB-2018","25-JUN-2018","cp11","Y",0,10)
		
		when:
		def response = reportTransactionController.getInvoices("SCFREPORT", "SWETA","004","25-FEB-2018","25-JUN-2018","25-FEB-2018","25-JUN-2018","cp11","Y",0,10)
		
		then:
		response!= null
		
	}
	
	
	
	
}